TACHYON V4 ( V4.5 )


{
170321
Introduced new EEPROM dictionary method. Header ENTRIES from hub RAM
are copied across into EEPROM with 16 bytes allocated for each entry.
Each EEPROM entry therefore begins on a 16 byte boundary
A hash table is created with a hashed byte representing its corresponding
indexed entry in the EEPROM dictionary.

The hash table is searched for hash matches to the search string and when a match is found then
the corresponding entry from EEPROM is read into a 16 byte buffer where the strings are compared.
If there is a string match then the search returns with the address to this buffer as the result.
If the string didn't match then hash matching continues hash table etc until exhausted.

}
\ pub COMPACT.fth		PRINT" Dictionary to EEPROM compacting and search " ;
PRIVATE
$8000		== eedict
$7000		== hashtags
\ hashtags $3FF + == HB

PRIVATE
4 longs cstr
4 longs eebuf


pri HASH ( nfa -- byte )
	--- create a checksum from characters
	C@++ SWAP FROM 0 OVER FOR I C@ + NEXT
	--- and blend in 2 bits of count into msbs
	$3F AND SWAP 3 AND 6 << +
	;


pub HSEARCH ( cstr -- nfaptr ) ( 104 bytes )
	cstr 16 $FF FILL
	DUP cstr OVER C@ 1+ CMOVE
	@NAMES ( cstr names )
	FINDSTR ?DUP IF EXIT THEN
	FALSE cstr HASH ( flg hash )
	hashtags FROM $3FE
	( flg hash )
	FOR I C@ OVER =
	 --- matching hash byte
	  IF
	  --- Index entry in EEPROM and copy into eebuf
	    I hashtags - 4 << eedict + eebuf 16 ELOAD
	    --- quick compare with count + first character
	  cstr W@ eebuf W@ =
	  --- proceed with string compare on match
	    IF cstr eebuf COMPARE$
	      --- matched string
	      IF NIP eebuf SWAP LEAVE THEN
	    THEN
	  THEN
	NEXT
	DROP
	;

pri ~H	' HSEARCH 1+ ' SEARCH W! ;

{
pri CSTR!		cstr 16 $FF FILL DUP LEN$ DUP cstr C! cstr 1+ SWAP CMOVE ;
--- list out all entries that match hash tag
pub HASHLIST ( str -- )
	CSTR! cstr HASH hashtags $400 ADO I C@ OVER = IF I hashtags - 4 << eedict + $10 EE DUMP THEN LOOP
	;
}

{
pri NFA>EE ( adr -- )
	DUP C@ 5 + 1 ANDN
	( adr cnt+5A )
	1@ @EEWAIT 1 DOFOR I C@ I2C! LOOP I2C>
	--- point to next 16 byte boundary
	1@ $0F ANDN 16 + 1!
	;
}
pri ~N		DUP C@ + 5 + 1 ANDN ;

pri NFA>EE ( adr -- )
	DUP C@ 5 + 1 ANDN
\	~N ( adr cnt+ )
	1@ @EEWAIT
	ADO I C@ I2C! LOOP I2C>
	--- point to next 16 byte boundary
	1@ $0F ANDN 16 + 1!
	;


pri .NFA	<CR> DUP .WORD SPACE DUP 1+ PRINT$ 8 SPACES ;
\ pri .NFA	CR DUP .WORD SPACE DUP 1+ PRINT$ 8 SPACES 1@ .WORD ;

--- copy dictionary as 16 byte entries into EEPROM
pri DICT>EE
	@NAMES
	  BEGIN DUP C@
	  WHILE .NFA DUP NFA>EE ~N
	  REPEAT
	DROP 0 1@ E!
	;

pri DICT>HASH
	--- temp buffer clear
	$7C00 DUP $400 ERASE 1!
	@NAMES
	BEGIN
	  DUP C@
	WHILE
	  .NFA DUP HASH SWAP ~N SWAP 1@ C! 1++
	REPEAT
	DROP
	;


pri CWORDS
	CR PRINT" Dictionary in EEPROM " CR
	$8000
	BEGIN
	  DUP EC@ DUP $FF <>
	WHILE
	  OVER 1+ FROM FOR I EC@ EMIT NEXT SPACE
	16 +
	REPEAT
	2DROP
	CR
	;

pub COMPACT
	' CWORDS ' WORDS W!

	eedict $5000 $FF EFILL
	eedict 1!
	DICT>EE
	DICT>HASH
\	@NAMES NFA' *end* OVER - ERASE
	--- now use top 1k of old dictionary as
	$7C00 hashtags $3FE CMOVE
\ ' HSEARCH $88 W!
	--- REVECTOR SEACH after compacting
	~H
	--- set new hub dictionary pointer to just before hashtags
	hashtags 2- DUP W~ names W!
\	NFA' ~N (FORGET)
	;

\ +VECTOR WORDS CWORDS

{ sample of EEPROM dictionary
0000.8000:   03 45 4E 44  80 00 5E 4A  FF FF FF FF  FF FF FF FF    .END..^J........
0000.8010:   07 54 41 43  48 59 4F 4E  80 00 5A 4A  FF FF FF FF    .TACHYON..ZJ....
0000.8020:   07 43 4F 4D  50 41 43 54  80 00 2C 4A  FF FF FF FF    .COMPACT..,J....
0000.8030:   06 43 57 4F  52 44 53 88  E4 49 FF FF  FF FF FF FF    .CWORDS..I......
0000.8040:   09 44 49 43  54 3E 48 41  53 48 88 00  BA 49 FF FF    .DICT>HASH...I..
0000.8050:   07 44 49 43  54 3E 45 45  88 00 A0 49  FF FF FF FF    .DICT>EE...I....
0000.8060:   04 2E 4E 46  41 88 8E 49  FF FF FF FF  FF FF FF FF    ..NFA..I........

}
END

--- redefine these two to maintain search vector
pub TACHYON	TACHYON ~H ;
pub END		END ~H ;

