TACHYON V4 ( V4.5 )

{

V4.5 for 4.5 kernel - all DO LOOP styles are now FOR NEXT with optional FROM and BY
	IY is now FOR@
V4.4 for 4.4 kernel - uses DOFOR LOOP
V4r2 for 4.2 kernel - COGREG is removed  - use COG@ and COG! from location 1 onwards
}

IFDEF EXTEND.fth
FORGET EXTEND.fth
--- keyword used to prevent ROMs being wiped on reload of EXTEND
pub ~K ;
}
	$7610 org

pub EXTEND.fth		." Primary extensions to TACHYON V4.5 kernel  - 170814-1100" ;

{
changelog:
170730	Fixed DS3231 temperature reading and improved RTC routines - tested with DS3231 and MCP79410
170725	Hybrid RTC
170712
170612	increased clock width of I2C!? as some EEPROMs failed

}


--- lock in CLKFREQ as location 0 can be corrupted easily enough as 0 is returned as false for many operations
0 @			== CLKFREQ
CLKFREQ 1,000,000 /	== CLKMHZ


IFNDEF ALIGN
pub ALIGN ( address align -- val00  )
--- n = 0 is byte align, n = 1 is word align, n = 2 is long align )
	1- SWAP OVER + SWAP ANDN ;
}




pri @HATR			@NAMES C@++ + ;

--- make latest definition IMMEDIATE (deprecated 170425 by use of pre)
pub IMMEDIATE ( --   )		$20 @HATR SET ; IMMEDIATE
pre UNSMUDGE ( --   )		$40 @HATR CLR ;

pub PRIVATE 	( -- )		8 flags SET ; \ 8 @HATR SET ;
pub PUBLIC	( -- )		8 flags CLR ; \ 8 @HATR CLR ;

pub ANYCASE ( on/off -- )	0= 1 flags 1+ ROT BIT! ;

PRIVATE
long ulong
--- UNALIGNED LONG
pub U!	( long addr --  )
	SWAP ulong ! ulong SWAP 4 CMOVE
	;
pub U@	( addr -- long )
	ulong 4 CMOVE ulong @
	;

--- write a new value to a programmble constant  ( 1234 ' mycon WW! ) simply writes a 15-bit constant to word
pub WW! ( newcon 'oldcon -- )		SWAP 15 MASK OR SWAP W! ;

--- give the 0-based position of the highest bit set (slow)
pub >| ( mask -- bit )
	0 SWAP BEGIN ?DUP WHILE 2/ SWAP 1+ SWAP REPEAT 1-
 	;

pub LIMIT ( n min max -- n )	ROT MIN MAX ;

IFNDEF NUMBER
pub NUMBER ( str -- num )
	DUP C@ SWAP
	0 BEGIN OVER C@ WHILE OVER C@ DUP '0' '9' WITHIN IF '0' - SWAP 10 * + ELSE DROP THEN SWAP 1+ SWAP REPEAT NIP SWAP '-' = ?NEGATE
	;
}

16 bytes NUM$
pub NUM>STR ( num -- str )	<# #S #> NUM$ 16 CMOVE NUM$ ;







pub QUIET
	IF
 	  OFF ECHO ' NOOP prompt W!				--- Non-interactive mode - just accept "commands"
 	ELSE
 	  ON ECHO prompt W~
 	THEN
	;


--- simple version of CASE -- looking later at use a wordcode instead of "SWITCH@ = IF"

pub SWITCH		uswitch ! ;
pub SWITCH@		uswitch @ ;
pre CASE		' SWITCH@ [C] W, ' = [C] W, [C] IF ;
pre BREAK		' EXIT [C] W, [C] THEN ;





--- aliases
ALIAS org ORG
ALIAS byte BYTE
ALIAS word WORD
ALIAS long LONG
ALIAS bytes BYTES
\ ALIAS words WORDS
ALIAS longs LONGS
\ ALIAS NOOP OK
ALIAS CASE =[
ALIAS BREAK ]
ALIAS MASK |<
ALIAS second s

ALIAS (WAITPNE) WAITLO
ALIAS (WAITPEQ) WAITHI

ALIAS NOOP .. IMMEDIATE

ALIAS ON TRUE
ALIAS ON 0-1

PUBLIC
0	== FALSE
PRIVATE

8 longs astk
pub A@	astk @ ;
pub >A	astk DUP 4+ 28 <CMOVE astk ! ;
pub A>	A@ astk DUP 4+ SWAP 28 CMOVE ;

--- code space variables which are backed up to EEPROM along with code during BACKUP - 170701 now includes an initialization value
pre cbyte ( val -- )		[C] GRAB 				HERE >A [C] |	A> [C] == ;
pre cword ( val -- )		[C] GRAB HERE 1 AND ALLOT		HERE >A [C] ||  A> [C] == ;
pre clong ( val -- )		[C] GRAB 4 HERE 3 AND - 3 AND ALLOT	HERE >A [C] ,   A> [C] == ;


pub DS+				@org W+! ;
pre DS				[C] GRAB @org W@   SWAP @org W+! [C] == ;


pub <=	( n1 n2 -- flg  )	SWAP
pub =>	( n1 n2 -- flg )	1- > ;


pub @.	( longAddr --  )	@ U. ;

pub 2SWAP ( n1 n2 n3 n4 -- n3 n4 n1 n2 )	>A ROT ROT A> ROT ROT ;
pub 3DUP ( n1 n2 n3 -- n1 n2 n3 n1 n2 n3 )	3RD 3RD 3RD ;
pub 2OVER					4TH 4TH ;
pub MOD ( n1 mod -- rem )			U/MOD
pri DROP;					DROP ;

pub INVERT					-1 XOR ;


IFNDEF R@
pub R@						R> R> DUP >R SWAP JUMP
}

pub KB ( kb -- bytes )		10 << ;
pub MB ( mb -- bytes )		20 << ;


(			CHARACTER I/O REDIRECTION			)


pub NULLOUT			' DROP; uemit W! ;

long ~c
--- switch I/O to console but save current device key&emit
pub [CON			uemit @ ~c !
--- reset character I/O ( EMIT & KEY) back to default console
pub CON				uemit ~ ;
--- retyrn from console and restore previous device
pub CON]			~c @ uemit ! ;



\ byte lastkey
\ byte delim

PUBLIC
long boot
byte NULL$    NULL$ C~

pub COPY$ ( str1 str2 -- )	OVER LEN$ 1+ CMOVE ;

ALIAS COPY$ $!


--- Locate the first ch in the string and return else null
pub LOCATE$ ( ch str -- str )
	DUP FROM 0 SWAP LEN$ FOR OVER I C@ = IF DROP I LEAVE THEN NEXT
	NIP
	;


pub COMPARE$ ( str1 str2 -- flg \ Compare two strings for equality )
	OVER LEN$ OVER LEN$ =
	IF
	  DUP FROM LEN$
	  FOR C@++ I C@ <> IF DROP 0 LEAVE THEN NEXT
	  0<>
	ELSE
	  2DROP FALSE
	THEN
	;

ALIAS COMPARE$ $=

--- append str1 at the end of str2
pub APPEND$ ( str1 str2 -- )		DUP LEN$ + COPY$ ;
--- add a character to a string
pub +CHAR ( ch str2 -- )		DUP LEN$ + OVER 1+ C~ C! ;
pub MID$ ( str offset len -- str )	>A + A>
pub RIGHT$ ( str len -- str2 )		OVER LEN$ SWAP - + ;
pub LEFT$ ( str len -- str2 )		OVER + C~ ;



pri VAR		R> ;

pre TABLE ( <name> --  | -- addr )
	BEGIN HERE 3 AND 2 <> WHILE 1 ALLOT REPEAT
	[C] CREATE
	HERE @NAMES NFA>BFA W!
	UNSMUDGE ' VAR [C] ||
	ALLOCATED
	;



pre STRING ( str max -- )
	[C] CREATE
	HERE DUP DUP @NAMES NFA>BFA W! ALLOCATED
	CALL ( here str max )
	SWAP LEN$ MAX
	OVER + 3 + 2 ALIGN uhere W!
	' VAR SWAP W!
	;

{

" HELLO" 0  STRING A$
" SECRET" 32 STRING PASS$
A$ PRINT$
PASS$ PRINT$
" DOUBLESECRET" PASS$ $!   PASS$ PRINT$
" 007" PASS$ APPEND$    PASS$ PRINT$
PASS$ 3 RIGHT$ PRINT$

}





( *** INPUT/OUTPUT *** )


--- *** I/O and REGISTERS ***

PUBLIC
$01F0	== SPR
$01F0	== PAR
$01F1	== CNT
$01F2	== INA
$01F3	== INB
$01F4	== OUTA
$01F5	== OUTB
$01F6	== DIRA
$01F7	== DIRB
$01F8	== CTRA
$01F9	== CTRB
$01FA	== FRQA
$01FB	== FRQB
$01FC	== PHSA
$01FD	== PHSB
$01FE	== VCFG
$01FF	== VSCL

\ pub SPR!	SPR + COG! ;
IFNDEF P@
pub P@		INA COG@ ;

pub P!		OUTA COG! ;
}

pub CNT@		CNT COG@ ;
pub =CNT ( addr -- )	CNT@ SWAP ! ;
pub ELAPSED?  ( cycles var -- flg )	@ CNT@ SWAP - SWAP > ;

IFNDEF PIN!
pub PIN! ( bit pin -- )		MASK
}
pub OUT				DUP OUTPUTS SWAP SHROUT 2DROP ;

IFNDEF PIN@
pub PIN@ ( pin -- bit )
		MASK
pub IN		INA COG@ AND 0<> ;
}

pub AVG ( val var -- avg )
	DUP @ 2/ 2/ ROT SWAP -
	OVER +! @ 2/ 2/
	;



PRIVATE
16 longs locals
locals 4 +	== @x2
locals 8 +	== @x3
locals 12 +	== @x4

pri @X		4* locals + ;
pub X1		locals @ ;
pub X2		@x2 @ ;
pub X3		@x3 @ ;
pub X4		@x4 @ ;

--- pop the n top stack elements to the local space, TOS => X1, TOS+1 => X2 ..
pub LOCAL ( <data> n --  )
	DUP 4* ( <data> n bytes )
	locals 2DUP + ROT <CMOVE
	FOR I @X ! NEXT
	;

--- pop and release emove n elements from locals, of no longer used )
pub RELEASE ( n -- )		DUP @X locals ROT 4* $40 SWAP - CMOVE ;



\ locals $40 ERASE			\ Clean out the locals (easier for debugging)


pub >W ( long -- word )				$FFFF AND ;
--- mask off bits -- $1234 5 BITS -> $14
\ pub BITS ( n bits -- )				MASK 1- AND ;

pub L>W ( long - loword hiword ) 		DUP $FFFF AND SWAP 8>> 8>> ;
pub W>B ( word - lobyte hibyte ) 		DUP >B SWAP 8>> >B ;

pub B>W	( lobyte hibyte -- word )		8<< OR ;
pub B>L ( lobyte byte2 byte3 byte4 -- long )	B>W >A B>W A>
pub W>L ( loword hiword -- long )		8<< 8<< OR ;

\ Increment and decrement variables at address
pub ++ ( longAddr -- )				1 SWAP +! ;
pub -- ( longAddr -- )				-1 SWAP +! ;

pub W++ ( wordAddr -- )				1 SWAP W+! ;
pub W-- ( wordAddr -- )				-1 SWAP W+! ;

pub C++ ( byteAddr -- )				1 SWAP C+! ;
pub C-- ( byteAddr -- )				-1 SWAP C+! ;

--- Clear and set variable at address
\ pub ~   ( longAddr -- )			0 SWAP ! ;
pub ~~  ( longAddr -- )				-1 SWAP ! ;
\ pub W~  ( wordAddr -- )			0 SWAP W! ;
pub W~~ ( wordAddr -- )				-1 SWAP W! ;
\ pub C~  ( byteAddr -- )			0 SWAP C! ;
pub C~~ ( byteAddr -- )				-1 SWAP C! ;



PUBLIC
--- handy variables
IFNDEF 1!
1 longs @1
pub 1!	( long -- )	@1 ! ;
pub 1@	( -- long )	@1 @ ;
pub 1++			@1 ++ ;
}
1 longs @2
pub 2!			@2 ! ;
pub 2@			@2 @ ;
pub 2++			@2 ++ ;
1 longs @3
pub 3!			@3 ! ;
pub 3@			@3 @ ;
pub 3++			@3 ++ ;



pub LONGFILL ( addr cnt longval --  )		3RD ! OVER 4+ SWAP 1- 4* CMOVE ;


long seed

\ COMMENT: RND ( -- n )  Generate a 32-bit pseudo-random number enhanced with the system counter
pub RND ( -- n    \ 32 bit pseudo random number enhanced with system counter )
 	seed @ DUP 13 << XOR
 	DUP 17 >> XOR
 	DUP 5 << XOR
 	CNT@ * DUP seed !			\ randomize the result as well using the system CNT
 	;







--- Find the next available cog that's free to run a task - ready and in IDLE
pub TASK? ( -- task )
	8 BEGIN 1- DUP TASK @ $1.0000 = OVER 0< OR UNTIL
	;


pub RUN ( pfa cog -- | USAGE: ' MYTASK TASK? RUN )
 	DUP 0 7 WITHIN IF TASK W! ELSE CR PRINT" Error - cog out of range " THEN
 	;
\ Set starting address of a task's registers
pub TASKREGS ( addr -- )		8 COG! ;

pub COGINIT ( code pars cog -- ret ) 	 SWAP 16 << OR SWAP 2 << OR pCOGINIT ;





















long radix			\ 4 level deep radix stack
pub RADIX ( base -- \ Set number base )
 	?DUP IF base C! THEN
 	;
pub >RADIX ( base -- \ backup and set number base )
 	radix @ 8<< base C@ + radix ! RADIX
 	;
pub RADIX> ( -- \ restore previous radix )
 	radix @ DUP RADIX 8>> radix !
 	;


--- *** NUMBER PRINT FORMATTING ***



( NUMBER PRINT FORMATING )
\ Check and insert separators (subfunction of .NUM)

pri (SEP)
	 I IF 1 REG C@ $40 AND IF \ 0EXIT
 	 base C@ 10 =
	   IF I 3 MOD 0= IF $2C HOLD THEN				\ Process decimal numbers with a decimal point
	   ELSE I 4 MOD 0= IF $5F HOLD THEN				\ or else use underscore for a separator
	   THEN
	 THEN
	 THEN
	;

{ Usage: - testing
	WORD sep
pri InitSep ( digits base -- digits base )
	DUP #10 = IF $2C03 sep W! THEN
	DUP ":" = IF DROP #10 $3A02 sep W! THEN
	DUP "/" = IF DROP #10 $2F02 sep W! THEN
}

pri (.NUM) ( n len -- )
	<# $1F AND ?DUP 						--- If there is a count (b4..b0) specified then lock to that
	  IF DUP 31 = IF 1+ THEN FOR (SEP) # NEXT		--- fixed width also 31(max) indicates 32 binary digits
	  ELSE 32 FOR (SEP) # DUP 0= IF LEAVE THEN NEXT	--- variable width, don't print lz
	  THEN
	0 REG C@ ?DUP IF HOLD THEN
	#> PRINT$
	;
{ HELP PRINTNUM ( number format -- )
Format the number as to it's base, the number of digits, whether it's signed, and should it have separators
Thi`s is a very versatile print number routine and can be incorporated into other print words
A single word is passed with options:
b07..00 = base
b12..08 = digits
b13	 = use spaces in place of leading zeros
b14	= force separators (decimals have a , every 3 places while others have a _ every 4 places)
b15	= force sign (always + or - depending upon the number)
Usage:
 	$C00A will force separators, sign, no leading zeros (0 digits), and a base of 10
i.e.	0 @ $C00A .NUM +80,000,000 ok
	$4810 will force separators, no sign, and 8 digits with a base of 16
i.e.	0 @ $4810 .NUM 04C4_B400 ok
}
pub PRINTNUM  ( number sign+sep+6BitForDigits+8BitForBase -- \ format number according to format spec )
	W>B SWAP
\	InitSep
	>RADIX
	0 REG C~							--- clear prefix for sign
	DUP 1 REG C!							--- save sign+sep+digits byte
 	DUP $20 AND IF 4 flags SET THEN					--- select leading zero suppression
	DUP $80 AND							--- signed?
 	  IF OVER 0<
 	    IF '-' ELSE '+' THEN  0 REG C!
 	  THEN
 	(.NUM)
	RADIX>
	;

--- deprecated name - prefer PRINTNUM for readability
\ ALIAS PRINTNUM .NUM


pub .DP ( dblnum decimals --- )
 	DUP >A 1 SWAP FOR #10 * NEXT UM/MOD64
 	<D> $400A PRINTNUM
 	A> ?DUP IF '.' EMIT 8<< $0A + PRINTNUM THEN
	;



pub D.		<D> PRINT ;

--- Print a formatted decimal number with 4 digits
pub .DECX ( number --  )	 	4
--- Print a formatted decimal number with at least n digits
pub PRINTDEC ( number n -- )		8<< $400A OR PRINTNUM	;

ALIAS PRINTDEC .DEC

pub U.R ( n places --- )	8<< $200A + PRINTNUM ;

pri .EMIT		'.' EMIT ;
pri ~1			DUP 24 >> 10 PRINTNUM 8 << ;
--- Print an IP style formatted number i.e. &192.168.0.16
pub PRINT&		'&' EMIT ~1 .EMIT ~1 .EMIT ~1 .EMIT ~1 DROP ;




--- ---






--- *** ANSI TERMINAL SUPPORT ***


PUBLIC
0	== black
1	== red
2	== green
3	== yellow
4	== blue
5	== magenta
6	== cyan
7	== white

long _ansi
pri AEMIT			_ansi @ IF EMIT ELSE DROP THEN ;
pub ESC ( ch -- )		$1B AEMIT AEMIT ;

pub HOME			'H'
pri ESCB ( ch -- )		'[' ESC AEMIT ;

pub PEN ( col -- )		7 AND '3'
pri COL ( col fg/bg -- )	ESCB '0' + AEMIT 'm' AEMIT ;
pub PAPER ( col -- )		'4' COL ;

{ optional - normally not supported
pri ESCH ( ch -- )		"#" ESC EMIT ;
pub DHT				"3" ESCH ;
pub DHB				"4" ESCH ;
pub NARROW			"5" ESCH ;
pub WIDE			"6" ESCH ;
}

pri CUR ( cmd n -- )		'[' ESC SWAP
pri .PAR			SWAP #10 PRINTNUM AEMIT ;
pub XY ( x y -- )		';' SWAP CUR 'H' .PAR ;


pub CLS				$0C AEMIT HOME
--- Erase the screen from the current location
pub ERSCN			'2' ESCB 'J' AEMIT ;
--- Erase the current line
pub ERLINE			'2' ESCB 'K' AEMIT ;


pub CURSOR ( on/off -- )	'?' ESCB 25 . IF 'h' ELSE 'l' THEN AEMIT ;

pub PLAIN			'0'
pri ATR ( ch -- )		ESCB 'm' AEMIT ;
pub REVERSE			'7' ATR ;
pub BOLD			'1' ATR ;

pub MARGINS ( top bottom -- )	'[' ESC SWAP ':' .PAR 'r' .PAR ;

--- res = 1B5B.306E
pub ?ANSI ( --  )		_ansi ~~ '5' ESCB 'n' EMIT 30 ms 0 4 FOR 8 << KEY OR NEXT _ansi ! ;


{
pri CSI ( n1 n2 -- )		$C2 EMIT $9B EMIT 2 FOR ?DUP IF EMIT THEN NEXT ;
pri CNUM			0 BEGIN WKEY DUP $30 $39 WITHIN WHILE $30 - SWAP 10 * + REPEAT DROP ;
pub XY@				$6E $36 CSI 8 EMIT SPACE 8 EMIT WKEY DROP WKEY DROP CNUM CNUM SWAP ;

--- list all color combos
8 for cr i pen 8 for i paper print" hello "   next  plain next
}



pub .HEAD$	BOLD PRINT" *** " PRINT$ PRINT"  ***" PLAIN ;

--- ---






--- table of up to 16 initialization vectors
TABLE inits		 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 || 0 ||
pri ~I			inits FROM 2 BY 16 ;
pub +INIT		~I FOR I W@ 0= IF DUP I W@ <> IF DUP I W! THEN LEAVE THEN NEXT DROP ;
pub -INIT ( cfa -- )	~I FOR I W@ OVER = IF 0 I W! LEAVE THEN NEXT DROP ;
--- execute valid inits
pub INIT		~I FOR I W@ ?DUP IF CALL THEN NEXT ;

--- Clear out invalid inits after a FORGET etc
pri ?INITS		~I FOR I W@ HERE > IF 0 I W! THEN NEXT ;

pub lsini
	CR " INITS" .HEAD$
	red PEN
	inits FROM 2 BY 16 FOR
	  I W@ ?DUP IF
	    CR PRINT" INIT#" I inits - 2/ . SPACE DUP .WORD SPACE CFA>NFA ?DUP
	      IF 1+ PRINT$ THEN
	  THEN
	NEXT
	PLAIN
	;


pri (STRIP) ( nameptr -- nameptr+ )
	CR ." Removing " DUP 1+ PRINT$			\ Ok, strip it out
	DUP DUP C@ 5 + 1 ANDN ( nameptr cnt )
	DUP >A @NAMES +
	@NAMES ROT SWAP - ( newnames len )
	@NAMES ROT ROT <CMOVE
	A> DUP names W+! +   	 			\ add to names pointer and to current pointer for next word
 	;

--- Strip a single header from the dictionary
pre STRIP			[C] NFA' [C] GRAB (STRIP) DROP;



pre FORGET ( <name> -- )
 	[C] NFA'
--- find the NFA of the word
pub (FORGET) ( nfa -- )
	?DUP
 	IF
	  NFA>BFA DUP W@ $200 BUFFERS WITHIN
	   IF
	     DUP W@ uhere W!
	     2+ names W!
              HERE uthere W!
	     ' EXIT HERE W!
	   ELSE
	     DROP PRINT"  Unforgettable word"
	   THEN
	ELSE
          SPACE @WORD PRINT$ PRINT"  not found "
	THEN
	?INITS
	;

--- REVECTOR oldcode newcode  - Replaces first code of oldcode with jump to newcode
pre REVECTOR			1
pri ~v				[C] ' [C] ' [C] GRAB ROT + SWAP W! ;
pre +VECTOR			0 ~v ;




--- create a dynamic variable
pub baudcnt	16 REG ;


pub SERBAUD ( baud -- )		CLKFREQ SWAP / DUP baudcnt W! 2/ 200 - baudcnt 2+ W! ;



9600 SERBAUD


pri TXSER
	baudcnt W@ DELTA
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT SHROUT
	WAITCNT SHROUT WAITCNT
	DROP
	;
pub SEROUT ( data pin -- )
	MASK H SWAP 2*
	TXSER OUTSET
	;

pub ISEROUT ( data pin -- )
	MASK L SWAP 2* $7FF XOR
	TXSER OUTCLR
	;


--- redirect character output to seleect serial channel using SEROUT
pri ~S			0 SEROUT ;
pub SERIAL ( pin -- )	' ~S C! ' ~S uemit W! ;



--- redirect character output to seleect serial channel using SEROUT
pri ~S			0 ISEROUT ;
pub ISERIAL ( pin -- )	' ~S C! ' ~S uemit W! ;



--- receive 8 bit serial data from pin at rate set with SERBAUD, blocks until character received
pub SERIN ( pin -- data  )
	MASK DUP 4 COG!					--- [5.8us]
 	baudcnt 2+ W@					--- [4.8us] serup half-bit delay with high speed compensation
	WAITHI						--- [0.4us+] make sure we are not detecting the last data bit - wait for stop
	WAITLO DELTA 					--- wait for start bit then wait haf bit time
	 0							--- [5.4us] setup pin mask and inital data to SHRINP 8 data
	baudcnt W@ DELTA 					--- delay to sample 1 bit later in 1st data bit
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP WAITCNT
	SHRINP							--- last data bit
	NIP #24 >>						--- right justify 8-bit data
	;


(	*** COUNTERS ***	 )

--- latch the selected counter A or B (0 or 1)
byte _ctr

--- Select the desired target CTR A or B before use
pub A				_ctr C~ ;
pub B				1 _ctr C! ;

pri CTR ( -- addr )		CTRA
pri ~C				_ctr C@ 1 AND + ;
pri CTR@ ( -- val )		CTR COG@ ;

--- Set NCO counter mode
pub NCO				4
--- Writes to the CTRMODE field of the current CTR channel without disturbing the other bits of the counter
pub CTRMODE ( n -- )		26 SHL	CTR@ $7C000000 ANDN OR
pri CTR! ( val -- )		CTR COG! ;

--- Change counter mode to differential
pub DIFF			CTR@ 1 26 << OR CTR! ;

--- SetDuty counter mode
pub DUTY			6 CTRMODE ;
pub PLL				2 CTRMODE ;
pub PLLDIV ( n -- )		#23 SHL CTR@ 7 #23 SHL ANDN OR CTR! ;

--- Set the APIN of the current CTR
pub APIN ( pin -- )		CTR@ $1F ANDN OR CTR! ;
--- Set the BPIN of the current CTR
pub BPIN ( pin -- )		9 << CTR@ $1F 9 << ANDN OR CTR! ;


--- Write an 8-bit value to the pin as a duty cycle - filter output for a voltage

pub DAC! ( byte pin -- )	DUP LOW APIN DUTY #24 SHL
--- Set the value of the current FRQ either A or B
pub FRQ ( n --  )		FRQA ~C COG! ;

-1 2/ CLKFREQ 10,000 / 2/ /	== HZCON


pub MHZ ( MHz -- )		#1000 *
pub KHZ ( khz -- )		#1000 *
pub HZ ( hz -- )		NCO HZCON #10000 */ FRQ	CTR@ $1F AND LOW ;
pub MUTE			CTR@ $1F AND FLOAT OFF CTRMODE ;

--- blinky using counters - also useful for setting up a pin quickly - then use HZ etc
pub BLINK ( pin -- )		APIN 2 HZ ;


---			*** I2C DRIVER ***

PUBLIC
\ 28		== *SCL
\ 29		== *SDA
--- Programmable pin constants
pub *SCL	28 ;
pub *SDA	29 ;

1		== @SCK
@SCK 1 +	== @MOSI
@SCK 2 +	== @MISO
@SCK 3 +	== @CE
@SCK 4 +	== @CNT

15		== @SCL
10		== @SPISCK


pri MASK? ( n -- mask )		>B DUP 32 U< IF MASK ELSE DROP 0 THEN ;

--- Set the SPI pins using a long as 4 octets = &ce.miso.mosi.clk  as this allows passing a single long
pub SPIPINS ( &ce.miso.mosi.clk --- )
 	@SPISCK
pub SETPINS ( &pins dst -- )  ( ~190us)
 	FROM
	--- set count
 	4 FOR
 	 --- make sck and mosi outputs
 	 DUP MASK? FOR@ 2 > IF L THEN
 	  I COG! 8>>
 	NEXT
 	--- 160506 make CE a high output
    @SPISCK 3 + COG@ OUTSET
 	DROP
 	;

pub MODPINS  	@SCK SETPINS ;


(			*** POPULAR I/O DEVICES ***			)


--- PING MODULE ---

pub PING ( trig echo -- us )
	--- setup WAITPxx mask
	MASK 4 COG!
	--- 10us trigger (dummy cycles)
	DUP HIGH 10 us LOW
	--- detect high period
	WAITHI WAITLO
	--- calculate high period
	1 COG@ 2 COG@ -
	CLKMHZ / /							--- convert cycles to us
	;

--- return with the range in mm using trig pin and echo pin
pub DISTANCE ( trig echo -- distance.mm )	PING 170145 1,000,000 */  ;



--- DHT22 HUMIDITY AND TEMPERATURE ---

PRIVATE
byte htck									--- checksum
word htref
word rh
word htsav								--- timing reference and last valid readings
\ long dt

pri DHTBIT ( -- cnt )
	WAITHI								--- wait for it to go high
	1 COG@								--- get captured CNT
	WAITLO								--- until it goes low
	1 COG@ SWAP -							--- calculate timing of high period
	;

pri DHTBYTE ( -- byte )
	0 8 FOR 2* DHTBIT htref W@ > 1 AND OR NEXT
	DUP htck C+!
	;

--- Test for a DHT device on this line by pulsing low then checking for a hi-lo
pub DHT? ( pin -- flg )  DUP PIN@ OVER LOW 1 ms OVER FLOAT 80 us SWAP PIN@ NOT AND ;

{ HELP DHT@ ( pin -- rh temp | -1 )
Read the relative humidity and temperature from the DHT22 (and DHT11)
Return with rh and temp in Celsius
If an error occurred in the checksum then return last valid reading
If the sensor is polled more than once every 2 seconds then use last valid readings
Typical acquisition time ~6ms
}
pub DHT ( pin -- rh temp )
\	dt COUNT?
\ 	IF
\ 	  2000 dt !
 	  htck C~
	  DUP MASK 4 COG!
	  DUP LOW 20 ms DUP FLOAT						--- Generate reset pulse (>18ms for DHT11)
	  DHTBIT DROP								--- wait for start of response
	  DHTBIT 3 / 2* htref W!						--- use start bit as reference
	  DHTBYTE 8<< DHTBYTE +							--- 2 bytes humidity reading
	  DHTBYTE 8<< DHTBYTE +							--- 2 bytes temperature reading
	  htck C@ DHTBYTE =							--- if checksum does not match then use last reading
 	    IF htsav W! rh W! ELSE 2DROP THEN					--- latch readings if valid
\ 	THEN
	DROP rh W@ htsav W@							--- return with latest valid result
	;

--- WS2812 RGB LED SUPPORT

--- 170117 update - use LEDPIN to set LED pin parameter seperately
PRIVATE
long brg

pub LEDPIN ( pin# -- )				MASK L 5 COG! ;

{
byte intensity
pri modulate		brg 3 ADO I C@ intensity C@ * brg C! LOOP ;
}

PRIVATE

TABLE ansi	0 , $00.FF.00 , $00.00.FF , $00.FF.FF , $FF.00.00 , $FF.FF.00 , $FF.00.FF , $FF.FF.FF ,

pub LED ( rrggbb -- )
	--- check for 0..7 as ANSI VT100 color codes
	DUP 8 <
	IF 4* ansi + @ brg !
	ELSE
	  DUP 16 >> brg 1+ C! DUP 8 >> brg C! brg 2+ C!
	THEN
	brg 1
--- Output an rgb array for the number of leds (3 bytes/led) on the selected pin
pub LEDS ( array leds -- )			3 * [WS2812] RUNMOD ;

{
--- Example of outputting an array of 100 LEDs
( 1452 $2A86 ok )   300 bytes matrix
( 1453 $2A86 ok )   22 LEDPIN LAP matrix 100 LEDS LAP .LAP  243072 cycles at 96000000Hz  or 2.532ms
( 1454 $2A86 ok )

--- running in the background
300 bytes matrix
pub MYLEDS   22 LEDPIN BEGIN matrix 100 LEDS AGAIN ;
' MYLEDS 3 RUN
}



pub RECLAIM
	$8000 ( limit -- )
	@NAMES DUP >A
	BEGIN
  	  DUP C@++ + ( nameptr atrptr )
  	  C@ 8 AND							--- Test to see if this is private
  	    IF (STRIP) ELSE C@++ + 4+ 1 ANDN THEN				--- strip header or proceed to next
	  2DUP U<
 	  OVER C@ 0= OR
	UNTIL
	2DROP CR ." Reclaimed " @NAMES A@ - DUP 0 PRINTDEC ."  bytes "	--- Report results
	A> SWAP ?DUP IF ERASE ELSE DROP THEN				--- Clear the reclaimed area (not needed)
	;



---			*** I2C DRIVER ***

byte i2cflg

--- wait but timeout while busy
pub ?I2C	i2cflg C@ IF 1500 BEGIN 1- i2cflg C@ 0= OVER 0= OR UNTIL DROP i2cflg C~  THEN ;



pub <I2C
	?I2C
pub <I2C>	--- restart without checking busy
	*SDA FLOAT *SCL HIGH
	--- setup mask for CLOCK instruction
 	*SCL MASK @SCL COG!
	*SDA LOW 1 i2cflg C! *SCL LOW
	;


{ I2C STOP CONDITION also releases I2C lines
 SCL XX-------==
 SDA XX___----==
}
pub I2C>
	--- pull SDA high from low while clock high
	*SDA LOW *SCL HIGH ( 1 DROP ) *SDA HIGH
	--- free up I2C lines
 	*SDA FLOAT *SCL FLOAT
 	i2cflg C~						--- i2c bus free
	;

ALIAS <I2C I2CSTART
ALIAS I2C> I2CSTOP


--- Write a byte to the I2C bus and return with the ack flag
--- This routine runs at an I2C speed of 400kHz
--- 38.4us
--- write a byte to the I2C bus and return with the ack  0=ack	)
pub I2C!? ( data -- flg )
	#24 REV
	--- data masks
	*SDA DUP HIGH MASK SWAP
	8 FOR SHROUT  CLOCK CLOCK  NEXT
	DROP DUP INPUTS						--- Float SDA
	CLOCK IN 0<> CLOCK					--- ack clock
	;


{
--- write a byte to the I2C bus and return with the ack  0=ack	)
pub I2C!? ( data -- flg )
	24 <<
	--- data masks
	*SDA MASK SWAP
	8 FOR CLKOUT NEXT
	--- Float SDA for ACK
	DROP DUP INPUTS CLOCK IN 0<> CLOCK
	;
}
pub I2C!	I2C!? DROP ;

pub ackI2C@ 	0
--- 25.5us @96MHz
--- Fetch a byte from the I2C bus - mirror ack signal 0 in = 0 out
pub I2C@	( ack -- data  )
	*SDA DUP FLOAT MASK 0  ( ack iomask dat )
	  8 FOR CLKIN CLOCK NEXT
	--- make SDA an high output
	OVER OUTSET
	--- clock out ack bit
	-ROT SWAP CLKOUT DROP CLOCK INPUTS
 	;

pub nakI2C@	TRUE I2C@ ;

--- 16.33us @96MHz
pub FI2C@ ( -- byte )
	*SDA DUP FLOAT MASK 0  ( iomask dat )
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  CLKIN CLOCK
	  OVER OUTCLR
	CLOCK CLOCK SWAP INPUTS
	;

--- Control the speed of the I2C bus
--- The CLOCK instruction can be slowed down at 16 COG!
pub I2CFAST	0
pri ~D		16 COG! ;
pub I2C100	CLKMHZ ~D ;
pub I2C400	CLKMHZ 12 / ~D ;

I2C400


( EEPROM )
byte eeadr
--- EEPROM addressing - select default device and write 16-bit address
--- Updated to take an address >64K and automatically select the next device

--- use full 32-bit address to select a device and issue the lower 16-bit address to it
pub @EE ( addr -- flg )  ( 17408 cycles at 96000000Hz  or 181.333us )
	I2CFAST
	--- wait if busy then terminate any I2C activity
	?I2C I2C>
	--- calculate the device address with base $A0 (8-bits)
	L>W 2* $A0 + DUP eeadr C!
	--- send the device address
	<I2C> I2C!?
	--- send the 16-bit memory address (msb)
	OVER 8>> I2C!?
	--- send the lsb and return with a combined ack flag.
	OR SWAP I2C!? OR
	;

--- revision 140602 - Added timeout loop counter to prevent hanging
pub @EEWAIT ( adr --  ) ( 180.4us timeout )
---	timeout   cnt  read ee rdy? cnt0  either until
  	40 BEGIN 1- OVER @EE 0= OVER 0= OR UNTIL 2DROP
	;

--- Switch EEPROM to read mode
pub EERD ( -- flg  ) ( 56.2us )
---	Restart and issue device read
	<I2C> eeadr C@ 1+ I2C!?
	;

--- read last byte [no ack] and stop
pri ENDRD
 	nakI2C@ DROP I2C>
 	;

--- Store byte to EEPROM
pub EC! ( byte addr -- ) ( 234us )
 	@EEWAIT I2C! I2C>
 	;

--- Fetch byte from EEPROM
pub EC@ ( addr -- byte )
 	@EEWAIT EERD DROP
 	nakI2C@ I2C>
 	;

pub EW! ( word addr -- ) ( 273us )
 	@EEWAIT W>B SWAP I2C! I2C! I2C>
  	;

--- Fetch a word from EEPROM
pub EW@ ( addr -- word )
 	@EEWAIT EERD DROP
 	ackI2C@ nakI2C@ B>W I2C>
	;

--- Fetch a long from EEPROM
pub E@ ( addr -- long )
 	@EEWAIT EERD DROP
 	ackI2C@ ackI2C@ B>W ackI2C@ nakI2C@ B>W I2C>
 	W>L
 	;

pub E! ( long addr -- ) ( 356us )
 	@EEWAIT L>W SWAP W>B SWAP I2C! I2C!
 	W>B SWAP I2C! I2C! I2C>
  	;

pub ESAVEB ( ram eeprom cnt -- \ byte by byte method - safer for non-page aligned addresses and counts )
	SWAP FROM
 	FOR C@++ I EC! 5 ms SPINNER NEXT DROP
 	;



pub EEPROM			29 28
pub I2CPINS ( sda scl -- )	' *SCL WW! ' *SDA WW! ;

--- calculate EEPROM programming page size basd on memory size

0 $8000 E! $8000 E@ 0 E@ <> IF 128 ELSE 64 THEN		== ep


--- Save a block of RAM to EEPROM. Will backup 32K to EEPROM in 4.963 seconds

pub ESAVE ( ram eeprom cnt -- )
	--- round up to nearest 64 byte page --- use ram address for loop index, leave eeprom addr on stack
	ep ALIGN ROT FROM ep BY ep /
	FOR
   	( eeprom )
	  --- Wait for the EEPROM write cycle
   	  DUP @EEWAIT
	  EERD DROP 0
	  I FROM ep
 	    FOR FI2C@ I C@ <> OR DUP IF LEAVE THEN NEXT
	   nakI2C@ DROP I2C>
	   IF
	     --- Write 64 bytes and check acks
 	     DUP @EE DROP 0 I FROM ep FOR I C@ I2C!? OR NEXT I2C>
	     IF $0D EMIT ." FAIL @" DUP .WORD THEN
	   THEN
	   --- console spinner to show it's busy
    	   SPINNER  ep +
  	NEXT
	DROP
 	;

--- Load a block of EEPROM to RAM
pub ELOAD ( eeprom ram cnt -- )
	ROT @EEWAIT EERD DROP				--- select the device - might have to wait
	SWAP FROM
	  FOR FI2C@ I C! NEXT				--- sequential reading from EEPROM into RAM
	ENDRD						--- signal last byte read
 	;

pub EFILL ( src cnt ch -- )				--- fill EEPROM from src address with cnt times byte ch)
	ROT FROM
	ep BY
	SWAP ep /
 	FOR (  ch )
	  I @EEWAIT					--- write address but wait if necessary
	  ep FOR DUP I2C! NEXT I2C>			--- store one page's worth of data to EEPROM and write
	NEXT DROP
	;


--- copy cnt bytes from eesrc to eedst )
pub ECOPY ( eesrc eedst cnt -- )
	SWAP FROM ep BY ep /
	FOR
	  DUP BUFFERS ep ELOAD
	  BUFFERS I ep ESAVE
	ep +
	NEXT DROP
	;

{
: ECHECK
	0 $8000 ADO
	0 I 64 ADO I C@ I EC@ <> OR LOOP
	IF
	I 64 ADO
	I $3F AND 0= IF CR I .LONG SPACE THEN
	I $0F AND 0= IF SPACE THEN
	I C@ I EC@ <> IF I .HEX ELSE ." ." THEN
	LOOP
	THEN
	64 +LOOP
	;

}



pub CONBAUD ( baud -- \ Set TACHYON's baudrate for next reboot  )
	CLKFREQ SWAP / DUP $28 ! $28 E!
	;


--- Only backup if there are no errors recorded
pub ?BACKUP
 	errors W@ NOT 0EXIT
	--- Backup the current Tachyon Forth session
pub BACKUP
	EEPROM
	PRINT" BACKUP "
	0 0 $7400 ESAVE
	;

IFNDEF DUMP:
pri DUMP:	R> SETDUMP ;
}

--- Select EEPROM device for DUMP command access
--- Usage: 0 $100 EE DUMP
pub EE		DUMP: EC@ EW@ E@ ;



pre AUTORUN
	[C] ' [C] GRAB DUP uauto W! uauto EW!
 	;









(	*** RTC and TIMERS ***		)




( REAL-TIME CLOCK )

{ HELP TIMER ( <name> -- )
create a timer variable (replaces DOUBLE)
ms(4), alarm/mode(2), link(2), tid(1), nu(1), nu(2)
}
pre TIMER			4 ALIGNORG @org W@ 16 ERASE 4 [C] longs ;


\ Define variables used by the background timer cog

PUBLIC
1 cword timers		--- link to timers - set to 1 as last
PRIVATE
byte tid

CLKFREQ #1000 / == ttint				\ define the timing constant ( writable constant )

( Background timer API )

{ New timer methods that allow modules to link their timers into the background countdown process
add a timer to the list of timers to countdown,
addr points to 2 longs, first is the timer, second is both the alarm word and the link word
last timer has a link word of 0
link->TIMER3->TIMER2->TIMER1->0
}
pub TIMEOUT ( ms addr -- \ Set the timeout period in ms for this timer - link and init if not already set )
 	SWAP OVER ! --- set it and link it if it has not been linked yet
pri +TIMER ( addr -- )
	--- discard and ignore if already linked
 	DUP 8 + C@ tid C@ = IF DROP EXIT THEN
	--- set tid
 	tid C@ OVER 8 + C!
	--- link in new timer (first one is set to 1 )
   	timers W@ OVER 6 + W!
	--- save latest in timers
 	timers W!
	;

pub COUNTUP ( addr -- \ countup timer mode )
 	1 SWAP
	DUP +TIMER
pub ALARM ( pfa addr -- \ Set an alarm action to perform once timeout occurs )
	4+ W!
	;
pub TIMEOUT? ( addr -- flg \ check if this timer has timed out )
	@ 0=
	;

TIMER wdt
pub WATCHDOG ( ms -- )		wdt TIMEOUT ;





1 longs	runtime

4 bytes @time
4 bytes @date
2 bytes @day

10 bytes rtcbuf

pri rtcbuf@	rtcbuf + C@ ;
pri rtcbuf!	rtcbuf + C! ;



--- I2C RTC DRIVERS ---

--- RTC I2C ADDRESS psuedo constant
pub @rtc		0 ;

--- selects type of I2C RTC chip used
--- DS3231 is fairly generic f
pub DS3231		$D0
pri =rtc		' @rtc WW! ;
pub MCP79410	$DE =rtc ;
pub RTCEE		$AE =rtc ;		--- EEPROM of MCP79410 - access with RTC@/RTC!
pub NORTC		0 =rtc ;


--- Start and address RTC device
pri <RTC			I2C400 <I2C @rtc I2C! ;
--- restart and read RTC device
pri <RTC>			<I2C> @rtc 1+ I2C! ;

--- Read first 8 timekeeping bytes of RTC into rtcbuf
pub RDRTC
	@rtc 0EXIT <RTC 0 I2C! <RTC>
	  rtcbuf FROM 8 FOR ackI2C@ I C! NEXT nakI2C@ DROP I2C>
	;

--- Write first 8 timekeeping bytes of RTC from rtcbuf
pub WRRTC
	@rtc 0EXIT <RTC 0 I2C!
	  rtcbuf FROM 8 FOR I C@ I2C! NEXT I2C>
	;

pub RTC! ( byte addr -- )	<RTC I2C! I2C! I2C> ;

pub RTC@ ( addr -- byte )	<RTC I2C! <RTC> nakI2C@ I2C> ;
\ pub RTCW@ 					DUP RTC@ 8<< SWAP 1+ RTC@ + ;

--- Select RTC as a DUMP device - byte method only
pub RTC						DUMP: RTC@ RTC@ RTC@ ;

pub BCD>DEC ( bcd -- dec )	DUP >N SWAP 4 >> 10 * + ;

pub DEC>BCD ( dec -- bcd )	10 U/MOD 4 SHL + ;

--- read HHMMSS time in decimal format
pub TIME@ ( -- #hhmmss )
    @time @ 1000 /
    60 U/MOD ( sec x ) 60 U/MOD ( sec mins hrs ) 24 MOD 10000 * SWAP 100 * + +
    ;

--- read international date in decimal format
pub DATE@ ( -- #yymmdd )
       @date @ DUP 0= IF DROP 010101 THEN
    ;

pub TIME! ( hh.mm.ss -- )
    0
--- write time/date in decimal format where d/t = 4 for date
pub DT! ( hh.mm.ss|yy.mm.dd d/t -- )
    @rtc
    IF
      2DUP
      4 AND 2DUP @time + !
      RDRTC SWAP
      --- ensure some RTC devices have a 'RUN' bit set otherwised it is ignored.
      100 U/MOD SWAP DEC>BCD $80 OR 3RD rtcbuf!
      100 U/MOD SWAP DEC>BCD 3RD 1+ rtcbuf!
      DEC>BCD SWAP 2+ rtcbuf!
      WRRTC
    THEN
--- write soft time/date in decimal format where d/t = 4 for date
pub SDT! ( hh.mm.ss|yy.mm.dd d/t -- )
	4 AND DUP NOT
	  IF DROP 100 U/MOD 100 U/MOD 60 * SWAP + 60 * + 1000 * 0 THEN
	@time + !  --- time stored in milliseconds
	;

pub DATE! ( yy.mm.dd -- )	4 DT! ;

--- Days of the week constants
PUBLIC
1 == MON
2 == TUE
3 == WED
4 == THU
5 == FRI
6 == SAT
7 == SUN

pub DAY@ ( -- day )			@day C@ 1 MAX ;

--- set DAY as in MON DAY etc
pub DAY ( day -- )
     DUP @day C!
     @rtc IF 3 rtcbuf@ 7 ANDN + 3 rtcbuf! WRRTC ELSE DROP THEN
     ;

pub .DAY ( n -- )	1 7 LIMIT 1-  3 * " MonTueWedThuFriSatSun" + 3 CTYPE ;

pub .TIME
     TIME@ ':'
pri .DTF ( value sep -- )
     SWAP #10 >RADIX <# # # OVER HOLD # # SWAP HOLD # # #> PRINT$ RADIX>
     ;

--- Print date in international format YYYY/MM/DD
pub .DATE        20 . DATE@ '/' .DTF ;

pub .ASMONTH ( index -- )
    >N 1- 3 * " JanFebMarAprMayJunJulAugSepOctNovDec" + 3 CTYPE
    ;

pub .DT		TIME@ DATE@ DAY@
( Tue, 03 Dec 2013 04:19:05 GMT )
pri .DTS ( time date day -- )
	.DAY ',' EMIT
	SPACE 100 U/MOD SWAP $420A PRINTNUM
	SPACE 100 U/MOD SWAP .ASMONTH SPACE
	2000 + PRINT
	SPACE ':' .DTF PRINT"  AEST" CR
	;


--- STAMP@ returns a 32-bit millisecond time + day of month in top 5-bits
pub STAMP@ ( --- dhmsc )	@time @ @day 1+ C@ 27 << + ;


--- read temperature from DS3231
pub 'C ( -- 'C*100 )		@rtc IF $12 RTC@ $11 RTC@ B>W 6 >> 25 * ELSE 0 THEN ;
pub 'F ( -- 'F*100 )		'C 9 * 5 / 3200 + ;
pub .TEMP					'C <# # # '.' HOLD #S #> PRINT$ PRINT" 'C " ;

( TIMERS )
--- Maintain chained list of TIMERS
--- by default count down 32-bits to zero every millisecond if set
pri CountDown
	--- next timer
	timers W@
 	BEGIN
	  --- link to another timer?
 	  DUP $FF >
	WHILE
	  --- count up mode? (ALARM=1)
 	  DUP 4+ W@ 1 =
 	  IF
	    --- simple count up mode
 	    DUP ++
 	  ELSE --- count down if non-zero
 	    DUP @ ?DUP
 	    IF
	      --- decrement non-zero timer and udate
 	      1- DUP 3RD !
	        --- if now zero then execute valid alarm if set
 	        0= IF DUP 4+ W@ DUP 4 >>
 	          IF CALL ELSE DROP THEN
 	        THEN
 	    THEN
 	  THEN
	  --- follow link to next timer
 	  6 + W@
 	REPEAT
 	DROP
	;


{ DS3231 REGISTERS  --- typical arrangement of most RTCs with minor differences

	7	6	5	4	3	2	1	0
00	0	----10 seconds---	------ seconds ----------
01	0	----10 minutes---	------ minutes ----------
02	0	12/24	PM --------------- hours ----------------
03	0	0	0	0	0	----- day -------
04	0	0	--date---	---------- date ---------
05	cent	0	0	--------- month -----------------
06	--------- 10 year -------	-------- year -----------
0E	/eosc	bbsqw	conv	-	-	intcn	A2IE	A1IE
11	sign------------------ temperature msb ------------------
12	-- t lsb --

}
pub !RTC
	--- set some defaults in case hardware is not present
	010101 4 SDT! 0 0 SDT! MON @day C!
	--- skip if no hardware RTC has been set
	@rtc 0EXIT
	--- otherwise buffer current RTC readings
	RDRTC
	--- read hours and convert to minutes
	2 rtcbuf@ $3F AND BCD>DEC 60 *
	--- read minutes, acc and convert to seconds
	1 rtcbuf@ BCD>DEC + 60 *
	--- read seconds and acc
	0 rtcbuf@ $7F AND BCD>DEC +
	--- convert to millisec and update soft rtc
	1000 * @time !				--- resynch soft rtc
	--- read year and decimal shift 4 places
	6 rtcbuf@ BCD>DEC #10000 *
	--- read month and decimal shift 2 places and acc
	5 rtcbuf@ $1F AND BCD>DEC 1 12 LIMIT #100 * +
	--- read date and acc
	4 rtcbuf@ $3F AND BCD>DEC 1 31 LIMIT DUP @day 1+ C! +
	--- latch date
	@date !
	--- day
	3 rtcbuf@ 7 AND 1 MAX @day C!
	;


PRIVATE
word _job

pub TIMERJOB ( cfa -- )		BEGIN _job W@ 0= UNTIL _job W! ;

--- Provide background timing functions including alarm actions on timeouts
pri TIMER.TASK
	--- reset timer chain
	1 timers W!
	--- timer boot id - if timer id is same as this then it has already been added since boot
 	3 tid C+!
	--- clear variables
	runtime ~ _job ~
	--- set the WAITCNT DELTA for every millisecond
	ttint DELTA
	--- disable watchdog
 	wdt 16 ERASE
	--- but link it into the timer list
 	0 wdt TIMEOUT
	--- set default watchdog behaviour
	' REBOOT wdt ALARM
	BEGIN
	  --- allow other cogs to get this cog to handle I/O inits etc
 	  _job W@ ?DUP IF _job W~ CALL THEN
 	  runtime ++
	  --- maintain the linked chain of countdown timers
 	  CountDown
	  --- time of day in milliseconds
	  @time ++
	  --- update soft RTC at start of day
	  @time @ 86400000 => IF !RTC THEN
	  --- make sure no alarm routine affects these lines (in this cog).
 	  $F000.0000 INPUTS
	  --- synch to next heartbeat
	  WAITCNT
	AGAIN
	;


--- EXTENDED KEY POLLING – UP TO 8 ENTRIES
8 words polls
pub ?POLL
	--- read 8 words and call if set
 	polls FROM 2 BY 8 FOR I W@ ?DUP IF CALL THEN NEXT
 	;
pub +POLL ( cfa -- )
	--- find a blank word                                  and set it
 	polls FROM 2 BY 8 FOR DUP I W@ = IF LEAVE ELSE I W@ 0= IF DUP I W! LEAVE THEN THEN NEXT DROP
	--- ensure keypoll is set
 	' ?POLL keypoll W!
	;

\ pub !POLLS	polls 16 ERASE keypoll W~ ;

--- read pin load as floating, up, or down
pri ~p	I FLOAT 10 us I PIN@ 1 AND 10 us ;

pub lsio
	DIRA COG@
	31 FROM -1 BY 32
	FOR
	  I 3 AND 3 = IF SPACE I . ':' EMIT THEN
	  I MASK OVER AND
	  IF
	    I PIN@ IF 'H' ELSE 'L' THEN EMIT
	  ELSE
	    I LOW ~p 2* I HIGH ~p + " D~?U" + C@ EMIT
	  THEN
	NEXT
	DIRA COG!
	KEY DROP
	;

pri ~R	@rtc NOT IF I =rtc THEN ;
pri ~I
	SWITCH
	$DE CASE " MCP7941x RTC" ~R BREAK
	$AE CASE " RTC EEPROM" BREAK
	SWITCH@ 4 >> SWITCH
	$4 CASE " I/O PORT" BREAK
	$7 CASE " DISPLAY I/O" BREAK
	$A CASE " EEPROM" BREAK
	---            and automatically add the device if it is found
	$D CASE " RTC" ~R BREAK
	" unknown"
	;

pub lsi2c
	" I2C" .HEAD$ yellow PEN
	2 BY 128 FOR
	  <I2C I 1+ I2C!? 0=
	    IF CR I '$' EMIT .BYTE SPACE I ~I PRINT$ THEN
	  I2C>
	NEXT
	PLAIN
	;


(		*** Unified memory operators ***	)



--- Print counted string from EEPROM
pri .ES			SWAP FROM FOR I EC@ EMIT NEXT ;

--- Addresses $8000 upwards are EEPROM
pri EE?			DUP 15 >> ;
pub MC@++		DUP 1+ SWAP
pub MC@			EE? IF EC@ ELSE C@ THEN ;
pub MW@			EE? IF EW@ ELSE W@ THEN ;
pub MU@			EE? IF E@ ELSE U@ THEN ;
pub NFA>BFA		MC@++ + 2+ 1 ANDN ;

pub MLEN$		DUP BEGIN MC@++ 1 $7E WITHIN NOT UNTIL SWAP - 1- ;

pub PRINT$		DUP MLEN$
pub CTYPE		SWAP FROM FOR I MC@ EMIT NEXT ;

pub +NFA		EE? IF 16 + ELSE NFA>BFA 2+ THEN ;							--- proceed to next name ;
{
pub CFA>NFA
	@NAMES BEGIN DUP MC@ 0= IF 2DROP 0 EXIT THEN
	DUP NFA>BFA MW@ 3RD
        word  @ATNAMES+s
cnlp    word  DUP,CFETCH,ZEQ,_IF+02,DROP2,@FALSEX+t
        word  DUP,@NFABFA+s,WFETCH,THIRD
        word  EQ,_IF+01,@NIPEX+t
        word  @NFANFA+s,@cnlp+t

' MC@ ' CFA>NFA 4 + W!
' MW@ ' CFA>NFA 18 + W!
' MC@++ ' CFA>NFA 4 - W!
}

--- common sub used by .EEMOD
pri ~M ( ptr -- )
	BEGIN
 	  DUP MC@
 	WHILE
	  --- name must be longer than 4 chars
 	  DUP MC@ 4 >
	  --- is the end of the name = ".fth" ?
	  IF DUP MC@ 3 - OVER + MU@ " .fth" MU@ =
 	    IF
	      --- print its CFA code address (old PFA)
 	      DUP NFA>BFA MW@ DUP >A CR .WORD PRINT" : "
	      --- display the module name and try to line up the description
 	      BOLD DUP 1+ DUP PRINT$ MLEN$ #20 SWAP - SPACES
	      --- execute the .fth word to display it's message
 	      A> CALL
	      PLAIN
	    THEN
	  THEN
	  +NFA
	REPEAT
	DROP
;

pub .MODULES
	" MODULES" .HEAD$
	CR 20 XTAB REVERSE .VER PLAIN
	@NAMES ~M CR
	$8000 ~M
	;


{ Dictionary header attribute flags
hd      = |<7           'indicates this is a an attribute (delimits the start of a null terminated name)
sm      = |<6           'smudge bit - set to deactivate word during definition
im      = |<5           'lexicon immediate bit
pr      = |<3           'private (can be removed from the dictionary)
}
\  NFA  CFA  ATRS    V NAME
\ 6390 204C 0 AWORDS          639A 2038 0 EE              63A0 202C 0 BACKUP          63AA 2026 0 ?BACKUP

--- common sub for WORDS
pri ~W
	CR PRINT" NFA  CFA  V NAME"
	0 SWAP
	BEGIN
	  PLAIN
	  DUP MC@
	WHILE
	 OVER 3 AND 0= IF CR THEN
	 SWAP 1+ SWAP
	  \ XY@ DROP 88 > IF CR THEN
	  DUP MC@++ + MC@
	  --- print attribute
	  DUP $20 AND IF BOLD ELSE PLAIN THEN 8 AND IF red ELSE green THEN PEN
	  DUP .WORD SPACE DUP NFA>BFA MW@ .WORD SPACE
	  \ SPACE
	  DUP MC@ 5 >> PRINT SPACE
	  DUP MC@++ $1F AND SWAP OVER CTYPE 16 SWAP - SPACES
	  +NFA	\ NFA>BFA 2+
	REPEAT
	2DROP
	;

pub WWORDS	@NAMES ~W $8000 E@ -1 <> IF $8000 ~W THEN ;

pri ~V
	0 SWAP
	BEGIN
	  DUP MC@
	WHILE
	  DUP NFA>BFA W@ DUP
	  $8000 AND IF
	    3RD 6 MOD 0= IF CR ELSE 3RD 6 MOD 20 * XTAB THEN
	    $7FFF AND DUP 3 AND " 2365" + C@ PEN .WORD SPACE DUP 1+ PRINT$
	    SWAP 1+ SWAP
	  ELSE DROP
	  THEN
	  +NFA
	REPEAT
	2DROP PLAIN
	;

pub .VARS	@NAMES ~V $8000 ~V ;

pub .INDEX 	CR I 2 PRINTDEC PRINT" : " ;

pub .TASKS ( -- )
	8 FOR
	I TASK 2+ C@ DUP
	IF   .INDEX I TASK W@ ?DUP
	  IF CFA>NFA 1+ DUP PRINT$
	  ELSE PRINT" IDLE"
	  THEN
	  20 XTAB
	THEN
	I COGID = DUP
	  IF   .INDEX PRINT" CONSOLE" 20 XTAB THEN
	OR IF I TASK DUP W@ .WORD SPACE 2+ FROM 6 FOR I C@ .BYTE SPACE NEXT THEN
	NEXT
	;


pub .TIMERS
      SPACE CLKFREQ ttint / ." ticks = 1/" 0 PRINTDEC
      PRINT"  runtime = " runtime @ 0 PRINTDEC
        --- read links
 	timers W@
 	BEGIN
 	  DUP $FF >
 	WHILE
 	  CR DUP .WORD 	  ." : "
 	  DUP $8000 + CFA>NFA 1+ PRINT$ 20 XTAB
 	  DUP @ 6 PRINTDEC ." ms "
 	  ." =" DUP @ .LONG
 	  ."  L" DUP 6 + W@ .WORD
 	  SPACE DUP 4 + W@ IF ." ALARM=" DUP 4 + W@ CFA>NFA 1+ PRINT$ THEN
 	  6 + W@ --- fetch the link to the next timer
 	REPEAT
 	DROP
 	;

--- --- --- --- --- --- --- --- --- INTERCOM --- --- --- --- --- --- --- --- --- --- ---
{
$0030
$30	gpcfg         byte    0
$31	idcfg         byte    0
$32	trcfg         byte    0
$33	tecfg         byte    0
$34	ppbaud        long    sysfreq/2000000           ' default 2Mbps


INTERCOM ADDRESSES
$100		select none
$101..$1DF	select unit 1..223
$1E0..$1EE	select group 0..14
$1EF		select all
INTERCOM COMMANDS
$1F0
$1F1
$1F2
$1F3		INDUCT
$1F4
$1F5
$1F6
$1F7
$1F8		HUB memory
$1F9
$1FA		HALT cogs
$1FB		INIT cog
$1FC		BOOT image
$1FD
$1FE		RESET
$1FF		ETX marker


#222		default unassigned unit
}

pub PPBAUD! ( baud -- )		9600 2,000,000 LIMIT CLKFREQ SWAP / $34 E! ;

--- &GP.ID.TR.TE   --- &01.12.14.15 INTERCOM!
pub INTERCOM! ( config baud -- )
	PPBAUD!
	$0F.FF.1F.1F AND $E0.00.00.00 OR $30 E!
	$30 $30 $10 ELOAD
	;

pub .INTERCOM
	BOLD PRINT" INTERCOM: " PLAIN
	$33 C@ '&' EMIT >N 2 .DEC
	$32 C@ '." EMIT 2 .DEC
	$31 C@ '." EMIT 2 .DEC
	$30 C@ '." EMIT 2 .DEC
	SPACE
	'@' EMIT CLKFREQ $34 @ / 0 PRINTDEC
	;


pub .AUTO	 PRINT" AUTORUN " uauto W@ ?DUP IF CFA>NFA 1+ PRINT$ ELSE PRINT" <OFF>" THEN ;

pub .FREQ	CR PRINT" FREQ = " CLKFREQ 100,000 / 0 1 .DP PRINT" MHz" ;


--- save unit prompt ID in place of " ok"
pub ID!	( str -- )		id $! id DUP 16 ESAVEB ;








byte tibwr
--- text input buffer is a psuedo constant
pub tib		$1C0 ;


pub EVAL$ ( str -- )	DUP FROM LEN$ FOR I C@ doKEY NEXT $20 doKEY $0D doKEY ;


pri KEY:
	DUP $08 = IF DROP tibwr C@ IF 8 EMIT SPACE 8 EMIT tibwr C-- THEN EXIT THEN
	DUP $0D = IF DROP tibwr C@ IF tib EVAL$ tibwr C~ THEN PRINT"  ok" CR EXIT THEN
	DUP EMIT tibwr C@ tib + C! tibwr C++ tibwr C@ tib + C~
	;

pre OK
	ON QUIET CR tibwr C~ tib C~
	BEGIN KEY ?DUP IF KEY: THEN AGAIN
	;



























(	*** ROMS ***		)

$E000		== roms
$1F00		== romsz
" .ROM" U@	== .rom


pub lsroms
	" ROMS" U@ roms E@ =
	IF " ROMS" .HEAD$ cyan PEN
	  .rom roms
	BEGIN DUP E@ 3RD =
	  IF ( ROMS PTR )
	   CR DUP 16 + .WORD PRINT" : " DUP 6 + 10 .ES SPACE DUP 4+ EW@ 4 U.R
	   DUP 4+ EW@ +
	  ELSE
	   4+
	  THEN
	DUP roms romsz + =>
	UNTIL
	2DROP
	ELSE DROP PRINT" NO ROMS"
	THEN
	PLAIN
	;








pri NEXTROM ( addr -- addr2 | false )
	BEGIN DUP E@ .rom <> WHILE 4+ DUP roms romsz + => IF DROP FALSE EXIT THEN REPEAT
	NOP
	;




pri FINDROM ( name -- nameaddr | false )
	roms
	BEGIN NEXTROM DUP ( name @rom flg )
	WHILE 6 + OVER U@ OVER E@ = IF OVER 4+ U@ OVER 4+ E@ = IF NIP EXIT THEN THEN
	--- skip over this rom
	DUP 2- EW@ + 2+
	REPEAT
	NIP
	;


{		--- COGINIT ( code pars cog -- ret )
@VGA $200 + vgapars 2 LOADCOG
0 = Tachyon console
1 = serial recevie
2 = TIMER
}



pub LOADCOG ( pars cog name  -- )
	FINDROM ?DUP
	IF
	  PRINT" Loading cog " OVER PRINT SPACE DUP .WORD SPACE DUP 8 .ES
	  DUP 10 + SWAP 2- EW@ ( pars cog addr cnt )
	  ep ALIGN $8000 OVER - DUP >A SWAP ELOAD	--- use from end of buffers as required
	  A> -ROT COGINIT DROP
	THEN
	;


PRIVATE
1 longs f32cmd	( f32 parameter block - force alignment using longs )
long result long fnumA long fnumB


pub FCMD ( n1 n2 cmd -- result )  result ! fnumB ! fnumA ! result f32cmd ! BEGIN f32cmd @ 0= UNTIL result @ ;

pub >F ( n1  -- result )	0 $5CFC8E42 FCMD ;
pub F> ( n1 -- result )		1 $5CFCBE48 FCMD ;
pub F+ ( n1 n2 -- result )	$5CFC3C0D FCMD ;
pub F- ( n1 n2 -- result )	$5CFC3C0C FCMD ;
pub F* ( n1 n2 -- result )	$5CFC641F FCMD ;
pub F/ ( n1 n2 -- result )	$5CFC6233 FCMD ;
pub FSIN ( n1 -- result )	0 $5CFD72A2 FCMD ;
pub FSQRT ( n1 -- result )	0 $5CFD006C FCMD ;






pri ,WORD$
	--- compile code for inline string
	' (") [C] [W]
	--- process word as string
	@WORD DUP FROM LEN$ 1+
	--- and compile it including terminator
	  FOR I C@ [C] [B] NEXT
	--- clear out word
	@WORD 1- 32 ERASE
	--- skip returning to error handler
	R> DROP
	;

--- hold up to 4 deferred actions
4 words defstk

pri ?DEFER
	defstk 6 + FROM -2 BY 4 FOR I W@ ?DUP IF CALL THEN I W~ NEXT
	undef W~
	;

\ pri !DEFER	defstk 8 ERASE ;

pub DEFER
	--- cause undefined words to be handled
	' ,WORD$ undef W!
	--- and defered code to execute on acceptance of line
	' ?DEFER prompt 2+ W!
	R>
	--- push onto defer stack
	defstk DUP 2+ 6 <CMOVE
	\ defstk 6 + W~
	defstk W!
	;




pub BOOT
	' TIMER.TASK 2 RUN
	$7610 $200 ERASE
	keypoll W~
	--- Clear out any dead inits
	?INITS
\	!POLLS
\	!DEFER
	?ANSI
	CR green PEN f32cmd 3 " F32     " LOADCOG  PLAIN ( start up F32 )
	--- clear out buffers as LOADCOG just used this
	BUFFERS $800 ERASE
	--- generate a seed
	seed =CNT RND seed !

	--- abort inits if ^A is detected
	BEGIN KEY ?DUP WHILE 1 = IF  CR PRINT"  <aborting startup> " DISCARD EXIT THEN 20 ms REPEAT
	INIT
pub ??
	PLAIN CR .MODULES CR .AUTO .FREQ
	lsini
	CR lsroms
	CR I2C100 lsi2c I2C400 !RTC
	CR BOLD PRINT" I/O = " PLAIN red PEN lsio PLAIN
	CR .INTERCOM CR .STATS
	.DT
	;

--- remove header for seed constant
STRIP seed






IFNDEF ~K
--- Scan first 32k of EEPROM for any ROMs and move them up into the special ROM area, then forget this routine
pub SAVEROMS
	ep 64 > 0EXIT
\	" ROMS" U@ roms E@ <> 0EXIT
\	roms $1F00 $FF EFILL
	--- search for ROMS string between end of kernel at TACHYON and start of dictionary
	" ROMS" U@
	' TACHYON 6000 + 3 ANDN FROM ( src )
	@NAMES 3 ANDN OVER - 2/ 2/ 4 BY ( src lcnt )
	FOR I E@ OVER =				--- found a match for "ROMS"
	  IF I 8 + E@ OVER =			--- Yes but verify for additional ROMS sig
	    IF
	      CR 20 SPACES PRINT" COPY ROMS from $" I .WORD
	      PRINT"  for " I 4+ E@ DUP .DECX SPACE CR
	--- Copy ROMs from old EEPROM location to upper EEPROM
	      I roms ROT romsz MIN ECOPY
	--- erase original ROMs
\	      I 8 4 DOFOR 0 I E! LOOP
	      LEAVE
	    THEN
	  THEN
	NEXT
	DROP
	;


$7610 @org W@ OVER - ERASE
END


errors W@ 0= IF SAVEROMS THEN
--- wipe ROMS pattern from U@ register
0 U@ DROP
FORGET SAVEROMS


errors W@ 0= IF AUTORUN BOOT THEN
I2C400 ?BACKUP

REBOOT


}

