' V4.5 - experiment with revised DO LOOP method - FOR NEXT augmented with BY and FROM
' FROM defaults to 0 and BY defaults to 1 - no need to set unless required
' TODO: loop stack maintained in hub RAM at $180 but obviously other cogs need their own area
DAT { *** VERSION *** }
version       long 450_170727
vertime       word 1400
vername       byte "4.5 DAWN"                   ' fixed 8 character version name

CON { *** CLOCK MODES *** }
{ 5/10MHZ CRYSTAL
_clkmode        = xtal1 + pll8x
_xinfreq        = 10_000_000            ' <--- AUTOMATIC 5 or 10MHz operation change at boot
sysfreq         = 80_000_000
'}
'{ 6MHZ CRYSTAL
_clkmode        = xtal1 + pll16x
_xinfreq        = 6_000_000
sysfreq         = 96_000_000
'}
baud            = 115200                ' <-- user change - tested from 300 baud to 3M baud
'baud            = 921600

CON {{

.:.:-- TACHYON --:.:.

A very fast and very small Forth byte code interpreter for the Propeller chip.
2012..2017 Peter Jakacki


FEATURES
V4
Wordcodes are read from hub RAM and directly address first 512 longs of PASM code in cog
15-bit literals are directly encoded - variables and constants are compiled from the header data
Special branch codes with encoded +/- 128 word displacement and conditional bit.


Stacked backward branch references - fast and simple looping
Top 4 stack parameters are accessed as fixed registers - uses cog stack for up to 32 items
Small memory footprint
Low level words and run-time wordcode interpreter in PASM
-----------------------------------------------------------------------------------------------



'-------------------- WHAT'S NEW --------------------'

V4 uses word encoding instead of bytecodes and the instruction word also has a simple encoding
All addresses <$200 will jump to PASM code
$200..$7DFE     will automatically push the current IP (if bit 0 = 0) and load the IP with the address given
                if bit 0 = 1 then it performs the equivalent of a jump
$7Exx           are 8-bit byte index into this cog's task registers (set via regptr)
$7Fxx           is a conditional jump where a 8-bit signed displacement field indicates +/-128 words
$8000..$FFFF    are 15-bit literals with the msb set.


NOTES:
INDENT all user input

CHANGELOG
170727  Interpret -1 as code
        Reformatted .STATS
170715  Simplified console and prompt - removed line number etc

170709  Updated version number after various tweaks
        Added IC! to speed up LREAD in EASYNET
        Added ADO LOOP and +LOOP as variations of FOR NEXT loops
170705  Introduced FROM and BY to set FOR NEXT loop start index and index step
        Combined loop and branch stack and placed in hub RAM to save code space and easier indexing

170702  Strings can now include " as a valid char - " followed by a space or cr is the terminator
        PRINT" NOW I CAN EMBED "QUOTES""
170620  Increase depth of loop and branch stack to allow for one extra LOOP nesting
170521  Interactive mode default is any-case - use OFF ANYCASE to force case
170520  Rearranged doNext to give more priority to hub calls vs literals etc
        Introduced auxiliary stack >A A> A@ and !A if needed (other stacks should not be used for temps)
170519  Added PUSH16 for more compact literals
        IX has been removed - use I to read FOR NEXT index
        IY has been added - returns current DOFOR loop count (which counts down)
170518  Changed loop stack into hybrid stack to save space - only top 4 elements directly accessible inc I,J (not K)
        Move rarely used code to high-level such as ROR, ROL, 0< etc
1705xx  V4.4 - experimenting with DOFOR to replace DO/ADO/+LOOP
        IX is now the same as I since the loop index is now the top element


170319  Fixed COLD start - retain dictionary at top
        Fixed .LAP to report seconds
170307  V4.2 - removed COGREG references and moved to fixed location from address 1 - index from 1 onwards

170124  Add extra RUNMODs
        Add XTAB feature
        Change default space after console enter to a CR
        Allow lower-case hex
170118  Adding ping-ping command modes - still testing
170117  Add 9-bit ping-pong mode for binary transfers - allows up to 239 devices as well
161221  TACHYON loads fast dictionary search module - handles line delays down to 3ms
161220  Added character literals etc

161123  Realized that special unconditional jumps such as _ELSE and _AGAIN are unnecessary since we have calls as jumps
161122  FIXDICT function will also move dictionary up so the end of it lines up against dictend (varram)
161121  Dictionary structure for RAM is set to: cnt+voc(1),name(v),atr(1),<word align>,wordcode(2)


Refer to V3.1 for older changelogs


Some comparisons with V3
V4 2.8us/loop   1000 0 LAP DO 1234 DROP LOOP LAP .LAP
V3 3.6us/loop   1000 0 LAP DO 1234 DROP LOOP LAP .LAP  ( 3ms @96)
Both execute DO LOOP in 600ns
V4 2.2us        1234 DROP
V3 3.0us        1234 DROP

V4 170213 @96MHz                V3
Push literal    833ns           833..1333..1833..2000
DROP            833ns           666ns..1000 (stack)
32-bit push     1166            3000
DO LOOP         500ns           500ns
FOR NEXT        333ns           333
DUP             666ns           833
SWAP            500ns           333
NOP             333ns           333
1+              333ns           333
8<<             333ns           333
>R              1166
R>              1000

V4 2.17us/loop  1000 0 LAP DO 1234 DROP LOOP LAP .LAP

}}

CON {{ *** MEMORY MAP ***

COGS
0 TACHYON CONSOLE
1 CONSOLE SERIAL + PING-PONG
2   TIMERS + RTC + WDT
3 LOADER
4
5
6
7

MEMORY MAP
0000    CLKFREQ
0004    CLK
0005    CHKSUM
0006    PBASE   0010            Always $0010
0008    VBASE   7E34
000A    DBASE   7E3C
000C    PCURR   7E0C            Spin code reset vector
000E    DCURR   7E40
0010    PROP TOOL ?             0000.0010:   24 7E 02 00  FC 7D 00 00

0018    VERSION
0028    CONSOLE BAUD TICKS
002C    RXPIN,TXPIN,0,0
0030    PPCFGS (PPBAUD,TR,TE,ID,GP)
0038    -
0040    GLOBAL VARIABLES($8C)
0040    TASKS
00CC    -

0100   TASK REGISTERS ($77)
0177   -

0200    vvv HIGH LEVEL CODE vvv

 1880   DICTIONARY
 2300   ROMS

        ^^^ DICTIONARY ^^^
7400    RX BUFFER
7600    VARIABLES
7800    BUFFERS
        Console serial + Ping-Pong
        Tachyon kernel
        Spin startup


0000.0000:   00 D8 B8 05  6F F6 10 00  BC 7F C4 7F  88 7F C8 7F    ....o...........
0000.0010:   AC 7F 02 00  78 7F 00 00  12 B3 72 18  6C 07 34 2E    ....x.....r.l.4.

             VERSION-----------------  --CONBAUD--  RX TX
0000.0020:   31 20 44 41  57 4E 00 00  00 10 0E 00  1F 1E 00 00    1 DAWN..........
             TR TE ID GP  PPBAUD-----
0000.0030:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................

HUBVARS
0000.0040:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0050:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0060:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0070:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0080:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0090:   00 00 08 74  00 00 A4 69  A4 69 C8 5D  C8 5D 80 18    ...t...i.i.].]..
0000.00A0:   9C 2C A4 2C  A5 5A 74 2C  00 00 F2 05  00 00 00 00    .,.,.Zt,........
0000.00B0:   01 00 00 00  00 00 D4 76  DE 04 E2 04  E6 04 00 00    .......v........
0000.00C0:   22 00 0D 50  00 00 01 00  00 00 00 00  00 00 00 00    "..P............
---
0000.00D0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.00E0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.00F0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................

TASK REGISTERS
0000.0100:   00 44 00 00  00 00 00 00  00 00 00 00  00 00 00 00    .D..............
0000.0110:   10 27 C0 12  00 00 00 00  00 00 00 00  34 00 0A 00    .'..........O...
0000.0120:   0A 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0130:   0D 50 4D 55  00 00 00 00  00 00 00 00  00 00 00 00    .PMU............
0000.0140:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0150:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0160:   00 00 00 00  00 00 00 00  00 00 00 31  33 31 31 34    ...........13114
0000.0170:   31 31 35 32  32 00 15 00  00 00 00 00  00 00 00 00    11522...........

SPARE TASK REGISTERS
0000.0180:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.0190:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.01A0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.01B0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.01C0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.01D0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.01E0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................
0000.01F0:   00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00    ................

}}



DAT
' serial console parameters

baudrate      long    sysfreq/baud              ' The baudrate is now stored as a variable
conpins       byte    rxd,txd,0,0               ' default pins for console
''''' $0030..$003F   TR TE ID GP  PPBAUD
' &ID.GP.TR.TE BAUD
ppcfgs
tecfg         byte    0
trcfg         byte    0
idcfg         byte    0
gpcfg         byte    0
ppbaud        long    sysfreq/2000000           ' default 2Mbps






CON { *** PORT ASSIGNMENTS *** }
' Standard Port assignments
scl             = 28
sda             = 29
txd             = 30
rxd             = 31


CON { *** STACK DEFINITIONS etc *** }

' Stack sizes
datsz           = 32-4
retsz           = 28

hubvars         = $40
registers       = $0100 'hubvars+128
loopstk         = $0180
'rxbuffers       = registers+256

varram          = $7400                 ' rxpars and rxbuffer
datram          = $7610
buffers         = $7800


' COMPILATION CONSTANTS
w               = $8000                 ' this is added into a 15-bit literal so it can be decoded as a literal and not an address
s               = $10                   ' Spin tool header offset fix
t               = s+1                   ' Same as s except JUMP instead of CALL
y               = w+s                   ' Use with absolute position precompiled embedded variables y+@mytemp

_FALSE          = w+0
_0              = w+0
_1              = w+1
_2              = w+2
_3              = w+3
_4              = w+4
_5              = w+5
_6              = w+6
_7              = w+7
_8              = w+8
_16             = w+16
BL              = w+$20

'conditional branch code
_UNTIL          = $7F80
_IF             = $7F00

' task register opcode
rg               = $7E00


numpadsz        = 26                    ' We really only need a large buffer for when long binary numbers with separators are used - 26 digits for double number 18,446,744,073,709,551,615
wordsz          = 39                    ' any word up to 37 characters (1 count, 1 terminator)
tasksz          = 8                     ' 8 bytes/task RUN[2] FLAG[1]
loadsz          = 23                    ' Specifies the number of longs to load with LOADMOD for a RUNMOD module

' flags masks
echof           = |<0
linenums        = |<1                     ' prepend line number to each new line
leadspaces      = |<2                     ' # number conversion
prset           = |<3                     ' private headers set as default
oddbc           = |<4                  ' bcomp has word aligned - could reuse this byte on next bcomp
'imset           = |<5
comp            = |<6                   ' force compilation of the current word - resets each time
deff            = |<7                   ' defining
'sign            = |<8
anycase         = |<0

CON { *** DICTIONARY *** }
' Dictionary header attribute flags
hd      = |<7           'indicates this is a an attribute (delimits the start of a null terminated name)
sm      = |<6           'smudge bit - set to deactivate word during definition
im      = |<5           'lexicon immediate bit
pr      = |<3           'private (can be removed from the dictionary)

link    = |<2           'next record is a link ( long(1),long(ptr) )

cn      = 1             ' default count and vocab - FIXDICT overwrites

' Count byte fields
' 0..4  = length 0 to 31
' 5..7  = vocab 1 of 8







DAT { *** GLOBAL VARIABLES *** }

              org hubvars
tasks           res tasksz*8    ' (must be long aligned)
loadpars        res 8           ' load address and count

ufind           res 2           ' runs extended dictionary search if set after failing precompiled dictionary search
uword           res 2           ' exception processing for text words (create etc)
uprompt         res 2           ' pointer to code to execute when Forth prompts for a new line
uaccept         res 2           ' pointer to code to execute when Forth accepts a line to interpret (0=ok)
ucreate         res 2           ' If set will execute user create routines rather than the kernel's

rxptr           res 2           ' Pointer to the terminal receive buffer - read & write index precedes
rxsz            res 2           ' normally set to 256 bytes but increased during block load
corenames       res 2           ' points to core kernel names for optimizing search sequence
 oldnames        res 2           ' backup of names used at start of TACHYON load
names           res 2           ' start of dictionary (builds down)
 prevname        res 2           ' temp location used by CREATE
fromhere        res 2           ' Used by TACHYON word to backup current "here" to determine code size at end of load
uhere           res 2           ' pointer to compilation area (overwrites VM image)
uthere          res 2           ' current code compilation pointer (updates "here" or is reset by it)
cold            res 2           ' pattern to detect if this is a cold or warm start ($A55A )
uauto           res 2           ' user autostart address if non-zero - called from within terminal
errors          res 2
linenum         res 2
emitreg         res 4           ' 160514 addition for virtual console - 160705 using txon flg in emitreg+3
flags           res 2           ' echo,linenums,ipmode,leadspaces,prset,striplf,sign,comp,defining
keypoll         res 2           ' poll user routines - low priority background task
                res 2           ' backup for keypoll when disabled during block load
keys            res 2           ' ?????
datorg          res 2
dmm             res 8           ' DUMP methods
'delim           res 2           ' the delimiter used in text input and a save location
ucomp           res 2
lastkey
prevch          res 2           ' used to detect LF only sequences vs CRLF to perform auto CR


'lastkey         res 1
keychar         res 1           ' override for next key character to insert a characer into the stream

spincnt         res 1           ' Used by spinner to rotate busy symbol

prefix          res 1           ' NUMBER input prefix
suffix          res 1           ' NUMBER input suffix
                res 3
hvend           res 0





DAT { *** TASK REGISTERS *** }

' Allocate storage memory for buffers and other variables


'               long 0[64]              'Variables used by kernel + general-purpose

' Task registers can be switched easily by setting "regptr" ( 7 COGREG! )
' New tasks may only need room for the first 32 or 72 bytes



                org             ' TASK REGISTERS
' register offsets within "registers". Access as    REG,delim   ...  REG,base ... etc
'
' Minimum registers required for a new task - other registers after the ' ---- are not needed other than by the console
temp            res 12          ' general purpose
cntr            res 4           ' hold CNT or temp
baudcnt         res 4           ' SERIN SEROUT baud cnt value where baud = clkfreq/baudcnt   each cog can have it's own
uswitch         res 4           ' target parameter used in CASE structures



' @16
uemit           res 2           ' emit vector 0 = default
ukey            res 2           ' key vector

emitcol         res 1           ' CR resets this to zero - counts character position
keycol          res 1           ' maintains column position of key input
base            res 2           ' current base + backup location during overrides

inpbase         res 1
outbase         res 1

braces          res 1           ' count nested braces
inpsym          res 1           ' not used

inpnum          res 4
secnum          res 4
inpdgt          res 1
inpsep          res 1
                res 2

inpkey          res 4           ' last four key inputs

wordcnt         res 1           ' length of current word (which is still null terminated)
wordbuf         res wordsz              ' words from the input stream are assembled here
' numpad may continue to build backwards into wordbuf for special cases such as long binary numnbers
numpad          res numpadsz    ' Number print format routines assemble digit characters here   builds from end - 18,446,744,073,709,551,615
padwr           res 1           ' write index (builds characters down from lsb to msb in MODULO style)
                res 1

undef           res 2           ' undefined word exception vector

'tibwr           res 1
'tib             res 128           ' text input buffer for line mode


DAT { *** skip first 256 bytes of memory for buffers etc }
              'long 0[116]
              byte  0[$200-$38]



DAT { LMM CODE }



              org

        word      0
InitSP  word      LMM
                        movs    stkpop,#datastk
                        movd    stkpsh,#datastk
                        mov     udepth,#0
                        jmp     #EXIT

' SAR ( n1 cnt -- n2 )
        'word  0
_SAR          word      DROP,LMM
                        sar     tos,X
                        jmp     #EXIT

' DELTA ( delta -- )    Calculate and set the cnt delta and waitcnt
              word      0
DELTA         word      LMM
                        call    #POPX
                        mov     deltaR,X        ' use otherwise unused video reg for delta
                        mov     cnt,X           ' (kernel isn't doing any video)
                        add     cnt,cnt
                        waitcnt cnt,deltaR      ' continue from last count (must be called before target is reached)
                        jmp     #EXIT

pCOGSTOP      word      DROP,LMM
                        cogstop X
                        jmp     #EXIT

' COGINIT ( dest -- cog ) PAR(14), CODE(14), NEW(1),COG(3)
              word      0
pCOGINIT      word      LMM
                        coginit tos wr
                        jmp     #EXIT 'unext

_COGID        word      _0,LMM
                        cogid   tos
                        jmp     #EXIT

_REBOOT
              word    w+$80,  LMM
                        CLKSET  tos


' SYSTEM CLOCK MODES
'  	    0    C    7    C   0    0   0   0
'	%000011_0001_1111_000000000_000000000 STACKS 9 SHL + OPCODE (CLKSET)

        org
' CLK ( multiple0..4 -- )
_CLK    word  _3,PLUS,_4,CFETCH
        word  _7,_ANDN,_OR
_CLKSET word  _4,CSTORE,LMM
                        clkset  X
                        jmp     #EXIT

{
' LEN$ ( str -- len )
        word  0
STRLEN  word            LMM
                        mov     X,tos
stlp                    rdbyte  R0,tos wz               ' check byte for null or anything >$7F
       if_nz            cmp     R0,#$7F wc
       if_c_and_nz      add     tos,#1
       if_c_and_nz      rdlong   IP,IP
                        long     @stlp+s
                        sub     tos,X
                        jmp     #EXIT

'}
                        org
' temporary timing instructions
' Capture the current cnt value and calulate cycles since last LAP - result in lapcnt
' LAP ( --  ) delta in lapcnt (created independant regs rather than REG4,4)
        word      0
LAP     word      LMM
                        neg     lapcnt,target           '  -old
                        mov     target,cnt              ' new
                        add     lapcnt,target           ' new-old
                        jmp     #EXIT



' BIT? ( mask addr -- mask flg )
        word      0
BITQ    word      LMM
                        rdlong  tos,tos
                        and     tos,tos+1
                        jmp     #EXIT

' rarely if ever used - implement as LMM
        word      0
_ROL    word      LMM
                        call    #POPX
                        rol     tos,X
                        jmp     #EXIT
        word      0
_ROR    word      LMM
                        call    #POPX
                        ror     tos,X
                        jmp     #EXIT








DAT { HIGH LEVEL START }


        org
' idle loop for other Tachyon cogs
IDLE_reset
IDLE    word    InitRP
        word    _0,@_COGID+s,@TASK+s,WSTORE             ' clear task vector on entry and looping
id02    word    @InitSP+s
        word    w+1,@_COGID+s,@TASK+s,PLUS2,CSTORE  ' task+2 = 1 to indicate Tachyon running
idlp    word    w+8,@ms+s                                ' do nothing for a bit - saves power
        word    @_COGID+s,@TASK+s,WFETCH                ' fetch cog's task variable
        word    QDUP,_UNTIL+07                          ' loop until task active
id00    word    DUP,_SHR8,_IF+1,ACALL                   ' Execute but ignore if task address is only 8-bits
        word    @IDLE+t
id01


' TASK ( cog -- addr ) Return with address of task control register in "tasks"
TASK    word  w+3,_SHL,w+tasks,@PLUSX+t

' Registers can be used just like variables and the interpreted kernel uses some for itself
' 128+ bytes are reserved which can be accessed as bytes/words/longs depending upon
' the alignment. Since the registers are pointed to by "regptr" they can relocated
' REG ( index -- addr )
REG     word  rg+0
PLUSX   word  PLUS,EXIT


seconds word  w+1000,@MULTIPLY+s
' ms ( n -- ) Wait for n milliseconds
ms      word  QDUP,ZEXIT,@FREQ+s,w+1000,@UDIVIDE+s,UMMUL,DROP,w+2900+16,MINUS,@DELTA+t
us      word  _6,MINUS,FOR,_NOP,_NOP,forNEXT,EXIT


' LP! ( loopstk -- )
LPST    word  w+lpsp,COGSTORE,EXIT
LEAVE   word  _1
FORST   word  w+_for,COGSTORE,EXIT
FORFT   word  w+_for,COGFETCH,EXIT
BYST    word  w+_by,COGSTORE,EXIT

J       word  w+_fromj,COGFETCH,EXIT




DUP2    word  OVER,OVER,EXIT
ROT2    word  ROT,ROT,EXIT

' ?EXIT ( flg -- ) Exit if flg is true
IFEXIT  word  ZEXIT,RPOP,DROP,EXIT

{
' COGINIT ( code pars cog -- ret )
' : COGINIT     SWAP 3 ANDN 2 SHL OR SWAP 3 ANDN 16 SHL OR (COGINIT) ;
aCOGINIT
'        byte    DUP,XCALL,xTASK,FOURTH,OVER,WSTORE                              ' update cog info block with code adr
'        byte    THIRD,SWAP,INC,INC,WSTORE                                       ' store pars field
        '  pCOGINIT = PAR@long(14), CODE@long(14), NEW(1),COG(3)
        byte    SWAP,_16,_SHL,_OR,SWAP,_2,_SHL,_OR,pCOGINIT,EXIT
}


' !A Init the auxiliary stack pointer
'InitA   word    w+$00E0-4,w+astk,COGSTORE,EXIT

DAT { *** NUMBER BASE *** }


' change the default number bases
BIN     word  w+2,@SetBase+t
DECIMAL word  w+10,@SetBase+t
HEX     word  w+16
SetBase word  rg+base,CSTORE,@setdef+t

DAT { *** NUMBER PRINT FORMATTING *** }

' @PAD ( -- addr ) pointer to current position in number pad
ATPAD   word    rg+padwr,CFETCH,rg+numpad,@PLUSX+t

' HOLD ( char -- )
HOLD    word    MINUS1,rg+padwr,CPLUSST,@ATPAD+s,@CSTOREX+t

' >CHAR  ( val -- ch ) convert binary value to an ASCII character
TOCHAR  word    w+$3F,_AND,w+"0",PLUS,DUP,w+"9"             ' convert to "0".."9"
        word    GT,w+7,_AND,PLUS            ' convert to "A"..
        word    DUP,w+$5D,GT,ZEXIT,w+3,@PLUSX+t             ' skip symbols to go to "a"..

' <#    ' resets number pad write index to end of pad
LHASH   word    w+numpadsz,rg+padwr,CSTORE,_0,@HOLD+t


' # ( n1 -- n2 ) convert the next ls digit of a double to a char and prepend to number string
HASH    word  DUP,_IF+9
        word  rg+cntr,FETCH,rg+base,CFETCH,UMDIVMOD64,@DNUM+s
        word  SWAP,@toCHAR+s,@HOLD+t
        ' conversion digits exhausted, use zeros or spaces
        word  w+$30,w+leadspaces,@SETFLGQ+s,_IF+02,DROP,BL,@HOLD+t

' #S ( d1 -- 0 ) Convert all digits
HASHS   word  @HASH+s,DUP,ZEQ,_UNTIL+4,EXIT

' #> ( 1 -- caddr )
RHASH   word  DROP,@ATPAD+s,w+leadspaces,w+flags,@CLR+s,_0
' <D> ( d1 -- n1 ) ' Store high long of double for formating
DNUM    word  rg+cntr,@STOREX+t

{
' LEN$ ( str -- strend )
STRLEN  ' ( str -- len )
        word    DUP,STREND,SWAP,MINUS,EXIT
}

' STR ( -- n ) Leave address of inline string on stack and skip to next instruction
STRLIT   word    RPOP,DUP,CFETCHINC,ZEQ,_UNTIL+3,@ALIGNW+s,AJMP

' . ( n -- ) Print the number off the stack
PRINT     word    DUP,@ZLT+s,_IF+03,w+$2D,@EMIT+s,NEGATE
' U. ( n -- ) Print an unsigned number
UPRINT    word    @LHASH+s,@HASHS+s,@RHASH+s

' PRINT$ ( adr -- ) Print the null or 8th bit terminated string - stops on null or binary
PSTR    word    CFETCHINC,DUP,w+1,w+$7E,@WITHIN+s,_IF+02,@EMIT+s,@PSTR+t
pstrxt  word    DROP2,EXIT

' CTYPE ( adr cnt -- )
CTYPE   word  SWAP,FROMS,FOR,I,CFETCH,@EMIT+s,forNEXT,EXIT

' 0PRINT ( u cnt -- ) print u with cnt digits with leading zeros
ZPRINT  word  @LHASH+s,FOR,@HASH+s,forNEXT,@RHASH+s,@PSTR+t


PRTDEC  word    w+10
' DEPPRECATED - only used by END - use .NUM from EXTEND.fth
' B. ( n base -- ) Print the number off the stack in the base specified
basePRT word    rg+base,CFETCHINC,SWAP,CSTORE,rg+base,CSTORE
        word    @LHASH+s,@HASH+s,@HASH+s,@HASH+s,@HASHS+s,@RHASH+s,@PSTR+s
        word    rg+base+1,CFETCH,rg+base,@CSTOREX+t


PRT3    word  @LHASH+s,@HASH+s,@HASH+s,@HASH+s,w+".",@HOLD+s,@HASHS+s,@RHASH+s,@PSTR+t

ELAPSED word  w+lapcnt,COGFETCH,@LAP+s,@LAP+s,w+lapcnt,COGFETCH,MINUS,_0,@_MAX+t

PRTCYC  word  @ELAPSED+s,DUP,@PRINT+s,@PRTSTR+s
        byte  " cycles at ",0
        word  @FREQ+s,w+1000,@UDIVIDE+s,w+1000,@UDIVIDE+s,@PRINT+t

PRTLAP '( -- \ prints time since last LAP )
        word  @PRTCYC+s,@PRTSTR+s
        byte  "MHz = ",0

        word  DUP,@FREQ+s,GT,_IF+09,w+1000,@FREQ+s,@UMMULDIV+s,DROP
        word  @PRT3+s,@PRTSTR+s
        byte  "sec",0
        word  EXIT
        '            1,000,000,000
        word  PUSH32,$3B9A,$CA00,@FREQ+s,@UMMULDIV+s,DROP
        '                1,000,000
        word  DUP,PUSH32,$0F,$4240-1,GT,OVER,w+31,_SHR,_OR
        word  _IF+07,w+1000,@UDIVIDE+s
PLP1    word  @PRT3+s,@PRTSTR+s
        byte  "ms ",0
        word  EXIT
        word  @PRT3+s,@PRTSTR+s
        byte  "us ",0
        word  EXIT

PRTDP   word  SWAP,@DNUM+s,@LHASH+s,FOR,@HASH+s,forNEXT,w+".",@HOLD+s,@RHASH+s,@PSTR+t

PRTHEX  ' ( n -- ) print n (0..$0F) as a hex character
        word  toNIB,w+$30,PLUS
        word  DUP,w+$39,GT,_IF+02,w+7,PLUS                      'Adjust for A..F
PRTCH   word  @EMIT+t

{HELP  .BYTE ( n -- ) print n as 2 hex characters }
PRTBYTE word  DUP,w+4,_SHR
        word  @PRTHEX+s,@PRTHEX+t


SPRTWORD
        word  w+"$",@EMIT+s
{HELP  .WORD ( n -- ) print n as 4 hex characters }
PRTWORD word  DUP,_SHR8
        word  @PRTBYTE+s
        word  @PRTBYTE+t

{HELP .LONG ( n -- ) print n as 8 hex characters }
PRTLONG word  DUP,w+16,_SHR
        word  @PRTWORD+s
        word  w+".",@EMIT+s
        word  @PRTWORD+t


DMP     word  @DMPC+t
dmpcnt  byte  1
dmpwth  byte  16
dmpspc  byte  1
dmpfmt  byte  1

RAMC    word  CFETCH,EXIT
RAMW
' : >CFA  ( bfa -- cfa )
BFACFA
WFETCHX
        word  WFETCH,EXIT
RAML
FETCHX
        word  FETCH,EXIT

' ramtbl  word  @RAMC+s,@RAMW+s,@RAML+s

RAM     word  @SETDMP+s,@RAMC+s,@RAMW+s,@RAML+s
SETDMP  word  RPOP,w+dmm,_6,CMOVE,EXIT

' DUMP display reading methods - reassign via vectors

DMPC    word  w+dmm,WFETCH,ACALL,@PRTBYTE+t
DMPW    word  w+dmm+2,WFETCH,ACALL,@PRTWORD+t
DMPL    word  w+dmm+4,WFETCH,ACALL,@PRTLONG+t
DMPCOG  word  COGFETCH,@PRTLONG+t

QDUMP   word  @entered+s,BL

' DUMP ( addr len -- )
        ' 1 spaces, 1 bytes, 16 wide
DUMP    word  w+$1110,w+@DMPC+t

' SPC(4)+BYTES(4) WIDTH(6)+FMT(2)
' DUMPX ( from cnt spaces:bytes:width+format 'method -- )
        '     force jump, set DMP vector
DUMPX   word  _1,_OR,w+@DMP+s,WSTORE
        ' ( from cnt config ) set width
        word  DUP,tobyte,DUP,_3,_ANDN,w+@dmpwth+s,CSTORE
        ' ( from cnt config width )
        word  _3,_AND,w+@dmpfmt+s,CSTORE
        ' ( from cnt config )
        word  _SHR8,DUP,toNIB,w+@dmpcnt+s,CSTORE
        word  _4,_SHR,w+@dmpspc+s,CSTORE
        ' ( from cnt -- )
DUMPS   word  SWAP,FROMS,w+@dmpwth+s,CFETCH,@UDIVIDE+s
        word  w+@dmpwth+s,CFETCH,w+@dmpcnt+s,CFETCH,@MULTIPLY+s,BY,FOR
        word    @CRLF+s
        word    I,@PRTLONG+s
        word    @PRTSTR+s
        byte    ":  ",0
        ' skip hex dump if spaces = 0
        word  w+@dmpspc+s,CFETCH,_IF+(@dm2-@dm1)/2
dm1     word    I,FROMS,w+@dmpwth+s,CFETCH,w+@dmpcnt+s,CFETCH,BY,FOR
        word      I,_3,_AND,ZEQ,_IF+01,@SPACE+s
        word      I,@DMP+s
        word      w+@dmpspc+s,CFETCH,@SPACES+s
        word      LOOP
        word  _3,@SPACES+s
        ' list ASCII characters
dm2     word  w+@dmpfmt+s,CFETCH,ZEQ,_IF+(@dm3-@dm2a)/2
dm2a    word      I,FROMS,w+@dmpwth+s,CFETCH,FOR
        word        I,w+@DMP+s,WFETCH,WFETCH,w+$7FFF,_AND,WFETCH,@EXECUTE+s,DUP,BL,ULT,OVER,w+$7E,GT,_OR
        word        _IF+02,DROP,w+".",@EMIT+s
        word      LOOP
dm3     word  LOOP
        word    @RAM+t
'        word    @CRLF+t


' CONFIG = SPC(4)+BYTES(4) WIDTH(6)+FMT(2)

' Dump ASCII
DUMPA   word  w+$0140,w+@DMPC+t,@DUMPX+t
' Dump ASCII wide
DUMPAW  word  w+$0180,w+@DMPC+t,@DUMPX+t
' Dump words
DUMPW   word  w+$2208+1,w+@DMPW+t,@DUMPX+t
' Dump long
DUMPL   word  w+$4404+1,w+@DMPL+t,@DUMPX+t
' Dump all cog memory
DUMPCOGM
        word  _0,w+$1FF
DUMPCOG word  w+$2108+1,w+@DMPCOG+t,@DUMPX+t


CLS     word    w+$0C,@EMIT+t
SPACE   word    BL,@EMIT+t
BELL    word    w+7,@EMIT+t
CR      word    w+$0D,@EMIT+t
CRLF    word    @CR+s,w+$0A,@EMIT+t

spstr   byte  "|/-\"
SPINNER word    w+spincnt,CFETCH,_3,_SHR,_3,_AND,w+@spstr+s,PLUS,CFETCH
        word  @EMIT+s,_8,@EMIT+s,_1,w+spincnt,CPLUSST,_1,@ms+t



' PROMPT
PROMPT
        word  _1,w+linenum,WPLUSST
        ' execute user prompt instead?
        word  w+uprompt,WFETCH,QDUP,_IF+01,AJMP
        ' ( 0108 $36FA  ok )
        ' No new line if this one is empty
        word  rg+emitcol,CFETCH,_IF+01
        word  @CRLF+s
        word  w+@prmid+s,@PSTR+s,@SPACE+t
prmid   byte  ".. ",0[13]


{
LPROMPT
        word  w+"(",@EMIT+s,@SPACE+s
        word  w+linenum,_1,OVER,WPLUSST,WFETCH,_4,@ZPRINT+s
        word  @SPACE+s,@HERE+s,@SPRTWORD+s,@SPACE+s
        '     change ok to ?? or ++ if in definition
        word  w+deff,@SETFLGQ+s,_IF+(@prm0-@prmx)/2     ' ok
prmx    word  w+errors,WFETCH,_IF+04                    ' ++
        word  @PRTSTR+s
        byte  " ??",0
        word  @prm1+t
        word  @PRTSTR+s
        byte  " ++",0

prm1    word  @PRTSTR+s
        byte  " )   ",0
        word  EXIT
}
{
prm0    word  @PRTSTR+s
prmid   byte  " ok",0
        word  EXIT
}


PRTSTRN word  @CRLF+s
' Print inline string
PRTSTR  word  RPOP
pstl    word  CFETCHINC,QDUP,_IF+02,@EMIT+s,@pstl+t
        word  @ALIGNW+s,AJMP


PRTSTK  word    rg+base,CFETCH,PUSHR,@DECIMAL+s
        word    @PRTSTR+s
        byte    " Data Stack (",0
        word    @DEPTH+s,@PRINT+s,w+")",@EMIT+s
        word    @DEPTH+s,_IF+(@pstk2-@pstk3)/2
        ' read from stack rather than registers, so crowd out top 4
pstk3   word    @DEPTH+s,w+datastk,OVER,PLUS,_3,PLUS,@DUP2+s
pstklp  word    @CRLF+s,w+"$",@EMIT+s,DUP,COGFETCH,DUP,@PRTLONG+s
        word    @PRTSTR+s
        byte    " - ",0
        word    @PRINT+s,DEC,SWAP,DEC,SWAP,OVER,ZEQ,_UNTIL+(@pstk1-@pstklp)/2
pstk1   word    DROP2,DROP2,@CRLF+s
pstk2   word    RPOP,rg+base,@CSTOREX+t


etbl    byte  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
'
{HELP EMIT ( char -- )  Emit a character to the terminal or to an other output device defined by setting an alternative output routine to the uemit vector. }
EMIT
        ' substitute control characters
        word    DUP,w+16,SWAP,GT,_IF+03,w+@etbl+s,PLUS,CFETCH
        ' synch to ping-pong emit if enabled
EMITR
        word    w+emitreg+3,CFETCH,_IF+07,w+emitreg,WFETCH,ZEQ,_UNTIL+07
        ' echo to ping-pong
        word    DUP,w+emitreg,WSTORE
        ' track X position of output
        word    DUP,w+$1F,GT,_IF+03,_1,rg+emitcol,CPLUSST
        ' reset X on a CR
        word    DUP,w+$0D,EQ,_IF+02,rg+emitcol,@CCLR+s
        ' redirect?
        word    rg+uemit,WFETCH,QDUP,_IF+01,AJMP       ' execute user EMIT if vector is non-zero
        ' otherwise use default serial console emit
        word    pEMIT,EXIT

TABS    word  @SPACES+s
ATAB    word  @SPACE+s,rg+emitcol,CFETCH,_7,_AND,ZEQ,_UNTIL+07,EXIT
' XTAB ( pos -- )
XTAB    word   @SPACE+s,rg+emitcol,CFETCH,OVER,GT,_UNTIL+06,@DROPEX+t
'       SPACES ( cnt -- \ print many spaces )
SPACES  word  BL,SWAP
        ' EMITS ( ch cnt -- \ emit the same character many times )
EMITS   word  QDUP,_IF+04,FOR,DUP,@EMIT+s,forNEXT
        word  @DROPEX+t


ECHOKEY word  @WKEY+s,DUP
' ?EMIT ,( ch --  ) suppress emitting the character if echo flag is off
QEMIT   word  w+echof,@SETFLGQ+s,_IF+01,@EMIT+t,@DROPEX+t



' DEPTH ( -- levels )
DEPTH   word  w+udepth,COGFETCH,DEC,EXIT

FREQ    word  _0,@FETCHX+t


' ****************************************************************************************

' C~
CCLR    word  _0,SWAP
CSTOREX word  CSTORE,EXIT
' W~
WCLR    word  _0,SWAP
WSTOREX word  WSTORE,EXIT
' ~ ( addr -- ) Clear the long to zeros
LCLR    word  _0,SWAP
STOREX  word  STORE,EXIT


' 0< ( n -- flg )
ZLT     word  w+31,_SHR
' 0<> ( val -- flg )
ZNE     word  ZEQ,ZEQ,EXIT
' <> ( n1 n2 -- flg )
NEQ     word  EQ,ZEQ,EXIT

' U> ( n1 n2 -- flg )
UGT     word  SWAP
ULTX    word  ULT,EXIT
' < ( n1 n2 -- flg )
LT      word  SWAP,GT,EXIT

' ( n lo hi -- flg ) true if n is within range of low and high inclusive
WITHIN  word  INC,OVER,MINUS,PUSHR
        word  MINUS,RPOP,@ULTX+t


MINMAX  word  @DUP2+s,GT,ZEXIT,SWAP,EXIT

'pub MIN ( n1 n2 -- n3 ) --- signed minimum of two items
_MIN 	word  @MINMAX+s,@DROPEX+t

'pub MAX ( n1 n2 -- n3 ) --- signed maximum of two items
_MAX 	word  @MINMAX+s,@NIPEX+t


' SET ( mask caddr -- ) Set bit(s) in hub byte
SET     word  DUP,CFETCH,ROT,_OR
SCST    word  SWAP,@CSTOREX+t

' CLR ( mask caddr -- ) Clear bit(s) in hub byte
CLR     word  DUP,CFETCH,ROT,_ANDN,@SCST+t

' SET? ( mask caddr -- flg ) Test single bit of a byte in memory
SETQ    word  CFETCH,_AND,@ZNE+t


{ *** MOVES & FILLS *** }
' <CMOVE ( src dst cnt -- ) byte move in reverse from the ends to the start
RCMOVE  word  ROT,OVER,PLUS,DEC,ROT,THIRD,PLUS,DEC,ROT,pRCMOVE,EXIT

' ( addr cnt -- )
ERASE   word  _0
' ( addr cnt fillch -- )
FILL    word  THIRD,CSTORE,DEC,OVER,INC,SWAP,CMOVE,EXIT




{ *** OPERATORS *** }
{
CLKFREQ 1234 LAP U/MOD LAP .LAP  16.600us ok
. 64829 ok
. 1014 ok
}
' U/MOD ( u1 u2 -- rem quot )
UDIVMOD word  w+0,ROT,ROT,UMDIVMOD32,@DROPEX+t

' U/ ( u1 u2 -- quot )
UDIVIDE word  @UDIVMOD+s
NIPEX   word  SWAP
DROPEX  word  DROP,EXIT


' */ ( u1 u2 div1 -- res )
' CLKFREQ 1.333333 1,000,000 LAP */ LAP .LAP  35.200us ok
MULDIV  word  ROT,ROT,UMMUL,ROT,UMDIVMOD64,DROP,@NIPEX+t

' *
MULTIPLY
        word  UMMUL,DROP,EXIT

' pub /  ( n1 n2 -- n3 ) 					\ 18us signed divide (org 47us) vs 10us U/
DIV  	word  OVER,_ABS,OVER,_ABS,@UDIVIDE+s
 	word  ROT,ROT,_XOR,w+31,_SHR,QNEGATE,EXIT				' now get signs set result accordingly

' pub UM*/ ( u1 u2 u3 -- Du1*u2/u3 )
UMMULDIV
        word  ROT,ROT,UMMUL,ROT,UMDIVMOD64,ROT,@DROPEX+t









DAT ' ------------------------------------ CONSOLE INPUT ----------------------------------------


{
' ?EXIT ( flg -- ) Exit if flg is true
IFEXIT  byte    _IF,02,RPOP,DROP,EXIT
}
'' The read and write index is stored as two words preceding the buffer
'' BKEY ( buffer -- ch ) ' byte size buffer is preceded with a read index, go and read the next character
'
' READBUF ( buffer -- ch|$100 )
READBUF
        word    DUP,@SUB2+s,DUP,WFETCH                                          ' point to read index ( buffer writeptr writeindex )
        word    SWAP,@SUB2+s,WFETCH,SWAP                                        ' ( buffer readindex writeindex )
        word    OVER,EQ,_IF+02,DROP2,@FALSEX+t                                    ' empty, return with null
        ' ( buffer read )
        word    OVER,PLUS,CFETCH                                                '  get (buf+rd) character from buffer
        ' perform auto LF to CR subs (but not when it is part of a CRLF )
        word    DUP,w+$0A,EQ
        word    w+prevch,CFETCH,w+$0D,@NEQ+s,_AND
        word    _3,_AND,PLUS                                                    ' convert the LF to a CR
'
        word    w+prevch,CFETCHINC,SWAP,CSTORE
        word    DUP,w+prevch,CSTORE
        word    w+$0100,PLUS                                               ' get char ( buffer [buffer+read]+$100 )
        word    SWAP,_4,MINUS                                                   ' key readptr )
        word    DUP,WFETCH,INC                                                  ' update read index and wrap
'        word    DUP,w+rxsz,WFETCH,DEC,GT,_IF+02,DROP,_0
        word  w+rxsize-1,_AND
'        word    toBYTE
        word  SWAP,@WSTOREX+t

' KEY! ( ch -- ) Force a character as the next KEY read
PUTKEY  word    w+keychar,@CSTOREX+t

' KEY ( -- ch ) if ch is zero then no key was read
KEY     word    w+keychar,CFETCH
        ' read a "key" that was forced with KEY!
        word    QDUP,_IF+03,w+keychar,@CCLR+s,@CHKKEY+t
        ' or be redirected to a user key routine?
        word    rg+ukey,WFETCH,QDUP,_IF+02,ACALL,@CHKKEY+t
        ' else read from console as default
CONKEY  ' this returns with a character with b8 = $100 ? set or a false
        word    w+rxptr,WFETCH,@READBUF+s,DUP,_IF+(@DOPOLL-@cka)/2 '+15
cka     word    toBYTE,DUP,ZEQ,_IF+02,w+$0100,PLUS
        ' keep a track of the position of the this key on the input line (useful for assembler etc)
CHKKEY  word    _1,rg+keycol,CPLUSST,DUP,w+$0D,EQ,ZEXIT,rg+keycol,@CCLR+t

        ' background polling while waiting for a key
DOPOLL  word    w+keypoll,WFETCH,QDUP,_IF+01,AJMP,EXIT

' WKEY ( -- ch ) wait for a key and return with character
WKEY    word    @KEY+s,QDUP,_UNTIL+03,toBYTE,EXIT


' LASTKEY ( -- adr )
'LASTKEY word   w+rxptr,WFETCH,DUP,@SUB2+s,WFETCH,DEC,toBYTE,PLUS,EXIT














' ------------------------------------ DICTIONARY ----------------------------------------

{HELP HERE ( -- addr ) Address of next compilation location }
HERE   word    w+uhere,@WFETCHX+t


' SEARCH ( cstr -- nfaptr )                     ' cstr points to the count+string+null
SEARCH
        ' search core words first to improve compilation speed
'''        word    DUP,v+corenames,WFETCH,@FINDSTR+s
        ' found it - return now with result
'''        word    QDUP,_IF+01,@NIPEX+t
        ' search extended dictionary
        word  _NOP ' <---- gets replaced with jump to FFSTR for fast search
        word  DUP,@ATNAMES+s
' use REVECTOR to first dummy word of SEARCH to revector
'        word  w+ufind,WFETCH,QDUP,_IF+01,AJMP
        ' normal method
        word  @FINDSTR+s
        ' return with positive result ( cstr res )
        word   QDUP,_IF+08,@NIPEX+t
        ' not found in dictionary
'        word  DROP,_FALSE,EXIT
FFSTR   word  DUP,@ATNAMES+s

        word  @LOADFF+s,RUNMOD
        word  QDUP,_IF+01,@NIPEX+t
        word  DROP
FALSEX  word  _FALSE,EXIT

' ( cstr dict -- nfaptr | false ) Try to find the counted string in the dictionary(s) using CMPSTR  (ignore smudged entries)
FINDSTR
        word  @CHKCASE+s,_IF+11,OVER
        word   INC,DUP,CFETCH,@TOUPPER+s,DUP,THIRD,CSTORE,ZEQ,_UNTIL+09,DROP

fstlp   word  OVER,OVER,@CMPSTR+s,_IF+08
        ' found it, check the atr  ( src dict )
        word  DUP,@ADDCNT+s,CFETCH
        word  w+sm,_AND,ZEQ,_IF+01,@NIPEX+t     ' ( nfaptr ) found
        ' not found
        ' Skip the attribute byte and codes and test for end of dictionary (entry = 00)
nxtword ' ( src dict ) advance past atr+codes to try next.  (atr(1),bytecode)
        ' jump over CFA to next NFA --- cnt <name> ATR x WORDCODE
        word  @ADDCNT+s,_3,PLUS,@ALIGNW+s
        ' ( src dict ) dict points to bc1
        word  DUP,WFETCH,ZEQ
        word  _UNTIL+(@fstx-@fstlp)/2
        ' end of dictionary reached
fstx    word  DROP2,@FALSEX+t

' CMPSTR ( src dict -- flg )
CMPSTR
        word   SWAP,CFETCHINC,ROT,CFETCHINC,@TOUPPER+s,ROT          ' ( src+ dict+ (src) (dict) )
        word   @NEQ+s,_UNTIL+08
        word  SWAP,DEC,CFETCH,ZEQ
        word  SWAP,DEC,CFETCH,_7,_SHR,_AND,EXIT

TOUPPER ' ( ch -- ch )
        word  @CHKCASE+s,ZEXIT
        word DUP,w+"a",w+"z",@WITHIN+s,_IF+02,w+$20,MINUS,EXIT

CHKCASE word  w+anycase,w+flags+1,@SETQ+s,ZEQ,EXIT





{ name/code address conversion


}
'
' memory access methods which are revectored in EXTEND to include EEPROM
'
MCFETCH word  CFETCH,EXIT
MWFETCH word  WFETCH,EXIT
MCFTINC word  CFETCHINC,EXIT
'
' BFA is the address of the wordcode stored in the header that is executed or compiled
' NFA points to the first byte
' NFA>BFA ( nfa -- bfa )
'

' CFA>NFA ( wordcode -- nfa )
CFANFA  word  @ATNAMES+s
cnlp    word  DUP,@MCFETCH+s,ZEQ,_IF+02,DROP2,@FALSEX+t
        word  DUP,@NFABFA+s,@MWFETCH+s,THIRD
        word  EQ,_IF+01,@NIPEX+t
        word  @NFANFA+s,@cnlp+t

NFANFA  word  @ADDCNT+s,_3,PLUS,@ALIGNW+t

' point to the atr, then word aligned wordcode - cnt.<name>,atr,<x>,wordcode
NFABFA  word  @NFAATR+s,INC
ALIGNW  word  INC,_1,_ANDN,EXIT
ALIGNL  word  _3,PLUS,_3,_ANDN,EXIT

ADDCNT
NFAATR  word  @MCFTINC+s,@PLUSX+t





' : W	CR names W@ BEGIN SPACE DUP C@ OVER 1+ C@ OR WHILE DUP C@ ?DUP IF OVER 1+ SWAP ADO I C@ EMIT LOOP C@++ + 3 + ELSE 1+ THEN REPEAT 2DROP ;
' list dictionary words (basic kernel version)
WORDS   word  @PRTSTRN+s
        byte  " DICTIONARY WORDS @",0
        word  @ATNAMES+s,DUP,@PRTWORD+s,@SPACE+s
        word  @CRLF+s
wdlp    word  @SPACE+s,DUP,CFETCH,OVER,INC,CFETCH,_OR,_IF+(@wd05-@wd01)/2
wd01
        word  DUP,CFETCH,QDUP,_IF+(@wd03-@wd02)/2
wd02    word  OVER,INC,SWAP,@CTYPE+s
        word  @NFANFA+s,@wd04+t                              '_ELSE+(@wd04-@wd03)/2
wd03    word  INC
wd04    word  @wdlp+t
wd05    word  DROP2,@CRLF+t



' VER ( -- verptr )
'GETVER  word    w+@version+s,EXIT

' .VER
PRTVER  word    @PRTSTR+s
        byte    "  Propeller .:.:--TACHYON--:.:. Forth V",0
        word    w+@version+s+6,w+8,@CTYPE+s,@SPACE+s
        word    w+@version+s,DUP,FETCH,@PRTDEC+s
        word    w+".",@EMIT+s,PLUS4,WFETCH,@PRTDEC+t
'        word    @CRLF+t


DAT { *** COMMENTING *** }

'       \       ( -- )
'       Ignore following text till the end of line.
'       IMMED
COMMENT
        word  rg+inpkey,CFETCH,w+$0D,@NEQ+s,ZEXIT
        word  @KEY+s,w+$0D,EQ,_UNTIL+4        ' terminate comment on a CR
        'word  @CRLF+t
         word  w+$0D,@PUTKEY+t       ' force a CR back into the key stream on exit
'       (       stack or other short inline comments )
BRACE   word  @ECHOKEY+s,w+")",EQ,_UNTIL+4,EXIT

IFDEF   word @NFATICK+s,ZEQ,@QDEF+t
IFNDEF  word  @NFATICK+s
QDEF    word  ZEXIT
' {     Block comments - allow nested {{  }} operation
CURLY   word  _1,rg+braces,CSTORE                ' allow nesting by counting braces
CURLYlp word  @WKEY+s             ' keep reading each char until we have a matching closing brace
        word  DUP,w+$0D,EQ,_IF+03,_1,w+linenum,WPLUSST
        word  DUP,w+"{",EQ,_IF+03,_1,rg+braces,CPLUSST  ' add up opening braces
        word  w+"}",EQ,_IF+03,MINUS1,rg+braces,CPLUSST  ' count down closing braces
        word rg+braces,CFETCH,ZEQ,_UNTIL+25,EXIT




DAT { *** COMPILER *** }


        '     ****** EXECUTE CODE from user input ******
        '
        ' done - append an EXIT (minimum action on empty lines)
GRAB    word    w+EXIT,@WCOMP+s
        ' execute from beginning
reex    word    @HERE+s,ACALL

termcr  word  @HERE+s,w+uthere,WSTORE
        word  EXIT
ACCEPT
        ' execute valid accept vector
        word  w+uaccept,WFETCH,QDUP,_IF+01,AJMP
        word  @PRTSTR+s
        byte  " ok",0
        word  EXIT

EXECUTE ' ( wordcode -- )
        word    w+@bcexec+s,WSTORE
bcexec  word    EXIT,EXIT

ATTHERE  word  w+uthere,@WFETCHX+t

' WORDCODE COMPILE
' ( wordcode -- ) append this wordcode to next free code location + append EXIT (without counting)
WCOMPK   word  DUP,w+ucomp,WSTORE                       ' track last word compile for exit optimizer

WCOMP   word  @ATTHERE+s,_2,@ALIGN+s,w+uthere,WSTORE
        word  @ATTHERE+s,WSTORE,_2
NCOMP   word  w+uthere,WPLUSST
        ' compile an EXIT to the end of any code without allocating memory
        word  w+EXIT,@ATTHERE+s,@WSTOREX+t



BCOMP
        word    @ATTHERE+s,CSTORE,_1,w+uthere,WPLUSST
        word    _0,@ATTHERE+s,@CSTOREX+t

LITCOMP ' ( n -- ) compile the literal according to size
        ' test for -1 and compile as code instead
        word  DUP,INC,ZEQ,_IF+03,DROP,w+MINUS1,@WCOMP+t
        word  DUP,w+15,_SHR,_IF+(@LIT15-@LCOMP)/2
        ' compile a word or a long
LCOMP   word  DUP,w+16,_SHR,_IF+07
LIT32   word  w+PUSH32,@WCOMPK+s,DUP,_SHR8,_SHR8,@WCOMP+s,@WCOMP+t
LIT16   word  w+PUSH16,@WCOMPK+s,@WCOMP+t
        ' else 15-bit compact literal
LIT15   word  PUSH16,$8000,_OR,@WCOMPK+t


_BCOMP  word  @GRAB+s,w+oddbc,@SETFLGQ+s
        word  _IF+06,@HERE+s,DEC,CSTORE
BCCLR   word  w+oddbc,w+flags,@CLR+t
        word  @WCOMP+s,w+oddbc,@SETFLG+s,@ALLOCATED+t

_WCOMP  word  @GRAB+s,@WCOMP+s,@ALLOCATED+t

_LCOMP  word  @GRAB+s,w+ucomp,@WCLR+s
        word  @ATTHERE+s, _4,@ALIGN+s '@ALIGNL+s
        word  w+uthere,WSTORE
        ' save long into code memory
        word    @ATTHERE+s,STORE
        word  _4,@NCOMP+s,@ALLOCATED+t



' ALLOT ( bytes -- )
ALLOT   word    w+uthere,WPLUSST
' lock in compiled code so far - do not release but set new "here" to the end of these codes
ALLOCATED
        word    @ATTHERE+s,w+uhere,@WSTOREX+t


ATNAMES word  w+names,@WFETCHX+t


' NFA' ( <name> -- nfaptr )
' COMPILE  ( not used in this version )
NFATICK word  @GETWORD+s,DEC,@SEARCH+s,@CLRWORD+t


' [']
ATICK   word  @NFATICK+s,DUP,ZEXIT,@NFABFA+s,@WFETCHX+t

' ' <name>  ( -- pfa ) Find the address of the following word - zero if not found or it's PFA (bytecodes do not have a CFA)
TICK    word  @ATICK+s,@LITCOMP+t



' " string"     Compile a literal string - no length restriction - any codes can be included except the delimiter "
_STR_   word    w+@STRLIT+s,@WCOMPK+s,@COMPSTR+t

' PRINT" HELLO WORLD"   Compile a literal print string - no length restriction - any codes can be included except the delimiter "
COMPPRTS
        word    w+@PRTSTR+s,@WCOMPK+s
' compile string itself + term
COMPSTR word    rg+temp,@WCLR+s
CSLP    word    rg+temp,CFETCHINC,SWAP,CSTORE
        word    @STRKEY+s,DUP,rg+temp,CSTORE
        '       terminate on a "TAB
        word    rg+temp,WFETCH,w+$2209,@NEQ+s
        ' terminate on a "CR
        word    rg+temp,WFETCH,w+$220D,@NEQ+s,_AND
        ' terminate on a "SPACE
        word    rg+temp,WFETCH,w+$2220,@NEQ+s,_AND,_IF+02
        word    @BCOMP+s,@CSLP+t
        ' terminate string
        word    @PUTKEY+s
        word    @ATTHERE+s,DEC,@CCLR+s
        ' ensure end is word aligned
        word  @ATTHERE+s,_1,_AND,ZEXIT,_0,@BCOMP+t

' EMBEDEDDED CONTROL SEQUENCES IN STRINGS \n \r \t
' this routine reads keys and preprocesses them for building the string
STRKEY  word    @ECHOKEY+s,DUP,w+"\",EQ,ZEXIT                           ' return immediately if not \
        word    DROP,@ECHOKEY+s
' hex literal
        word    DUP,w+"$",EQ,_IF+12                                ' process hex number \$XX
        word    DROP,_1,_2,FOR,_4,_SHL,@ECHOKEY+s                           ' 2 seq hex nibbles
        word    @TODIGIT+s,_AND,_OR,forNEXT,EXIT                            ' non hex = 0, ret with $1xx
' optional checks for special C style string control charactes
        word    DUP,w+"n",EQ,_IF+02,w+$0A,@NIPEX+t                     ' newline
        word    DUP,w+"r",EQ,_IF+02,w+$0D,@NIPEX+t                     ' line return
        word    DUP,w+"t",EQ,_IF+02,w+09,@NIPEX+t                     ' tab
' default passthrough
        word    w+$100,_OR,EXIT                                    ' return with any other character+$100 (prevent exit, same byte still)

TODIGIT ' ( char -- val flg )
        word  DUP,w+"0",w+"9",@WITHIN+s,_IF+04             ' only work with 0..9,A..F
        word  w+"0",MINUS,_TRUE,EXIT              ' pass decimal digits
        word  DUP,w+"A",w+"F",@WITHIN+s,_IF+04
        word  w+$37,MINUS,_TRUE,EXIT              ' pass hex digits
        word  @FALSEX+t





' ( ch -- ) write a character into the next free position in the word buffer
PUTCHAR word    rg+wordcnt,CFETCHINC,SWAP,PLUS,@CSTOREX+t

PUTCHARPL
        word    @PUTCHAR+s,rg+wordcnt,DUP,CFETCH,INC
        word    w+wordsz,@UDIVMOD+s,DROP,SWAP,@CSTOREX+t

' Add a wordcode to the word aligned end of the wordbuf
PUTWORDPL ' ( wordcode -- )
        word  rg+wordcnt,CFETCHINC,SWAP,PLUS,@ALIGNW+s,SWAP,OVER,WSTORE
        word  PLUS2,rg+wordcnt,MINUS,rg+wordcnt,@CSTOREX+t


' Build a delimited word in wordbuf for wordcnt and return immediately upon a valid delimiter
' GETWORD ( -- str )
GETWORD
        word  @CLRWORD+s
gwlp    word  @ECHOKEY+s,DUP,BL,GT,_IF+(@gw1-@gw0)/2
gw0     'word  DUP,w+"a",w+"z",@WITHIN+s,_IF+02,w+$20,MINUS
        word  @PUTCHARPL+s,@gwlp+t                                             ' get another character
'gw1     word  w+$0D,EQ,_IF+01,@CRLF+s,rg+wordbuf,EXIT
gw1     word  w+$0D,EQ,_IF+02,w+$0D,@PUTKEY+s,rg+wordbuf,EXIT


DAT { *** CREATE DEFINITIONS *** }

{
NAMES

6CB6:  02 58 31 80 00 E6 9D 02 58 59 80 00 D2 84 03 44    .X1.....XY.....D
6CC6:  55 50 80 00 29 00 04 4F 56 45 52 80 2C 00 04 44    UP..)..OVER.,..D

}
CREATEWORD
        word    @GETWORD+s,DROP                          ' ( str ) read the next word
'  CREATENAME - create a name in the dictionary from wordcnt+wordbuf
CREATENAME ' (  wordcode -- )
        word  @BCCLR+s                                  ' relinquish odd byte recovery
'        word  @ATNAMES+s,w+prevname,WSTORE            ' backup names ptr (used to change fixed fields easily)
        word  w+flags,CFETCH,w+prset,_AND             ' get attribute
        word  w+hd,_OR                                 ' blend in private bit
        ' add attribute byte to header => cnt,name,atr
        word  @PUTCHARPL+s
        ' wordbuf = cnt,name,atr,x,worcode
        word  @PUTWORDPL+s
 '''       word  _1,rg+wordcnt,CPLUSST
 ''' word   rg+wordcnt,_16,@DUMP+s
        ' get total length of new header
        word  rg+wordcnt,CFETCH
        ' update names ptr backwards
        word  DUP,NEGATE,w+names,WPLUSST
        ' copy header across to dictionary
        word  rg+wordcnt,@ATNAMES+s,ROT,CMOVE
        ' fix up name count
        word  @ATNAMES+s,DUP,INC,STRLEN,SWAP,CSTORE
        ' check for dictionary full
        word  @ATNAMES+s,w+uhere,WFETCH,w+$40,PLUS,ULT                     'SWAP,GT
        word  _IF+(@crw05-@crw04)/2
crw04   word  @PRTSTR+s
        byte  "  Dictionary full! ",0
        word  @ERROR+s
crw05   word  @CLRWORD+t

{
VARIABLE
        word  RPOP,EXIT
}
' : LONGA		@org W@ 4 ALIGN org ;
' ALIGN ( address align -- val00  ) n = 0 is byte align, n = 1 is word align, n = 2 is long align )
ALIGN   word  DEC,SWAP,OVER,PLUS,SWAP,_ANDN,EXIT

VALIGN  word  w+datorg,WFETCH,SWAP,@ALIGN+s
VORG    word  w+datorg,@WSTOREX+t
VBYTES  word  @GRAB+s,@AVAR+t
VWORD   word  _1
VWORDS  word  _2,@VALIGN+s,@GRAB+s,_SHL1,@AVAR+t

VLONG   word  _1
VLONGS  word  _4,@VALIGN+s,@GRAB+s,_SHL2,@AVAR+t
VBYTE   word  _1
AVAR    word  w+datorg,DUP,WFETCH,ROT,ROT,WPLUSST
' CONSTANTS
ACON    word  @GETWORD+s,DROP        'w+@ACON1+s,@setword+t
ACON1   word  @UNSMUDGE+s,@GRAB+s
        word  DUP,w+15,_SHR
        word  _IF+07,@HERE+s,SWAP,@LCOMP+s,w+EXIT,@WCOMPK+s,@CREATENAME+s,@ALLOCATED+t
        'ELSE create a 15-bit wordcode constant
        word  w+15,MASK,_OR,@CREATENAME+t


COLON   word  w+ucomp,@WCLR+s,@NEWPUB+s
        word  @GETWORD+s,DROP
{
        word  w+@COLON1+s
setword word  w+uword,WSTORE,EXIT
}
' Create a new entry in the dictionary but also prevent any execution of code
' at an <enter> which would otherwise normally occur.
' unsmudge any previous name in case this is a fall-through.
' : <name>
        ' unsmudge any previous definition (fall-through)
COLON1  word  @UNSMUDGE+s,@HERE+s,@CREATENAME+s
        ' smudge it so it can't be referenced yet
_COLON  word  w+sm,@ATATR+s,@SET+s
        ' write over VAR instruction
'''        word  MINUS1,@ALLOT+s
        ' flag that we have entered a definition
        word  w+deff
SETFLG  word  w+flags,@SET+t

SETFLGQ word  w+flags,@SETQ+t

PUBDEF  word  @COLON+s,w+prset,@ATATR+s,@CLR+t

IMMDEF  word  @PUBDEF+s,w+im,@ATATR+s,@SET+t

' Compile an EXIT normally but if the previous wordcode allows for a JUMP bit then use that method
aRETURN
        word  w+ucomp,WFETCH,DUP,w+$200,w+varram,@WITHIN+s,SWAP,_1,_AND,ZEQ,_AND
        word  _IF+13,@ATTHERE+s,@SUB2+s,DUP,WFETCH
        word  DUP,_SHR8,_IF+05,_1,_OR,SWAP,WSTORE,@NEWPUB+t
        word  DROP2
        word  w+EXIT,@WCOMPK+s,@ALLOCATED+t

' Update "here" pointer to point to current free position which "codes" pointer is now at
' Also unsmudge the headers tag
' ;
ENDCOLON
        ' compile an EXIT
'        word  @ATTHERE+s,@SUB2+s,DUP,WFETCH,w+$200,w+varram,@WITHIN+s
'        word  _IF+07,DUP,WFETCH,_1,_OR,SWAP,WSTORE,@NEWPUB+t
        ' just make the last call a jump if possible in which case skip compiling an EXIT
        word  @aRETURN+s
NEWPUB
        ' end definition and lock allocated bytes
        word  w+deff,w+flags,@CLR+s,@ALLOCATED+s
UNSMUDGE
        ' clear the smudge bit
        word  w+sm,@ATATR+s,@CLR+t

' ( -- atradr ) --- point to the attribute byte in the header of the latest name
ATATR   word  @ATNAMES+s,@NFAATR+t

' Set attribute of the latest word to PRIVATE -- used by RECLAIM (EXTEND.fth) to cull all unwanted headers.
PRIDEF word  @COLON+s,w+pr,@ATATR+s,@SET+t


' [COMPILE]
COMPILES
        word  w+comp,@SETFLG+t









' SCRUB --- scrub out any temporary compiled code, restore the code pointers etc.
SCRUB   word  @HERE+s,w+uthere,WSTORE
        word  @CLRWORD+s
        'restore end-of-line delimiter to a CR
'        word  w+$0D,w+delim+1,CSTORE
        'horizontal line
        word  @CR+s
        word  w+"-",w+80,@EMITS+t

ESC     word  @SCRUB+s,@PROMPT+t

' Discard the current line
DISCARD
        ' wait until there is no more input
        word  @KEY+s,ZEQ,_UNTIL+03
        ' then wait 100ms and restart if there is
        word  w+100,@ms+s,@KEY+s,ZEQ,_UNTIL+08,EXIT



BYT     word  @PRTSTR+s
        byte  " = ",0
        word  @PRINT+s,@PRTSTR+s
        byte  " bytes ",0
        word  EXIT

PRTFREE
        word  @PRTSTRN+s
        byte  "FREE:",0
        word  w+5,@SPACES+s
        word  @ATNAMES+s,@HERE+s,MINUS,@BYT+t

QSTATS

        word  @PRTSTRN+s
        byte  "CODE:",0
        word  @HERE+s,@SPRTWORD+s,@HERE+s,w+$200,MINUS,@BYT+s
        word  @PRTSTRN+s
        byte  "NAME:",0
        word  @ATNAMES+s,@SPRTWORD+s,w+varram,@ATNAMES+s,MINUS,@BYT+s
        word  @PRTSTRN+s
        byte  "DATA:",0
        word  w+datorg,WFETCH,DUP,@SPRTWORD+s,w+datram,MINUS,@BYT+s

        word  @PRTFREE+s
        word  @CRLF+s,@PRTSTK+s
        word  @CRLF+t

DEBUG   word  @PRTSTK+s
        word  @PRTSTRN+s
        byte  "HERE ",0
        word  @HERE+s,w+16,@DUMPW+s
        word  @PRTSTRN+s
        byte  "NAMES",0
        word  @ATNAMES+s,w+32,@DUMP+s

        word  @PRTSTRN+s
        byte  "COMMON ",0
        word  w+0,w+$80,@DUMPW+s

        word  @PRTSTRN+s
        byte  "REGISTERS",0
        word  rg+0,w+$40,@DUMPW+t






DAT { *** CONSOLE KEY PROCESSING *** }

BLOCK   word  _0,w+$7FFE,@DUMP+t

getkey  word  rg+inpkey,CFETCH,EXIT
aschex  word  toBYTE
        word  DUP,w+$60,GT,_IF+02,w+$20,MINUS
        word  DUP,w+$40,GT,_IF+02,w+7,MINUS,w+$30,MINUS,EXIT

UDUMP   word  rg+0,w+$100,@DUMP+t

ECHOK    word  rg+inpkey,CFETCH,@QEMIT+t

' number key - build number but still treat character as word
lnk
numkey  word  @ECHOK+s,@getkey+s
        word  @aschex+s,rg+inpnum,FETCH,rg+inpbase,CFETCH
        word  UMMUL,DROP,PLUS,rg+inpnum,STORE
nk1     word  _1,rg+inpdgt,CPLUSST,@ak2+t



' replace tab with space
tab     word  @ECHOK+s,BL,rg+inpkey,CSTORE,@edlm+t


' CR TERMINATOR

enter   word  @dlm+s,@SPACE+s
        word  @ATTHERE+s,@HERE+s,@NEQ+s,rg+wordcnt,CFETCH,@ZNE+s,_OR
        word  w+deff,w+flags,@SETQ+s,_NOT,_AND,_IF+02
entered
        ' executes whole line
        word  @GRAB+s,@ACCEPT+s
        word  @wipe+s,@PROMPT+t


' SPACE DELIMITER
edlm    word  @ECHOK+s
' delimiter - reset A-F and inpnum and wordbuf
dlm     ' skip any checks if wordbuf is empty
        word  rg+wordcnt,CFETCH,ZEXIT
        ' execute uword vector if set
'        word  w+uword,DUP,WFETCH,SWAP,@WCLR+s,QDUP,_IF+02,ACALL,@dlm1+t
        word  w+@dp+s,w+".",_1,@setkey+s
        ' check if digit count = character count
        word  rg+inpdgt,CFETCH,QDUP,_IF+(@NOTNUM-@an2)/2
        ' allow negative symbol to precede
an2     word  rg+wordbuf,CFETCH,w+"-",EQ,_1,_AND,SWAP
        word  rg+inpsep,CFETCH,PLUS,PLUS,rg+wordcnt,CFETCH
        word  EQ,_IF+(@NOTNUM-@an3)/2
        ' just compile a number without checking futher (combine with secnum for ip style nums)
an3     word  rg+inpnum,FETCH,rg+secnum,FETCH,PLUS
        word  rg+wordbuf,CFETCH,w+"-",EQ,QNEGATE
anum    word  @LITCOMP+s,@dlm1+t

        ' otherwise try to find this word in the dictionary
NOTNUM
        word  rg+wordcnt,@SEARCH+s,QDUP,_IF+(@unknown-@dlm0)/2
        ' read wordcode and check immediate atr
dlm0    word  DUP,@NFABFA+s,WFETCH,w+im,ROT,@NFAATR+s,@SETQ+s
        word  w+comp,w+flags,@SETQ+s,ZEQ,_AND                       ' and comp flag off (not forced to compile with [COMPILE])

        ' ( wordcode imm ) immediate executes
        word  _IF+02,@EXECUTE+s,@dlm1+t
        ' otherwise compile
        word  @WCOMPK+s,w+comp,w+flags,@CLR+s

        ' reset variables for next word
dlm1    word  @setdef+s,@setdec+s
        ' wipe number and word buffers
wipe    word  rg+inpnum,w+12,@ERASE+s           ',rg+inpdgt,@WCLR+s
CLRWORD word  rg+wordcnt,w+wordsz,@ERASE+t

'             UNKNOWN WORD - TEST FOR SPECIAL CHARACTER PREFIX ^X or 'X'
unknown
        word  rg+wordbuf,CFETCH,w+"^",EQ,rg+wordcnt,CFETCH,_2,EQ,_AND,DUP
        word  rg+wordbuf,CFETCH,w+"'",EQ,rg+wordcnt,CFETCH,_3,EQ,_AND
        word  _OR,_IF+07
'              read character               mask as control
        word  rg+wordbuf+1,CFETCH,SWAP,_IF+02,w+$1F,_AND,@anum+t

'
        word  DROP,rg+undef,WFETCH,QDUP,_IF+01,ACALL
        word  @PRTSTR+s
        byte  " ??? ",0
        word  w+deff,w+flags,@SETQ+s,_IF+(@unk1-@unk)/2
unk     word  @PRTSTR+s
        byte  "in ",0
        word  @ATNAMES+s,CFETCHINC,@CTYPE+s
        word  @PRTSTR+s
        byte  " at ",0
        word  rg+wordbuf,@PSTR+s,@SPACE+s,w+$10A,@EMIT+s
unk1    word  _1,w+errors,WPLUSST,@dlm1+t

        ' don't backspace on empty wordS
bs      word  rg+wordcnt,CFETCH,_IF+(@bksp3-@bksp2)/2
        ' backspace sequence
bksp2   word  @PRTSTR+s
        byte  $08,$20,$08,00
        word  rg+inpdgt,CFETCH,_IF+03,MINUS1,rg+inpdgt,CPLUSST
        ' correct wordcnt and wordbuf
        word  MINUS1,rg+wordcnt,CPLUSST
        word  _0,@PUTCHAR+t
        ' else can't backspace anymore, bell
bksp3   word  _7,@EMIT+t

setkey  word  SWAP,FROMS,FOR,DUP,I,_SHL1,w+@keyactions+s,PLUS,WSTORE,LOOP,@DROPEX+t

'

ampkey  word  @setdec+s,@rk+s
setamp  word  w+@amp+s,w+".",_1,@setkey+t
amp     word  @RK+s,rg+inpnum,FETCH,rg+secnum,FETCH,PLUS
        word  _SHL8,rg+secnum,STORE,rg+inpnum,@LCLR+t


hexkey  word  @rk+s
sethex  word  w+@numkey+s,w+"A",_6,@setkey+s,w+16,@setib+s
        word  w+@lnk+s,w+"a",_6,@setkey+s,w+16,@setib+t

deckey  word  @rk+s
setdec  word  w+@ak+s,w+"A",_6,@setkey+s,w+10,@setib+s
        word  w+@ak+s,w+"a",_6,@setkey+s,w+10,@setib+t

binkey  word  @rk+s
setbin  word  w+2,@setib+t

setdef  word  rg+base,CFETCH
setib   word  rg+inpbase,CSTORE
Noop    word  EXIT


QCOLD   word  rg+inpkey+1,CFETCH,w+$1A,EQ,ZEXIT,@COLDST+t

' build word

dp
rk      word  _1,rg+inpsep,CPLUSST
lk
ak      word  @ECHOK+s
ak2     word  @getkey+s,@PUTCHARPL+t


        org
' keyaction table - an action for every keystroke rather than testing special conditions etc
keyactions
' control keys
k00     word  @ak+s,@ak+s,@BLOCK+s,@_REBOOT+s,@DEBUG+s,@DUMPCOGM+s,@ak+s,@ak+s
k08     word  @bs+s,@tab+s,@NOOP+s,@ak+s,@ak+s,@enter+s,@ak+s,@ak+s
k10     word  @DUMP+s,@QDUMP+s,@ak+s,@InitSP+s,@ak+s,@UDUMP+s,@PRTVER+s,@WORDS+s
k18     word  @reex+s,@ak+s,@QCOLD+s,@ESC+s,@ak+s,@ak+s,@ak+s,@QSTATS+s
' numbers and symbols
k20     word  @edlm+s,@ak+s,@ak+s,@deckey+s,@hexkey+s,@binkey+s,@ampkey+s,@ak+s
k28     word  @ak+s,@ak+s,@ak+s,@ak+s,@dp+s,@ak+s,@dp+s,@ak+s
k30     word  @numkey+s,@numkey+s,@numkey+s,@numkey+s,@numkey+s,@numkey+s,@numkey+s,@numkey+s
k38     word  @numkey+s,@numkey+s,@dp+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s
' upper case and symbols
k40     word  @ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s
k48     word  @ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s
k50     word  @dp+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s
k58     word  @ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s,@dp+s
' lower case and symbols
k60     word  @ak+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s
k68     word  @lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s
k70     word  @lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s,@lk+s
k78     word  @lk+s,@lk+s,@lk+s,@ak+s,@ak+s,@ak+s,@ak+s,@ak+s
{
0024 1100 V4> $80 $20 DO CR I .BYTE SPACE I 16 BOUNDS DO I EMIT LOOP 16 +LOOP
20  !"#$%&'()*+,-./
30 0123456789:;<=>?
40 @ABCDEFGHIJKLMNO
50 PQRSTUVWXYZ[\]^_
60 `abcdefghijklmno
70 pqrstuvwxyz{|}~
0025 1100 V4>
}
dokey
        word  QDUP,ZEXIT
        word  toBYTE,rg+inpkey,FETCH,_SHL8,OVER,_OR,rg+inpkey,STORE
        word  w+$7F,_AND,_SHL1,w+@keyactions+s,PLUS,WFETCH,AJMP








DAT { *** RUNMODs *** }
{ TACHYON VM CODE MODULES }
' There are a number of longs reserved in the cog for a code module which can be loaded with LOADMOD and executed with RUNMOD

                org $01F0-loadsz        ' fixed address - high-level code can always assume RUNMOD' cog origin is here
RUNMOD
_RUNMOD         res loadsz




aLOADMOD
        word  w+_RUNMOD,w+loadsz,LOADMOD,EXIT

                        org     _RUNMOD
' WS2812 ( array cnt -- ) pin mask is in REG6, line RET is done at HL, not here
' Will transmit a whole array of bytes each back to back in WS2812 timing format
' A zero is transmitted as 350ns high by 800ns low (+/-150ns)
' A one is transmitted as 700ns high by 600ns low
' LOADMOD has room for ?
WS2812
              rdbyte     X,tos+1        ' read next byte
              rev        X,#24          ' the msb must be transmitted first - get it into the lsb for shr ops
              mov        R1,#8          ' data bits
              jmp        #$+2           ' skip delay of last bit (in loop) as we had to read another byte from hub
TXRGBlp       call       #WSDLY         ' gets skipped if this is a new byte
              shr        X,#1 wc        ' get next bit
              or         OUTA,REG5      ' always clock tx pin high for at least 400ns
              call       #WSDLY         ' delay
        if_nc andn       OUTA,REG5      ' pull line down now if it's a 0 we are transmitting
              call       #WSDLY         ' delay again, either high or low
              andn       OUTA,REG5      ' always needs to go low in the last third of the cycle
              djnz       R1,#TXRGBlp    ' so go back and get the next bit ready
RGBNEXT       add        tos+1,#1       ' next byte in array (and delay)
              djnz       tos,#WS2812    ' read the next long as long as we can (tos = count)
              jmp        #DROP2         ' tx line left low - discard stack parameters, all done.

WSDLY         mov        R2,CNT
              add        R2,#13
              waitcnt    R2,#0          ' just a delay, no need to synch
WSDLY_ret     ret

_WS2812 word  w+@WS2812+s,@aLOADMOD+t
{
long rgb
: LED! rgb !  rgb 3 22 MASK DUP OUTCLR 4 COGREG! [WS2812] RUNMOD ;

}

{
                        mov     R2,tos wc             ' force nc on entry, s[31] == 0 (doNEXT clears c)
                        mov     X,tos+1                 ' X = source
cmpstrlp                rdbyte  R0,X                    ' read in a character from the source
                        add     X,#1                    ' hub has to wait anyway so get ready for next source byte
                if_c    add     R2,#1                   ' updates the copy of the dictionary pointer
                        rdbyte  R1,R2                   ' read in from the dictionary
                        cmp     R1,R0 wz                ' are they the same?
                if_z    jmpret  par,#cmpstrlp wc,nr     ' keep at it, set carry to enable dict+ (for local copy)
nomatch                 cmp     R0,#1 wc                ' was the src null terminated? (C means we have matched the string)
                if_c    test    R1,#$80 wc              ' set c flag if dict 8th bit set (C = cross-matched)
cmpstr_ret                        ret                   ' Change our flag to -1 if C set (matched)


}
{
                        org     _RUNMOD
_TRACE                  mov     X,$0D
                        call    #xemit
                        MOV     x,$0A
                        call    #xemit


}

                        org     _RUNMOD

_FFSTR
nnlp                    mov     R2,tos wc             ' force nc on entry, s[31] == 0 (doNEXT clears c)
                        mov     X,tos+1                 ' X = source
fflp                    rdbyte  R0,X                    ' read in a character from the source
                        add     X,#1                    ' hub has to wait anyway so get ready for next source byte
                if_c    add     R2,#1                   ' updates the copy of the dictionary pointer
                        rdbyte  R1,R2                   ' read in from the dictionary
                        cmp     R1,R0 wz                ' are they the same?
                if_z    jmpret  par,#fflp wc,nr         ' keep at it, set carry to enable dict+ (for local copy)
                        cmp     R0,#1 wc                ' was the src null terminated? (C means we have matched the string)
                if_c    test    R1,#$80 wc              ' set c flag if dict 8th bit set (C = cross-matched)
                        '
              if_c      mov     tos+1,tos
              if_c      jmp     #DROP
                        rdbyte  R1,tos          ' read count
                        add     R1,tos          ' add to nfa
                        add     R1,#5           ' point to next nfa word aligned
                        andn    R1,#1
                        mov     tos,R1          ' replace dict ptr
                        rdword  R1,R1 wz         ' check end word = 0
              if_nz     jmp     #nnlp
                        mov     tos+1,#0
                        jmp     #DROP

LOADFF  word  w+@_FFSTR+s,@aLOADMOD+t




{HELP SDRD ( dst eof  --  firstPos charcnt   \ read block from SD into memory while scanning for special char )
    dst is a 32 bit SD-card address 0..4GB, char is the character to scan for while, reading in the block.
 NOTE: ensure MOSI is set as an output high from caller by  1 COGREG@ OUTSET
 This is just the low-level block read once the SD card has been setup, so it just reads a sector into the dst
 There is also a scan character that it will look for and return it's first position and how many were found
}

                        org     _RUNMOD
_SDRD
                mov     X,tos+1                 ' dst --> X
                mov     R2,#0                   ' charcnt
                mov     ACC,dstinc                 '$200   ' R2 = 512 bytes
SDRDSClp        mov     R1,#8                   ' 8-bits
SDRDSCbits      andn    OUTA,sck                ' clock low
                test    miso,INA wc             ' test data from device while clock is low
                rcl     R0,#1                   ' now assemble data (also setup time for mosi)
                or      OUTA,sck                ' clock high
                djnz    R1,#SDRDSCbits
                andn    OUTA,sck                ' leave with clock low
                wrbyte  R0,X                    ' write byte to destination
                and     R0,#$FF                 ' only want to compare a byte value
                cmp     R0,tos wz               ' compare byte with char unsigned for equality
        if_z    add     R2,#1                  ' found one and increment count
        if_z    cmp     R2,#1 wz               ' if match and count = 1 (first occurrence)
        if_z    mov     tos+1,X                 ' then save dst (tos+2) to firstpos (tos)
                add     X,#1                    ' dst = dst+1
                djnz    ACC,#SDRDSClp            ' next
                mov     tos,R2
                jmp     unext

' Load the SDSCAN read module (13us)
SDRD    word  w+@_SDRD+s,@aLOADMOD+t



                        org     _RUNMOD
' (SDRD) ( dst cnt -- )
_SDRDF
:l1             mov     phsb,#0
                movi    frqb,#%0010_0000_0
                test    miso,ina wc
                rcl     r0,#1
                test    miso,ina wc
                rcl     r0,#1
                test    miso,ina wc
                rcl     r0,#1
                test    miso,ina wc
                rcl     r0,#1
                test    miso,ina wc
                rcl     r0,#1
                test    miso,ina wc
                rcl     r0,#1
                test    miso,ina wc
                rcl     r0,#1
                test    miso,ina wc
                mov     frqb,#0
                rcl     r0,#1
                wrbyte  r0,tos+1                    ' write byte to destination
                add     tos+1,#1                    ' dst = dst+1
                djnz    tos,#:l1                 ' next
                jmp     #DROP2

' SDRD
SDRDF   'word  w+%00100,w+26,_SHL,PLUS,w+ctrb,COGSTORE
        word  w+@_SDRDF+s,@aLOADMOD+t




' SD MODULE
                        org     _RUNMOD
' Write a block to the SD card - 512 bytes
' SDWR ( src cnt --  ;write block from memory to SD )
_SDWR
                        or      DIRA,mosi
SDWRlp                  rdbyte  R0,tos+1        ' read next byte from source
                        add     tos+1,#1        ' increment source address
                        shl     R0,#24          ' left justify
                        mov     R1,#8           ' send 8 bits
SDWRbits                andn    OUTA,sck        ' clock low
                        shl     R0,#1 wc        ' assume msb first
                        muxc    OUTA,mosi       ' send next bit of data out
                        or      OUTA,sck        ' clock high
                        djnz    R1,#SDWRbits
                        andn    OUTA,sck        ' leave with clock low
                        djnz    tos,#SDWRlp     ' next byte
                        jmp     #DROP2

' Load the SD write module
SDWR    word  w+@_SDWR+s,@aLOADMOD+t


{

                        org     _RUNMOD
' REGS: 1=sck 2=mosi 3=miso
' SDCMD ( -1 crc data cmd+$40 -- res )
_SDCMD
                        call    #_SDWR8
                        call    #_SDWR32
                        call    #_SDWR8
_SDRD8                  mov     acc,#8
:l0                     andn    outa,sck
                        shl     tos,#1
                        test    miso,ina wz
                if_nz   or      tos,#1
                        or      outa,sck        ' clock high
                        djnz    R1,#:l0
                        andn    outa,sck        'jmp     #_SDXT
                        add     tos,#1 nr
                if_z    jmp     _SDRD8          ' continue reading until result <> -1
                        jmp     unext
_SDWR32                 mov     acc,#24
                        rol     tos,#8
_SDWR8                  add     acc,#8
                        rol     tos,#24
:l0                     andn    outa,sck        ' clock low
                        shl     tos,#1 wc      ' assume msb first
                        muxc    outa,mosi       ' send next bit of data out
                        or      outa,sck        ' clock high
                        djnz    acc,#:l0
                        andn    outa,sck        ' leave with clock low
                        call    #POPX
_SDRD8_ret
_SDWR32_ret
_SDWR8_ret              ret

SPCMD    word  w+@_sdcmd+s,@aLOADMOD+t





'}






{HELP SPIO ( send -- receive )  ( A: miso mosi sck )
REGS: 0=sck 1=mosi 2=miso 3=cnt
 *** SERIAL PERIPHERAL INPUT OUTPUT MODULE ***
Transfers 1 to 32 bits msb first
Transmit data must be left justified ready for transmission
Receive data is in correct format
Data is shifted in and out while the clock is low
The clock is left low between transfers
}
                        org     _RUNMOD
' COGREGS: 0=sck 1=mosi 2=miso 3=cnt
' SPIO ( send -- receive )  ( A: miso mosi sck )
_SDIO32                 add     acc,#24
                        rol     tos,#8
_SDIO                   add     acc,#8
                        rol     tos,#24
                        or      dira,mosi       ' MOSI must be an output
:l0                     andn    outa,sck        ' clock low
                        shl     tos,#1 wc       ' assume msb first
                        test    miso,ina wz     ' test data from device while clock is low
                        muxc    outa,mosi       ' send next bit of data out
'                        muxz    tos,#1
                if_nz   or      tos,#1          ' now assemble data (also setup time for mosi)
                        or      outa,sck        ' clock high
                        djnz    acc,#:l0
                        andn    outa,sck        ' leave with clock low
                        jmp     unext

SDIO    word  w+@_SDIO32+s,w+_RUNMOD,w+14,LOADMOD,EXIT

{
{HELP SPIO ( send -- receive )  ( A: miso mosi sck )
COGREGS: 0=sck 1=mosi 2=miso 3=cnt
 *** SERIAL PERIPHERAL INPUT OUTPUT MODULE ***
Transfers 1 to 32 bits msb first
Transmit data must be left justified ready for transmission
Receive data is in correct format
Data is shifted in and out while the clock is low
The clock is left low between transfers
}
                        org     _RUNMOD
' COGREGS: 0=sck 1=mosi 2=miso 3=cnt
' SPIO ( send -- receive )  ( A: miso mosi sck )
_SPIO                   mov     R1,scnt
                        or      DIRA,mosi       ' MOSI must be an output
SPIOlp                  andn    OUTA,sck        ' clock low
                        shl     tos,#1 wc      ' assume msb first
                        test    miso,INA wz     ' test data from device while clock is low
                        muxc    OUTA,mosi       ' send next bit of data out
                if_nz   or      tos,#1         ' now assemble data (also setup time for mosi)
                        or      OUTA,sck        ' clock high
                        djnz    R1,#SPIOlp
                        andn    OUTA,sck        ' leave with clock low
                        jmp     unext

SPIO    word  w+@_SPIO+s,@aLOADMOD+t
}
                    org     _RUNMOD
{HELP SSD! ( data reg cnt --  )  ( A: miso mosi sck )
  COGREGS: 0=sck 1=mosi 2=nu 3=cs  }
_SSDST                  mov     X,tos+1
                        shl     X,#23
                        call    #SSDWR9
                        mov     X,tos+2
                        shr     X,#8
                        or      X,#$100
                        shl     X,#23
                        call    #SSDWR9
                        mov     X,tos+2
                        or      X,#$100
                        shl     X,#23
                        call    #SSDWR9
                        djnz    tos,_SSDST
                        jmp     #DROP3

SSDWR9                  andn    OUTA,scs        ' chip select low
                        mov     R1,#9
SSDlp                   andn    OUTA,sck        ' clock low
                        shl     X,#1 wc         ' assume msb first
                        muxc    OUTA,mosi       ' send next bit of data out
                        or      OUTA,sck        ' clock high
                        djnz    R1,#SSDlp
                        or      OUTA,scs        ' chip select high
SSDWR9_ret              ret

SSDST     word   w+@_SSDST+s,@aLOADMOD+t



{ *** 32 channel 8-bit PWM *** }


' [PWM32] loads the PWM32 module into the cog ready for a RUNMOD

PWM32     word  w+@_PWM32+s,@aLOADMOD+t


' kuroneko's 7.6kHz version of the 32 channel PWM module
' ( table waitcnt -- )
                         org       _RUNMOD                   ' Compile for RUNMOD area in cog
_PWM32                   movi      ctrb, #%0_11111_000       ' LOGIC.always
                         mov       frqb, tos+1               ' table base address
                         shr       frqb, #1{/2}              ' divided by 2 (expected to be 4n)
                         mov       cnt,#5{14}+2*4+23         ' minimal entry delay
                         add       cnt,cnt
                         mov       phsb,#0                   ' preset (not optional, 8n)

pwmlp32                  and       phsb,wrap32               ' $0400 to $0000 transition        |
                         rdlong    X,phsb                    ' read from index + 2*table/2      | need to be back-to-back

                         waitcnt   cnt,tos                   ' |
                         mov       outa,X                    ' update outputs

                         add       phsb,#4                   ' update read ptr                  |
                         rdlong    X,phsb                    ' read from index + 2*table/2      | need to be back-to-back

                         add       phsb,#4                   ' update read ptr
                         waitcnt   cnt,tos                   ' |
                         mov       outa,X                    ' update outputs

                         jmp       #pwmlp32

wrap32                   long      256 * 4 -1

{ PWM32 TIMING SAMPLE

}
' PWM32! SETUP TABLE MODULE
' this module is run from the controlling cog whereas the PWM32 runtime is in a dedicated cog
                        org     _RUNMOD
' _PWM32! ( duty8 mask table -- )                         ' 104us (LOADMOD takes 18.8us)
_PWMST32                 mov       R2,#256                ' scan through all 256 slices
                         add       tos,endtbl             ' start from end (optimize hub access)
                         add       tos+2,#1               ' compensate for cmp op so that $80 = 50 %, $100 = 100 %
pwmstlp32                rdlong    X,tos                  ' read one 1/256 slice of 32 channels
                         cmp       R2,tos+2 wc            ' is duty8 > R2
                         muxc      X,tos+1                ' set or clear the bit(s)
                         wrlong    X,tos                  ' update slice
                         sub       tos,#4                 ' next long
                         djnz      R2,#pwmstlp32          ' terminate on wrap
                         jmp       #DROP3
endtbl                   long      256 * 4 -4             ' offset to last long of table

' [PWM32!]  Load the PWM32! module which is used to setup the PWM table
PWMST32   word  w+@_PWMST32+s,@aLOADMOD+t




' PLOT MODULE
' Used for VGA/TV or LCD graphics
' pixshift is always a multiple of two, 512 pixels/line = 6 etc
'
                        org     _RUNMOD
' PLOT ( x y -- )
_PLOT                   shl     tos,pixshift    ' n^2 bytes/Y line
                        mov     X,tos+1
                        shr     tos+1,#3        ' byte offset in line
                        add     tos,tos+1       ' byte offset in frame
                        add     tos,pixeladr    ' byte address in memory
                        and     X,#7    ' get bit mask
                        mov     tos+1,#1
                        shl     tos+1,X
                        rdbyte  X,tos   ' Read the contents of the memory location
                        or    X,tos+1 ' set or clear the bit(s) specd by mask
                        wrbyte  X,tos   ' update
                        jmp     #DROP2


' [PLOT]
PLOT    word w+@_PLOT+s,@aLOADMOD+t


' small RUNMOD for LIFE demo
_ROL3
                        and       tos,#2
                        call      #RPOPX
                        or        tos,X
                        rol       tos,#1
                        mov       R0,tos
                        call      #_PUSHR
                        call      #POPX
                        rol       tos,#1
                        rol       tos+1,#1
                        rol       tos+2,#1
                        jmp       unext


ROL3    word w+@_ROL3+s,@aLOADMOD+t


        org    _RUNMOD

' CAPTURE ( buf lcnt dly -- )
' the trigger mask is directly loaded into REG1
CAPTURE
                    mov         X,ina                   ' look for change of state by reading INA first
                    waitpne     X,REG1                  ' wait for change on those masked bits
                    mov         R1,tos wz               ' read delay
        if_z        movs        CAPINS,#CAPLP1          ' if zero then adjust loop to run without delay
        if_nz       add         R1,cnt
CAPLP
        if_nz       waitcnt     R1,tos                  ' (6+) if dly is set correctly then waitcnt can be considered a 6+ cycle NOP
CAPLP1              mov         ina,ina                 ' (4) read INA into its shadow (for dest field)
                    wrlong      ina,tos+2               ' (8..23) save it
                    add         tos+2,#4                ' (4) next long in memory
CAPINS              djnz        tos+1,#CAPLP wz         ' (4)
                    jmp         #DROP3

_CAP    word  w+@CAPTURE+s,@aLOADMOD+t



        org    _RUNMOD

' RCTIME (  pin -- cycles )
_RCTIME             call        #AMASK
                    mov         R1,tos
                    or          DIRA,R1
                    andn        OUTA,R1
                    mov         X,rclo
                    djnz        X,$
                    andn        DIRA,R1
                    mov         X,CNT
                    waitpeq     tos,tos
                    mov         tos,CNT
                    or          DIRA,R1
                    or          OUTA,R1
                    sub         tos,X
                    abs         tos,tos
                    andn        DIRA,R1
                    jmp         unext
rclo                long        2000

RCTIME    word  w+@_RCTIME+s,@aLOADMOD+t


        org    _RUNMOD

' Plays signed 16-bit WAV samples from two consecutive 512-byte buffers (sectors)
' PLAYER ( ctls blk -- )
_PLAY                   mov     REG1,tos        ' point to readptr hub update location
                        mov     REG3,tos+1
                '       mov     REG1,tos+1
                        add     REG1,#2         ' REG0 points to volume word in hub
                        mov     REG2,tos+1
                        add     REG2,#4         ' REG1 points to speed word in hub
_PLREP                  mov     R1,pblksz       ' reload buffer cnt
                        mov     R2,tos          ' reload buffer ptr
                        rdbyte  tos+1,REG1      ' update volume scale
_PLLP                   rdword  X,R2            ' get next sample
                        add     X,bias          ' offset the sign to half voltage
                        shl     X,#16           ' scale to 32-bits
                        wrword  R1,REG3         ' update hub read cnt (ext. buf fill task)
                        sar     X,tos+1         ' adjust volume?
                        mov     FRQA,X          ' output sample
                        waitcnt cnt,deltaR      ' sample time
                        rdlong  deltaR,REG2
                        add     R2,#2           ' point to next word
                        djnz    R1,#_PLLP       ' 512 samples / 1K (512x2)
                        jmp     #_PLREP         ' repeat buffer

bias            long    $FFFF8000               ' biased sign
pblksz          long    512                     ' 512 samples 1K buffer


PLAY    word  w+@_PLAY+s,@aLOADMOD+t




' start,sing/diff,d2,d1,d0,x,x -- 11..0

                        org     _RUNMOD
' COGREGS: 0=sck 1=mosi 2=miso 3=cs
' MCP32 ( send -- receive )  ( A: miso mosi sck )
' send = s/d+ch
_MCP32                  or      tos,#$18       ' add start bit + single mode
                        shl     tos,#27        ' left justify
                        or      DIRA,mosi       ' make sure mosi is an output
                        andn    OUTA,scs        ' assert ce
                        mov     R1,#19          ' clock out 7 bits then read 12
mcplp                   andn    OUTA,sck        ' clock low
                        cmp     R1,#14 wc       ' if mosi = miso then switch to input after 5 clocks
                if_c    andn    DIRA,miso
                        shl     tos,#1 wc      ' assume msb first
                        test    miso,INA wz     ' test data from device while clock is low
                        muxc    OUTA,mosi       ' send next bit of data out
                if_nz   or      tos,#1         ' now assemble data (also setup time for mosi)
                        or      OUTA,sck        ' clock high
                        mov     X,#1
:dly                    djnz    X,#:dly
                        djnz    R1,#mcplp
                        andn    OUTA,sck        ' leave with clock low
                        or      OUTA,scs        ' ce high
                        and     tos,mmask
                        jmp     unext
mmask                   long    $0FFF

' [MCP32] ( &ce.si.so.ck -- )
MCP32   word  w+@_MCP32+s,@aLOADMOD+t















DAT { *** STRUCTURED BRANCHING *** }


' Most of these words are acted upon immediately rather than compiled as they are
' part of the "compiler" in that they create the necessary structures
'

' MARKHERE ( tag -- tag&addr )
MARKHERE
        word  @ATTHERE+s,SWAP
' MARK ( addr tag -- tag&addr ) Merge tag and addr by shifting tag into hi word
MARK    word  _16,_SHL,_OR,EXIT

' UNMARK ( tag&addr -- addr tag )
UNMARK  word  DUP,PUSH16,$FFFF,_AND,SWAP,_16,_SHR,EXIT

' BEGIN as in BEGIN...AGAIN or BEGIN...UNTIL
_BEGIN_ word  w+$BE,@MARKHERE+t          ' generate branch for BEGIN

' BEGIN UNTIL ( flg -- )
_UNTIL_ word  @UNMARK+s
        word  w+$BE,EQ,_IF+(@badthen-@unt01)/2
unt01   word  @ATTHERE+s,PLUS2,SWAP,MINUS,_SHR1,w+_UNTIL,_OR,@WCOMPK+t              '

' BEGIN WHILE REPEAT
_REPEAT_
        word  @UNMARK+s
rp00    word  w+$1F,EQ,_IF+(@badrep-@rp02)/2
rp02    word  @ATTHERE+s,PLUS2,@RESFWD1+s          ' process branch of WHILE to after REPEAT
' BEGIN AGAIN
_AGAIN_ word  @UNMARK+s
        word  w+$BE,EQ,_IF+(@badthen-@ag01)/2
        ' simply compile this address as a jump (+1)         '
ag01    word  INC,@WCOMPK+t

        ' ( addr wc -- ) compile the wordcode and calculate the branch back
lpcalc  word  @WCOMPK+s
calcback
        word  @ATTHERE+s,INC,SWAP,MINUS,@WCOMPK+t

badrep  word  DROP2,@badthen+t

' IF as in IF...THEN or IF...ELSE...THEN
_WHILE_
_IF_    word  w+$1F,@MARKHERE+s,w+_IF,@WCOMPK+t

' ELSE
_ELSE_
        word  @UNMARK+s,w+$1F,EQ,_IF+(@badthen-@el01)/2         ' does this match an IF?
el01
        word  w+$1E,@MARKHERE+s                                 ' mark the else to be processed on a THEN
        word  w+@DEBUG+t,@WCOMPK+s                               ' Compile a DEBUG jump to be replaced on THEN
        word  SWAP,@RESFWD+t                                    ' get the IF addr and proceed as if it were a THEN

' THEN
_THEN_  word  w+ucomp,@WCLR+s
        word  @UNMARK+s,DUP,w+$1E,EQ,_IF+05
        word  DROP,@ATTHERE+s,INC,SWAP,@WSTOREX+t
        word  w+$1F,EQ,_IF+(@badthen-@RESFWD)/2
RESFWD  word  @ATTHERE+s
RESFWD1 word  OVER,MINUS,_SHR1,DEC,SWAP,@CSTOREX+t        ' calculate branch and update IF's branch

badthen word  @PRTSTR+s
        byte  " Structure mismatch! ",0
        word  DROP,@ERROR+t

{
'ADO     word  w+BOUNDS,@WCOMP+s,w+DO,@WCOMP+t
' 4+
XPLUS4   word  INC,INC
' 2+
PLUS2A   word  INC,INC,EXIT
}
' 2-
SUB2    word  DEC,DEC,EXIT

DAT
{
CLKSET
?(c) Copyright 2009 Philip C. Pilgrim (propeller@phipi.com)
see end of file for terms of use.

This object determines whether a 5MHz or 10MHz crystal is
being used and sets the PLL accordingly for 80MHz operation.
The main program should use the following settings:
  _clkmode      = xtal1 + pll8x
  _xinfreq      = 10_000_000
}
              org       _RUNMOD

_setpll       movi      ctra,#%0_00001_011      'Set ctra for pll on no pin at x1.
              movi      frqa,#%0100_0000_0      'Set frqa for clk / 4 (= 20MHz w/ 10MHz crystal, i.e. too high).
              add       pllx,cnt                'Give PLL time to lock (if it can) and stabilize.
              waitcnt   pllx,#0
              movi      vcfg,#$40               'Configure video for discrete pins, but no pins enabled.
              mov       vscl,#$10               'Set for 16 clocks per frame.
              waitvid   0,0                     'Wait once to clear time.
              neg       pllx,cnt                'Read -cnt.
              waitvid   0,0                     'Wait 16 pll clocks = 64 processor clks.
              add       pllx,cnt                'Compute elapsed time.
              cmp       pllx,#$40 wz            'Is it really 64 clocks?
        if_z  mov       pllx,#$6f               '  Yes: Crystal is 5MHz. Set clock mode to XTAL1 and PLL16X.
        if_z  clkset    pllx
        if_z  wrbyte    $-2, #4                 'update clkmode location
            jmp       unext

pllx          long      $1_0000                 '65536 clks for pll to stabilize.


        org
' FREE ( -- free ) Read free memory from Spin header and round up to a 64 byte page (to suit EEPROM)
FREE    word    w+@last+s+$40,w+$3F,_ANDN,EXIT

' correct the count byte in each entry in the dictionary as the precompiled version leaves a dummy count (too mind-numbing)
FIXDICT
        word  @PRTSTR+s
        byte  " Setting up dictionary   ",0
        word  w+varram-2,WFETCH,DUP,ZEQ,_IF+(@fd2-@fd0)/2
fd0     word  DROP,w+@dictionary+s,DUP
        ' find length of string and update count (blank when compiled)
fdlp    word  DUP,INC,STRLEN,OVER,CSTORE
        ' skip to next entry and word align  EX: 03 D U P ATR x WORD
        word  DUP,CFETCH,PLUS4,PLUS,@ALIGNW+s
        ' terminate if start of next entry is 00 00
        word  DUP,WFETCH,ZEQ,_UNTIL+(@fd1-@fdlp)/2
fd1     ' ( dictptr dictptr endptr )
        ' RELOCATE DICTIONARY TO UPPER HUB RAM
        ' calculate dest to move back from new dictend.
        word  w+@dictionary+s,MINUS,PLUS2,w+varram-2,OVER,MINUS ' ( src len dst )
        ' backup new dictionary ptr in last location to be used by COLD
        word  DUP,w+varram-2,WSTORE
        word  @ROT2+s,THIRD,SWAP,CMOVE

fd2     word  DUP,w+corenames,WSTORE
        ' Reset dictionary pointer
        word  DUP,w+names,WSTORE,w+names-2,@WSTOREX+t


' COLD  Force factory defaults
COLDST  word   @PRTSTR+s
        byte  " Cold start - no user code - setting defaults  ",$0D,$0A,0
        word  w+hubvars,w+hvend-hubvars,@ERASE+s
        ' free memory
        word  @FREE+s,DUP,w+uhere,WSTORE,w+uhere-2,WSTORE
        ' set data org
        word  w+datram,w+datorg,WSTORE
        ' setup saved receive buffer address
        word  w+@rxbuffers+s,w+rxptr,WSTORE
        ' Move dictionary into upper code space
        word  @FIXDICT+s
        ' initialize 8 task words
'        word  w+tasks,w+tasksz*8,@ERASE+s
        word  w+$5AA5,w+cold,@WSTOREX+t



DAT { *** CONSOLE *** }

        org             ' align the label - needs to be passed in 14-bit PAR register

TERMINAL_reset
        word  InitRP,@InitSP+s
        ' skip PLL setup if crystal is not 80MHZ
        word  _0,FETCH,w+10000,@UDIVIDE+s,w+8000,EQ,_IF+03
        ' Default 10MHz crystal but switch to 5MHz x16 if detected
SETPLL  word  w+@_setpll+s,@aLOADMOD+s,RUNMOD

        ' erase all variables, buffers etc
        word  w+datram,w+$8000-datram,@ERASE+s

        word  rg+temp,w+padwr+1-temp,@ERASE+s
'txticks         long (sysfreq / baud )  ' set transmit baud rate
        word  w+@baudrate+s,FETCH,_6,COGSTORE
        ' setup transmit pin
        word  w+@conpins+s+1,CFETCH,MASK,H,_7,COGSTORE

TERMINAL
        word  InitRP
        ' a little startup delay (also wait for serial cog)
        word  w+50,@ms+s
        ' Set the rx buffer size
        word  w+rxsize,w+rxsz,WSTORE
        word  @DECIMAL+s
        ' Show VERSION with optional CLS (default CR)
        word  @CRLF+s,@CRLF+s,@PRTVER+S
        ' performing a check for a saved session
        word  w+cold,WFETCH,w+$5AA5,@NEQ+s,_IF+01
KOLD    word  @COLDST+s
        word  w+uauto,WFETCH,QDUP,_IF+01,ACALL

CONSOLE
termnew word  InitRP,@CRLF+s,@SCRUB+s
        ' Stop compilation
        word  w+deff,w+flags,@CLR+s
        word  w+uprompt,@WCLR+s
        word  w+errors,@WCLR+s
        word  w+linenum,@WCLR+s
        ' echo on - select hub RAM for DUMP
        word  _1,@ECHO+s,@RAM+s
        '
        ' ****************** PROMPT FOR NEW LINE ******************
        '
        ' Main console line loop - get a new line (word by word)
        ' execute user prompt code
        word  @PROMPT+s
termlp  word  @KEY+s,@dokey+s,@termlp+t


DAT

ERROR   word  _1,w+errors,WPLUSST                       ' count errors
        word  @PRTSTR+s
        byte  " *error*",7,$0D,$0A,0
        word  w+$10A,@EMIT+s                            ' force a LF into the serial console
        word  @DISCARD+s,@InitSP+s,@CONSOLE+t          ' jumps to console (no return)




' 6A2C:  03 44 55 50 80 00 29 00 04 4F 56 45 52 80 2C 00    .DUP..)..OVER.,.
' 3,DUP,ATR,0,WORD
' ALIAS MASK |<
ALIAS   word  @NFATICK+s,@GRAB+s,@ADDCNT+s         ' ( atrptr )
        word  _0,@CREATEWORD+s
        word  @ATATR+s,OVER,CFETCH,OVER,CSTORE          ' copy atr
        word  SWAP,INC,@ALIGNW+s,WFETCH,SWAP,INC,@ALIGNW+s,@WSTOREX+t


' index the receive cog parameter long in EEPROM (rxpin,baud,network etc)
' rxpars ( index -- addr )
RXPARS  word  _SHL2,w+@_rxpars+s,@PLUSX+t










DAT

RTILDE  word  _1,w+$0A,@xTILDE+t
' disable line feeds
LTILDE  word  _0,_0
xTILDE  word  w+@etbl+$0A+s,CSTORE
'ECHO ( on/off -- )
ECHO    word  w+echof,w+flags,ROT
BITST   word  _IF+01,@SET+t,@CLR+t


' END
ENDLOAD word  @RTILDE+s,@CRLF+s,@PRTSTRN+s
        byte  "   End of source code, ",0
        word  w+errors,WFETCH,DUP,_IF+01,@BELL+s,@PRTDEC+s,@PRTSTR+s
        byte  "  errors found ",0
        word  @PRTSTR+s
        byte  " Load time = ",0
        word  @LAP+s,@PRTLAP+s
        word  @PRTSTRN+s
        byte  "Code bytes used = ",0
        word  @HERE+s,w+fromhere,WFETCH,MINUS,@PRINT+s
        word  @CRLF+s,@QSTATS+s,@CRLF+s
        word  w+keypoll,DUP,PLUS2,WFETCH,SWAP,WSTORE
        word  w+_NOP,w+errors,@WCLR+s
SETSRCH word  w+@SEARCH+s,@WSTOREX+t

' NOTE: Leave as last code routine in kernel for easy identification of boundaries etc.

{HELP TACHYON - used to verify that source code is intended for Tachyon and also to reset load stats }
TACHYON
        word  @PRTVER+s
        word  w+keypoll,DUP,WFETCH,SWAP,PLUS2,WSTORE
        word  w+keypoll,@WCLR+s                           ' disable background keypoll during load
        word  w+errors,@WCLR+s                            ' reset error count
        word  w+@FFSTR+t,@SETSRCH+s                   ' fast word search
        word  @HERE+s,w+fromhere,WSTORE                   ' remember code position for reporting
        word  _1,w+linenum,WSTORE
        word  @ATNAMES+s,w+names-2,WSTORE                 ' backup dictionary pointer
        word  @LTILDE+s
        word  @LAP+t


        org   ' align last to a long to suit Spin tool
last












DAT { *** DICTIONARY *** }

dictionary
{
 !"#$%&'()*+,-./
0123456789:;<=>?
@ABCDEFGHIJKLMNO
PQRSTUVWXYZ[\]^_

`abcdefghijklmno
pqrstuvwxyz{|}~

HUB RAM
1 byte        count(5)+vocab(3)
n bytes       name
1 byte        atr with msb set
1 word        code

EEPROM
Fixed 16 byte Record Structure
1 byte        count+vocab
12 bytes      12 characters
1 byte        atr
1 word        code

0   1   2   3   4   5   6   7   8   9   10  11  12  13  14  15
$03 $44 $55 $50 $20 $20 $20 $20 $20 $20 $20 $20 $20 $80 $22 $00
}

' The count field is left blank but filled in at runtime so that these do not need to be calculated when defining

'       CNT,NAME,ATR,<x>,WORDCODE

' STACK
        byte  cn,"NOP",hd                       ' marks start of kernel dictionary
        word  _NOP

        byte  cn,"DUP",hd
        word  DUP
        byte  cn,"2DUP",hd
        word  @DUP2+s
        byte  cn,"OVER",hd
        word  OVER
        byte  cn,"DROP",hd
        word  DROP
        byte  cn,"2DROP",hd
        word  DROP2
        byte  cn,"SWAP",hd
        word  SWAP
        byte  cn,"ROT",hd
        word  ROT
        byte  cn,"-ROT",hd
        word  @ROT2+s
        byte  cn,"NIP",hd
        word  @NIPEX+s
        byte  cn,"3DROP",hd
        word  DROP3
        byte  cn,"?DUP",hd
        word  QDUP
        byte  cn,"3RD",hd
        word  THIRD
        byte  cn,"4TH",hd
        word  FOURTH

        byte  cn,">R",hd
        word  PUSHR
        byte  cn,"R>",hd
        word  RPOP

        byte  cn,"!RP",hd
        word  InitRP
        byte  cn,"!SP",hd
        word  @InitSP+s
{
        byte  cn,"!A",hd
        word  @InitA+s
        byte  cn,">A",hd
        word  PUSHA
        byte  cn,"A>",hd
        word  POPA
        byte  cn,"A@",hd
        word  READA
}

' LOGIC
'        byte  cn,"INVERT",   hd,             INC,NEGATE
        byte  cn,"AND",hd
        word  _AND
        byte  cn,"ANDN",hd
        word  _ANDN
        byte  cn,"OR",hd
        word  _OR
        byte  cn,"XOR",hd
        word  _XOR
        byte  cn,"ROL",hd
        word  @_ROL+s
        byte  cn,"ROR",hd
        word  @_ROR+s
        byte  cn,"SHR",hd
        word  _SHR
        byte  cn,">>",hd
        word  _SHR
        byte  cn,"8>>",hd
        word  _SHR8
        byte  cn,"SHL",hd
        word  _SHL
        byte  cn,"<<",hd
        word  _SHL
        byte  cn,"8<<",hd
        word  _SHL8
        byte  cn,"2/",hd
        word  _SHR1
        byte  cn,"2*",hd
        word  _SHL1
        byte  cn,"4*",hd
        word  _SHL2
        byte  cn,"SAR",hd
        word  @_SAR+s

        byte  cn,"SPLIT9",hd
        word  SPLIT9

        byte  cn,"REV",hd
        word  _REV

        byte  cn,"MASK",hd
        word  MASK
        byte  cn,">N",hd
        word  toNIB
        byte  cn,">B",hd
        word  toBYTE
        byte  cn,"0=",hd
        word  ZEQ
        byte  cn,"NOT",hd
        word  ZEQ

' ARITHMETIC
        byte  cn,"1+",hd
        word  INC
        byte  cn,"1-",hd
        word  DEC
        byte  cn,"+",hd
        word  PLUS
        byte  cn,"-",hd
        word  MINUS

        byte  cn,"2+",hd
        word  PLUS2
        byte  cn,"4+",hd
        word  PLUS4
        byte  cn,"2-",hd
        word  @SUB2+s


        byte  cn,"MIN",hd
        word  @_MIN+s
        byte  cn,"MAX",hd
        word  @_MAX+s

        byte  cn,"*",hd
        word  @MULTIPLY+s
        byte  cn,"UM*",hd
        word  UMMUL

        byte  cn,"U/",hd
        word  @UDIVIDE+s
        byte  cn,"U/MOD",hd
        word  @UDIVMOD+s
        byte  cn,"/",hd
        word  @DIV+s
        byte  cn,"UM/MOD64",hd
        word  UMDIVMOD64
        byte  cn,"UM/MOD32",hd
        word  UMDIVMOD32

        byte  cn,"*/",hd
        word  @MULDIV+s
        byte  cn,"UM*/",hd
        word  @UMMULDIV+s

        byte  cn,"ABS",hd
        word  _ABS
'        byte  cn,"-NEGATE",hd
'        word  MNEGATE
        byte  cn,"?NEGATE",hd
        word  QNEGATE
        byte  cn,"NEGATE",hd
        word  NEGATE

' LOOPING
        byte  cn,"FROM",hd
        word  FROMS
        byte  cn,"BY",hd
        word  BY
        byte  cn,"ADO",hd
        word  ADO
        byte  cn,"FOR",hd
        word  FOR
        byte  cn,"NEXT",hd
        word  forNEXT
        byte  cn,"LOOP",hd
        word  LOOP
        byte  cn,"+LOOP",hd
        word  PLNEXT

        byte  cn,"I",hd
        word  I
        byte  cn,"J",hd
        word  @J+s
        byte  cn,"LEAVE",hd
        word  @LEAVE+s
        byte  cn,"FOR@",hd
        word  @FORFT+s
        byte  cn,"FOR!",hd
        word  @FORST+s
        byte  cn,"BY!",hd
        word  @BYST+s
        byte  cn,"LP!",hd
        word  @LPST+s



' BRANCHING
        byte  cn,"IF",hd+im
        word  @_IF_+s
        byte  cn,"ELSE",hd+im
        word  @_ELSE_+s
        byte  cn,"THEN",hd+im
        word  @_THEN_+s
        byte  cn,"ENDIF",hd+im
        word  @_THEN_+s
        byte  cn,"BEGIN",hd+im
        word  @_BEGIN_+s
        byte  cn,"UNTIL",hd+im
        word  @_UNTIL_+s
        byte  cn,"AGAIN",hd+im
        word  @_AGAIN_+s
        byte  cn,"WHILE",hd+im
        word  @_IF_+s
        byte  cn,"REPEAT",hd+im
        word  @_REPEAT_+s


' MEMORY
        byte  cn,"IC!",hd
        word  ICSTORE
        byte  cn,"IC@",hd
        word  ICFETCH
        byte  cn,"C@",hd
        word  CFETCH
        byte  cn,"W@",hd
        word  WFETCH
        byte  cn,"@",hd
        word  FETCH
        byte  cn,"C+!",hd
        word  CPLUSST
        byte  cn,"C!",hd
        word  CSTORE
        byte  cn,"C@++",hd
        word  CFETCHINC
        byte  cn,"W+!",hd
        word  WPLUSST
        byte  cn,"W!",hd
        word  WSTORE
        byte  cn,"+!",hd
        word  PLUSST
        byte  cn,"!",hd
        word  STORE
        byte  cn,"C~",hd
        word  @CCLR+s
        byte  cn,"W~",hd
        word  @WCLR+s
        byte  cn,"~",hd
        word  @LCLR+s

        byte  cn,"BIT?",hd
        word  @BITQ+s
        byte  cn,"SET?",hd
        word  @SETQ+s
        byte  cn,"SET",hd
        word  @SET+s
        byte  cn,"CLR",hd
        word  @CLR+s
        byte  cn,"BIT!",hd
        word  @BITST+s


' BLOCK
        byte  cn,"CMOVE",hd
        word  CMOVE
        byte  cn,"ERASE",hd
        word  @ERASE+s
        byte  cn,"FILL",hd
        word  @FILL+s
        byte  cn,"<CMOVE",hd
        word  @RCMOVE+s



        byte  cn,"RESET",hd
        word  RESET
        byte  cn,"0EXIT",hd
        word  ZEXIT
        byte  cn,"EXIT",hd
        word  EXIT
        byte  cn,"?EXIT",hd
        word  @IFEXIT+s

        byte  cn,"CALL",hd
        word  ACALL
        byte  cn,"JUMP",hd
        word  AJMP

        byte  cn,"(WAITPNE)",hd
        word  _WAITPNE


        byte  cn,"RUNMOD",hd
        word  RUNMOD
        byte  cn,"(WAITPEQ)",hd
        word  _WAITPEQ
        byte  cn,"(EMIT)",hd
        word  pEMIT
        byte  cn,"(EMITX)",hd
        word  pEMITX

        byte  cn,"LOADMOD",hd
        word  LOADMOD


        byte  cn,"COG@",hd
        word  COGFETCH
        byte  cn,"COG!",hd
        word  COGSTORE

        byte  cn,"COGSTOP",hd
        word  @pCOGSTOP+s
        byte  cn,"pCOGINIT",hd
        word  @pCOGINIT+s
        byte  cn,"COGID",hd
        word  @_COGID+s
        byte  cn,"REBOOT",hd
        word  @_REBOOT+s
        byte  cn,"CLK",hd
        word  @_CLK+s
        byte  cn,"CLKSET",hd
        word  @_CLKSET+s

        byte  cn,"DELTA",hd
        word  @DELTA+s
        byte  cn,"WAITCNT",hd
        word  WAITCNTS
        byte  cn,"LAP",hd
        word  @LAP+s
        byte  cn,".LAP",hd
        word  @PRTLAP+s
        byte  cn,"LAP@",hd
        word  @ELAPSED+s

' I/O
        byte  cn,"CLOCK",hd
        word  CLOCK
        byte  cn,"CLKIN",hd
        word  CLKIN
        byte  cn,"CLKOUT",hd
        word  CLKOUT
'        byte  cn,"MPIN",hd
'        word  MPIN
'        byte  cn,"PIN",hd
'        word  FPIN
        byte  cn,"H",hd
        word  H
        byte  cn,"L",hd
        word  L
        byte  cn,"P",hd
        word  P
        byte  cn,"T",hd
        word  TOGGLE
        byte  cn,"F",hd
        word  F
'        byte  cn,"TOGGLE",hd
'        word  TOGGLE
        byte  cn,"SHROUT",hd
        word  SHROUT
        byte  cn,"SHRINP",hd
        word  SHRINP

        byte  cn,"OUTSET",hd
        word  OUTSET
        byte  cn,"OUTCLR",hd
        word  OUTCLR
        byte  cn,"OUTPUTS",hd
        word  OUTPUTS
        byte  cn,"INPUTS",hd
        word  INPUTS
{
        byte  cn,"PIN!",hd
        word  PINST
}
        byte  cn,"HIGH",hd
        word  HIGH
        byte  cn,"LOW",hd
        word  LOW
        byte  cn,"FLOAT",hd
        word  FLOATPIN
        byte  cn,"PIN@",hd
        word  RDPIN
        byte  cn,"IN",hd
        word  IN


        byte  cn,"SPIWRB",hd
        word  SPIWRB
        byte  cn,"SPIWR16",hd
        word  SPIWR16
        byte  cn,"SPIWR",hd
        word  SPIWR
        byte  cn,"SPIRD",hd
        word  SPIRD
        byte  cn,"SPICE",hd
        word  _SPICE


' COMPARISON
        byte  cn,"0<>",hd
        word  @ZNE+s
        byte  cn,"<>",hd
        word  @NEQ+s
        byte  cn,"WITHIN",hd
        word  @WITHIN+s
        byte  cn,"U>",hd
        word  @UGT+s
        byte  cn,"=",hd
        word  EQ
        byte  cn,">",hd
        word  GT
        byte  cn,"<",hd
        word  @LT+s
        byte  cn,"U<",hd
        word  ULT
        byte  cn,"0<",hd
        word  @ZLT+s




' CONSOLE
        byte  cn,"HEX",hd
        word  @HEX+s
        byte  cn,"DECIMAL",hd
        word  @DECIMAL+s
        byte  cn,"BINARY",hd
        word  @BIN+s
        byte  cn,"READBUF",hd
        word  @READBUF+s
        byte  cn,"KEY",hd
        word  @KEY+s
        byte  cn,"WKEY",hd
        word  @WKEY+s
        byte  cn,"(KEY)",hd
        word  @CONKEY+s
        byte  cn,"KEY!",hd
        word  @PUTKEY+s
        byte  cn,"doKEY",hd
        word  @dokey+s


'        byte  cn,"lastkey",hd
'        word  @LASTKEY+s

        byte  cn,"EMIT",hd
        word  @EMIT+s
        byte  cn,"CLS",hd
        word  @CLS+s
        byte  cn,"SPACE",hd
        word  @SPACE+s
        byte  cn,"SPACES",hd
        word  @SPACES+s
        byte  cn,"EMITS",hd
        word  @EMITS+s
        byte  cn,"BELL",hd
        word  @BELL+s
        byte  cn,"CR",hd
        word  @CRLF+s
        byte  cn,"<CR>",hd
        word  @CR+s
        byte  cn,"TAB",hd
        word  @ATAB+s
        byte  cn,"TABS",hd
        word  @TABS+s
        byte  cn,"XTAB",hd
        word  @XTAB+s
        byte  cn,"SPINNER",hd
        word  @SPINNER+s


' NUMBER PRINT
        byte  cn,".HEX",hd
        word  @PRTHEX+s
        byte  cn,".BYTE",hd
        word  @PRTBYTE+s
        byte  cn,".WORD",hd
        word  @PRTWORD+s
        byte  cn,".LONG",hd
        word  @PRTLONG+s

' NUMBER FORMATING
        byte  cn,"@PAD",hd
        word  @ATPAD+s
        byte  cn,"HOLD",hd
        word  @HOLD+s
        byte  cn,">CHAR",hd
        word  @TOCHAR+s
        byte  cn,"#>",hd
        word  @RHASH+s
        byte  cn,"<#",hd
        word  @LHASH+s
        byte  cn,"#",hd
        word  @HASH+s
        byte  cn,"#S",hd
        word  @HASHS+s
        byte  cn,"<D>",hd
        word  @DNUM+s
        byte  cn,"PRINT$",hd
        word  @PSTR+s
        byte  cn,"CTYPE",hd
        word  @CTYPE+s

        byte  cn,"LEN$",hd
        word  STRLEN
        byte  cn,"U.",hd
        word  @UPRINT+s
'        byte  cn,".DEC",hd
'        word  @PRTDEC+s
        byte  cn,".DP",hd
        word  @PRTDP+s
        byte  cn,"PRINT",hd
        word  @PRINT+s
        byte  cn,".",hd
        word  @PRINT+s
        byte  cn,"ZPRINT",hd
        word  @ZPRINT+s


' DICTIONARY
        byte  cn,"CREATE",hd+im
        word  @CREATEWORD+s
        byte  cn,"CREATE$",hd
        word  @CREATENAME+s
        byte  cn,"GETWORD",hd
        word  @GETWORD+s
        byte  cn,"SEARCH",hd
        word  @SEARCH+s
        byte  cn,"FINDSTR",hd
        word  @FINDSTR+s

        byte  cn,"NFA>BFA",hd
        word  @NFABFA+s
        byte  cn,"CFA>NFA",hd
        word  @CFANFA+s
        byte  cn,"NFA>NFA",hd
        word  @NFANFA+s
        byte  cn,"@NAMES",hd
        word  @ATNAMES+s
        byte  cn,"names",hd
        word  w+names
        byte  cn,"WORDS",hd
        word  @WORDS+s
        byte  cn,"UNSMUDGE",hd
        word  @UNSMUDGE+s
'        byte  cn,"WWORDS",hd
'        word  @WWORDS+s


        byte  cn,"ALLOT",hd
        word  @ALLOT+s
        byte  cn,"ALLOCATED",hd
        word  @ALLOCATED+s
        byte  cn,"HERE",hd
        word  @HERE+s
        byte  cn,",",hd+im
        word  @_LCOMP+s
        byte  cn,"||",hd+im
        word  @_WCOMP+s
        byte  cn,"|",hd+im
        word  @_BCOMP+s

        byte  cn,"[W]",hd+im
        word  @WCOMPK+s
        byte  cn,"[B]",hd+im
        word  @BCOMP+s

        byte  cn,"W,",hd+im
        word  @WCOMP+s

        byte  cn,"EXECUTE",hd
        word  @EXECUTE+s

        byte  cn,"VER",hd
        word  w+@version+s
        byte  cn,".VER",hd
        word  @PRTVER+s
        byte  cn,"TACHYON",hd
        word  @TACHYON+s
        byte  cn,"END",hd
        word  @ENDLOAD+s
        byte  cn,"CONSOLE",hd
        word  @CONSOLE+s
        byte  cn,"ECHO",hd
        word  @ECHO+s

        byte  cn,"us",hd
        word  @us+s
        byte  cn,"ms",hd
        word  @ms+s
        byte  cn,"seconds",hd
        word  @seconds+s
        byte  cn,"second",hd
        word  @seconds+s


        byte  cn,"DISCARD",hd
        word  @DISCARD+s


        byte  cn,"TASK",hd
        word  @TASK+s
        byte  cn,"REG",hd
        word  @REG+s

        byte  cn,"BUFFERS",hd
        word  w+buffers


        byte  cn,"COLD",hd
        word  @KOLD+s

' DEBUG
        byte  cn,"RAM",hd
        word  @RAM+s
        byte  cn,"DUMP:",hd
        word  @SETDMP+s
        byte  cn,"DUMPX",hd
        word  @DUMPX+s
        byte  cn,"DUMP",hd
        word  @DUMP+s
        byte  cn,"DUMPW",hd
        word  @DUMPW+s
        byte  cn,"DUMPL",hd
        word  @DUMPL+s
        byte  cn,"DUMPC",hd
        word  @DUMPCOG+s
        byte  cn,"DUMPA",hd
        word  @DUMPA+s
        byte  cn,"DUMPAW",hd
        word  @DUMPAW+s
        byte  cn,"QD",hd
        word  @QDUMP+s

        byte  cn,"DEPTH",hd
        word  @DEPTH+s
        byte  cn,".S",hd
        word  @PRTSTK+s
        byte  cn,"DEBUG",hd
        word  @DEBUG+s
'        byte  cn,".FREE",hd
'        word  @PRTFREE+s
        byte  cn,".STATS",hd
        word  @QSTATS+s

        byte  cn,"IDLE",hd                       ' marks start of kernel dictionary
        word  @IDLE+s
        byte  cn,"NOOP",hd                       ' marks start of kernel dictionary
        word  @NOOP+s


' COMMENTS
        byte  cn,"---",hd+im
        word  @COMMENT+s
        byte  cn,"\",hd+im
        word  @COMMENT+s
        byte  cn,"''",hd+im
        word  @COMMENT+s
        byte  cn,"(",hd+im
        word  @BRACE+s
        byte  cn,"{",hd+im
        word  @CURLY+s
        byte  cn,"}",hd+im
        word  @NOOP+s
        byte  cn,"IFDEF",hd+im
        word  @IFDEF+s
        byte  cn,"IFNDEF",hd+im
        word  @IFNDEF+s

        ' STRINGS
        byte  cn,$22,hd+im
        word  @_STR_+s
        byte  cn,"(",$22,")",hd+im
        word  @STRLIT+s
        ' ."
        byte  cn,$2E,$22,hd+im
        word  @COMPPRTS+s
        byte  cn,"PRINT",$22,hd+im
        word  @COMPPRTS+s
        ' (.")
        byte  cn,"(",$2E,$22,")",hd+im
        word  @PRTSTR+s


        byte  cn,"==",hd+im
        word  @ACON+s
        byte  cn,"org",hd
        word  @VORG+s
        byte  cn,"@org",hd
        word  w+datorg
        byte  cn,"byte",hd+im
        word  @VBYTE+s
        byte  cn,"word",hd+im
        word  @VWORD+s
        byte  cn,"long",hd+im
        word  @VLONG+s
        byte  cn,"bytes",hd+im
        word  @VBYTES+s
        byte  cn,"words",hd+im
        word  @VWORDS+s
        byte  cn,"longs",hd+im
        word  @VLONGS+s
        byte  cn,"ALIGNORG",hd
        word  @VALIGN+s

        byte  cn,"ALIGN",hd
        word  @ALIGN+s

        byte  cn,":",hd+im
        word  @COLON+s
        byte  cn,"pre",hd+im
        word  @IMMDEF+s
        byte  cn,"pub",hd+im
        word  @PUBDEF+s
        byte  cn,"pri",hd+im
        word  @PRIDEF+s
        byte  cn,";",hd+im
        word  @ENDCOLON+s
        byte  cn,"RETURN",hd+im
        word  @aRETURN+s
        byte  cn,"[C]",hd+im
        word  @COMPILES+s

        byte  cn,"'",hd+im
        word  @TICK+s
        byte  cn,"[']",hd
        word  @ATICK+s
        byte  cn,"NFA'",hd+im
        word  @NFATICK+s

        byte  cn,"OFF",hd
        word  w+0
        byte  cn,"ON",hd
        word  MINUS1
        byte  cn,"0-1",hd
        word  MINUS1


        byte  cn,"ALIAS",hd+im
        word  @ALIAS+s
        byte  cn,"GRAB",hd+im
        word  @GRAB+s

' RUNMODs
        byte  cn,"[WS2812]",hd
        word  @_WS2812+s
        byte  cn,"[SDRDF]",hd
        word  @SDRDF+s
        byte  cn,"[SDRD]",hd
        word  @SDRD+s
        byte  cn,"[SDWR]",hd
        word  @SDWR+s
        byte  cn,"[SDIO]",hd
        word  @SDIO+s
        byte  cn,"[SSD!]",hd
        word  @SSDST+s
        byte  cn,"[PWM32]",hd
        word  @_PWM32+s
        byte  cn,"[PWM32!]",hd
        word  @_PWMST32+s
        byte  cn,"[PLOT]",hd
        word  @PLOT+s
        byte  cn,"[ROL3]",hd
        word  @ROL3+s
        byte  cn,"[CAP]",hd
        word  @_CAP+s
        byte  cn,"[WAV]",hd
        word  @PLAY+s
        byte  cn,"[MCP32]",hd
        word  @MCP32+s
        byte  cn,"[RCTIME]",hd
        word  @RCTIME+s

' GLOBAL VARIABLES
        byte  cn,"dmm",hd
        word  w+dmm
        byte  cn,"errors",hd
        word  w+errors
        byte  cn,"uhere",hd
        word  w+uhere
        byte  cn,"uthere",hd
        word  w+uthere
        byte  cn,"flags",hd
        word  w+flags
        byte  cn,"prompt",hd
        word  w+uprompt
        byte  cn,"uauto",hd
        word  w+uauto
        byte  cn,"keypoll",hd
        word  w+keypoll
        byte  cn,"lastkey",hd
        word  w+lastkey
        byte  cn,"rxpars",hd
        word  @RXPARS+s
        byte  cn,"rx",hd
        word  w+rxptr
        byte  cn,"id",hd
        word  w+@prmid+s

        byte  cn,"keytable",hd
        word  w+@keyactions+s


' TASK REGISTERS
        byte  cn,"@WORD",hd
        word  rg+wordbuf
        byte  cn,"uemit",hd
        word  rg+uemit
        byte  cn,"ukey",hd
        word  rg+ukey
        byte  cn,"base",hd
        word  rg+base
        byte  cn,"num",hd
        word  rg+inpnum
        byte  cn,"uswitch",hd
        word  rg+uswitch
        byte  cn,"undef",hd
        word  rg+undef



        byte  cn,"V4",hd
        word  _NOP

        byte  cn,"*end*",hd
        word  _NOP


enddict word  0        ' Mark the end of the kernel dictionary










DAT { *** ROMS ***  copied into upper EEPROM after EXTEND is loaded to free hub RAM }

        long  0[1500]
              org
roms          byte "ROMS"
              long @romend-@roms
              byte "ROMS"                      ' verification sig.





{

DAT { *** SPLATCAP - HIGH SPEED DIGITAL LOGIC CAPTURE *** }

                        org
              byte ".ROM"                       ' ROM signature
              word @capend-@cogcap              ' size
              byte "SPLATCAP  "                ' name 9 chars

              org

{ SPLAT CAPTURE COG - work in progress
Address of control registers passed in PAA

PAR:
cmd     2
        2
actmask 4
bufptr  2
bufsz   2
trig    4


capture routine looks for change of state on masked bits


}
                        org
COGCAP                  mov     ccr1,par
                        add     ccr1,#4
                        rdlong  ccmask,ccr0             ' read mask
                        add     ccr1,#4
                        rdword  cchub,ccr0              ' pointer to secondary hub buffer

                        mov     ccr0,ina                ' look for change of state by reading INA first
                        waitpne ccr0,ccmask             ' wait for change on those masked bits
cogbufwr                mov     cogbuf,ina
                        add     cogbufwr,incwr


incwr                   long    $200

                    mov         R1,tos wz               ' read delay
        if_z        movs        CCAPINS,#CCAPLP1          ' if zero then adjust loop to run without delay
        if_nz       add         R1,cnt
CCAPLP
        if_nz       waitcnt     R1,tos                  ' (6+) if dly is set correctly then waitcnt can be considered a 6+ cycle NOP
CCAPLP1              mov         ina,ina                 ' (4) read INA into its shadow (for dest field)
                    wrlong      ina,tos+2               ' (8..23) save it
                    add         tos+2,#4                ' (4) next long in memory
CCAPINS              djnz        tos+1,#CCAPLP wz         ' (4)
                    jmp         #DROP3


capend
ccr0                    res 1
ccr1                    res 1
ccmask                  res 1
cchub                   res 1
cogbuf                                                  ' storage area for samples


}





DAT { *** VGA 32x15 minimal footprint text driver *** }

                        org
              byte ".ROM"                       ' ROM signature
              word @vgaend-@vgarun              ' size
              byte "VGA32x15  "                ' name 9 chars
              '     1234567890

'{
' VGA
''***************************************
''*  VGA Driver v1.1                    *
''*  Author: Chip Gracey                *
''*  Copyright (c) 2006 Parallax, Inc.  *
''*  See end of file for terms of use.  *
''***************************************

CON

  paramcount    = 21
  colortable    = $180  'start of colortable inside cog


DAT { *** VGA DRIVER *** }

'********************************
'* Assembly language VGA driver *
'********************************

                        org
'
'
' Entry
'
vgarun                  mov     taskptr,#vgatasks        'reset tasks

                        mov     xx,#8                    'perform task sections initially
:init                   jmpret  taskret,taskptr
                        djnz    xx,#:init
'
'
' Superfield
'
superfield              mov     hv,hvbase               'set hv
                        mov     interlace,#0            'reset interlace
                        test    _mode,#%0100    wz      'get interlace into nz
'
'
' Field
'
field                   wrlong  visible,par             'set status to visible

                        tjz     vb,#:nobl               'do any visible back porch lines
                        mov     xx,vb
                        movd    bcolor,#colortable
                        call    #blank_line
:nobl
                        mov     screen,_screen          'point to first tile (upper-leftmost)
                        mov     vy,_vt                   'set vertical tiles
:line                   mov     vx,_vx                  'set vertical expand
:vert   if_nz           xor     interlace,#1            'interlace skip?
        if_nz           tjz     interlace,#:skip

                        tjz     hb,#:nobp               'do any visible back porch pixels
                        mov     vscl,hb
                        waitvid colortable,#0
:nobp
                        mov     xx,_ht                   'set horizontal tiles
                        mov     vscl,hx                 'set horizontal expand

''        bits 15..10: select the colorset* for the associated pixel tile
''        bits 9..0: select the pixelgroup** address %ppppppppppcccc00 (p=address, c=0..15)

:tile                   rdword  tile,screen             'read tile ($3A30)
                        add     tile,line               'set pointer bits into tile ($6.3A30)
                        rol     tile,#6                 'read tile pixels ($18E.8C00) 64 bytes/pixel
                        rdlong  pixels,tile             '(8 clocks between reads)
                        shr     tile,#10+6              'set tile colors ($18E)
                        movd    :color,tile
                        add     screen,#2               'point to next tile
:color                  waitvid colortable,pixels       'pass colors and pixels to video
                        djnz    xx,#:tile                'another tile?

                        sub     screen,hc2x             'repoint to first tile in same line

                        tjz     hf,#:nofp               'do any visible front porch pixels
                        mov     vscl,hf
                        waitvid colortable,#0
:nofp
                        mov     xx,#1                    'do hsync
                        call    #blank_hsync            '(x=0)

:skip                   djnz    vx,#:vert               'vertical expand?
                        ror     line,linerot            'set next line
                        add     line,lineadd    wc
                        rol     line,linerot
        if_nc           jmp     #:line
                        add     screen,hc2x             'point to first tile in next line
                        djnz    vy,#:line        wc      'another tile line? (c=0)

                        tjz     vf,#:nofl               'do any visible front porch lines
                        mov     xx,vf
                        movd    bcolor,#colortable
                        call    #blank_line
:nofl
        if_nz           xor     interlace,#1    wc,wz   'get interlace and field1 into nz (c=0/?)

        if_z            wrlong  invisible,par           'unless interlace and field1, set status to invisible

                        mov     taskptr,#vgatasks          'reset tasks

                        addx    xx,_vf           wc      'do invisible front porch lines (x=0 before, c=0 after)
                        call    #blank_line

                        mov     xx,_vs                   'do vsync lines
                        call    #blank_vsync

                        mov     xx,_vb                   'do invisible back porch lines, except last
                        call    #blank_vsync

        if_nz           jmp     #field                  'if interlace and field1, display field2
                        jmp     #superfield             'else, new superfield
'
'
' Blank line(s)
'
blank_vsync             cmp     interlace,#2    wc      'vsync (c=1)

blank_line              mov     vscl,h1                 'blank line or vsync-interlace?
        if_nc           add     vscl,h2
        if_c_and_nz     xor     hv,#%01
        if_c            waitvid hv,#0
        if_c            mov     vscl,h2                 'blank line or vsync-normal?
        if_c_and_z      xor     hv,#%01
bcolor                  waitvid hv,#0

        if_nc           jmpret  taskret,taskptr         'call task section (z undisturbed)

blank_hsync             mov     vscl,_hf                'hsync, do invisible front porch pixels
                        waitvid hv,#0

                        mov     vscl,_hs                'do invisble sync pixels
                        xor     hv,#%10
                        waitvid hv,#0

                        mov     vscl,_hb                'do invisible back porch pixels
                        xor     hv,#%10
                        waitvid hv,#0

                        djnz    xx,#blank_line   wc      '(c=0)

                        movd    bcolor,#hv
blank_hsync_ret
blank_line_ret
blank_vsync_ret         ret
'
'
' Tasks - performed in sections during invisible back porch lines
'
 vgatasks                   mov     t1,par                  'load parameters
                        movd    :par,#_enable           '(skip _status)
                        mov     t2,#paramcount - 1
:load                   add     t1,#4
:par                    rdlong  0,t1
                        add     :par,d0
                        djnz    t2,#:load               '+164

                        mov     t1,#2                   'set video pins and directions
                        shl     t1,_pins                '(if video disabled, pins will drive low)
                        sub     t1,#1
                        test    _pins,#$20      wc
                        and     _pins,#$38
                        shr     t1,_pins
                        movs    vcfg,t1
                        shl     t1,_pins
                        shr     _pins,#3
                        movd    vcfg,_pins
        if_nc           mov     dira,t1
        if_nc           mov     dirb,#0
        if_c            mov     dira,#0
        if_c            mov     dirb,t1                 '+14

                        tjz     _enable,#disabled       '+2, disabled?

                        jmpret  taskptr,taskret         '+1=181, break and return later

                        rdlong  t1,#0                   'make sure CLKFREQ => 16MHz
                        shr     t1,#1
                        cmp     t1,m8           wc
        if_c            jmp     #disabled               '+8

                        min     _rate,pllmin            'limit _rate to pll range
                        max     _rate,pllmax            '+2

                        mov     t1,#%00001_011          'set ctra configuration
:max                    cmp     m8,_rate        wc      'adjust rate to be within 4MHz-8MHz
        if_c            shr     _rate,#1                '(vco will be within 64MHz-128MHz)
        if_c            add     t1,#%00000_001
        if_c            jmp     #:max
:min                    cmp     _rate,m4        wc
        if_c            shl     _rate,#1
        if_c            sub     xx,#%00000_001
        if_c            jmp     #:min
                        movi    ctra,t1                 '+22

                        rdlong  t1,#0                   'divide _rate/CLKFREQ and set frqa
                        mov     hvbase,#32+1
:div                    cmpsub  _rate,t1        wc
                        rcl     t2,#1
                        shl     _rate,#1
                        djnz    hvbase,#:div            '(hvbase=0)
                        mov     frqa,t2                 '+136

                        test    _mode,#%0001    wc      'make hvbase
                        muxnc   hvbase,vmask
                        test    _mode,#%0010    wc
                        muxnc   hvbase,hmask            '+4

                        jmpret  taskptr,taskret         '+1=173, break and return later

                        mov     hx,_hx                  'compute horizontal metrics
                        shl     hx,#8
                        or      hx,_hx
                        shl     hx,#4

                        mov     hc2x,_ht
                        shl     hc2x,#1

                        mov     h1,_hd
                        neg     h2,_hf
                        sub     h2,_hs
                        sub     h2,_hb
                        sub     h1,h2
                        shr     h1,#1           wc
                        addx    h2,h1

                        mov     t1,_ht
                        mov     t2,_hx
                        call    #vmul
                        mov     hf,_hd
                        sub     hf,t1
                        shr     hf,#1           wc
                        mov     hb,_ho
                        addx    hb,hf
                        sub     hf,_ho                  '+59

                        mov     t1,_vt                  'compute vertical metrics
                        mov     t2,_vx
                        call    #vmul
                        test    _mode,#%1000    wc      'consider tile size
                        muxc    linerot,#1
                        mov     lineadd,lineinc
        if_c            shr     lineadd,#1
        if_c            shl     t1,#1
                        test    _mode,#%0100    wc      'consider interlace
        if_c            shr     t1,#1
                        mov     vf,_vd
                        sub     vf,t1
                        shr     vf,#1           wc
                        neg     vb,_vo
                        addx    vb,vf
                        add     vf,_vo                  '+53

                        movi    vcfg,#%01100_000        '+1, set video configuration

:colors                 jmpret  taskptr,taskret         '+1=114/160, break and return later

                        mov     t1,#13                  'load next 13 colors into colortable
:loop                   mov     t2,:color               '5 times = 65 (all 64 colors loaded)
                        shr     t2,#9-2
                        and     t2,#$FC
                        add     t2,_colors
                        rdlong  t2,t2
                        and     t2,colormask
                        or      t2,hvbase
:color                  mov     colortable,t2
                        add     :color,d0
                        andn    :color,d6
                        djnz    t1,#:loop               '+158

                        jmp     #:colors                '+1, keep loading colors
'
'
' Multiply t1 * t2 * 16 (t1, t2 = bytes)
'
vmul                shl     t2,#8+4-1

                        mov     tile,#8
:loop                   shr     t1,#1           wc
        if_c            add     t1,t2
                        djnz    tile,#:loop

vmul_ret            ret                             '+37
'
'
' Disabled - reset status, nap ~4ms, try again
'
disabled                mov     ctra,#0                 'reset ctra
                        mov     vcfg,#0                 'reset video

                        wrlong  outa,par                'set status to disabled

                        rdlong  t1,#0                   'get CLKFREQ
                        shr     t1,#8                   'nap for ~4ms
                        min     t1,#3
                        add     t1,cnt
                        waitcnt t1,#0

                        jmp     #vgarun                  'reload parameters
'
'
' Initialized data
'
pllmin                  long    500_000                 'pll lowest output frequency
pllmax                  long    128_000_000             'pll highest output frequency
m8                      long    8_000_000               '*16 = 128MHz (pll vco max)
m4                      long    4_000_000               '*16 = 64MHz (pll vco min)
d0                      long    1 << 9 << 0
d6                      long    1 << 9 << 6
invisible               long    1
visible                 long    2
line                    long    $00060000
lineinc                 long    $10000000
linerot                 long    0
vmask                   long    $01010101
hmask                   long    $02020202
colormask               long    $FCFCFCFC
'
'
' Uninitialized data
'
taskptr                 res     1                       'tasks
taskret                 res     1
t1                      res     1
t2                      res     1

xx                      res     1                       'display
vy                       res     1
hf                      res     1
hb                      res     1
vf                      res     1
vb                      res     1
hx                      res     1
vx                      res     1
hc2x                    res     1
screen                  res     1
tile                    res     1
pixels                  res     1
lineadd                 res     1
interlace               res     1
hv                      res     1
hvbase                  res     1
h1                      res     1
h2                      res     1
'
'
' Parameter buffer
'
_enable                 res     1       '0/non-0        read-only
_pins                   res     1       '%pppttt        read-only
_mode                   res     1       '%tihv          read-only
_screen                 res     1       '@word          read-only
_colors                 res     1       '@long          read-only
_ht                     res     1       '1+             read-only
_vt                     res     1       '1+             read-only
_hx                     res     1       '1+             read-only
_vx                     res     1       '1+             read-only
_ho                     res     1       '0+-            read-only
_vo                     res     1       '0+-            read-only
_hd                     res     1       '1+             read-only
_hf                     res     1       '1+             read-only
_hs                     res     1       '1+             read-only
_hb                     res     1       '1+             read-only
_vd                     res     1       '1+             read-only
_vf                     res     1       '1+             read-only
_vs                     res     1       '1+             read-only
_vb                     res     1       '2+             read-only
_rate                   res     1       '500_000+       read-only

vgaend
'                       long 0[30]      ' pad out to allow this image to be used as a screen buffer
''                        fit     colortable              'fit underneath colortable ($180-$1BF)
'}











DAT { *** HSUART - HIGH SPEED HALF-DUPLEX SERIAL TRANSMIT & RECEIVE *** }

                        org
              byte ".ROM"                       ' ROM signature
              word @UARTEnd-@UART               ' size
              byte "HSUART    "                 ' name
              '     1234567890


'**************************************** SERIAL RECEIVE ******************************************

{ This is a dedicated serial receive routine that runs in it's own cog }
{
PAR (longs)
0        rxmask
4        txmask
8        temask
12       mode
16        ticks
20        rxbuf
24        rxsiz
28        txbuf           a single long

}
                        	org
UART
                        mov     ur0,#8
                        mov     upar,par
uparlp                  rdlong  urxpin,upar             ' read in next parameter
                        add     uparlp,uinc             ' increment dst field (add $200)
                        add     upar,#4
                        djnz    ur0,#uparlp
                        ' parameters loaded - setup
                        mov     uhubrxwr,urxbuf            ' set pointer to rxwrite index
                        sub     uhubrxwr,#2
		        mov	urxwr,#0	        ' init rxwrite index
 			wrword	urxwr,uhubrxwr 	        ' clear rxrd in hub
                        or      outa,utxpin             ' assert txpin
                        or      dira,utxpin

			mov	ustticks,uticks	        ' calculate start bit timing
 			shr	ustticks,#1	        ' half a bit time less
 			sub	ustticks,#8	        ' compensate timing - important at high speeds

hsrxtx
                        mov	ucnt,ustticks	        ' Adjusted bit timing for start bit
                        mov     ur0,#30                 ' prioritize rx start detection, esp after a transmit
hslp                    test    urxpin,ina wc
        if_nc           jmp     #hsrx
                        djnz    ur0,#hslp
hsrx1                   rdword  udata,utxbuf wz         ' any data to send? (non-zero word) - rdword limits use to around 1Mbps max
        if_nz           jmp     #utxchk
                        jmp     #hsrxtx

hsrx
 			add	ucnt,cnt                ' uses special start bit timing (ustticks)
 			waitcnt	ucnt,uticks
 			test	urxpin,ina       wz     ' sample middle of start bit
urxcond2	if_nz	jmp	#hsrxtx                	' restart if false start otherwise bit time from center
 			waitcnt	ucnt,uticks	        ' wait until middle of first data bit
 			test	urxpin,ina wc	        ' sample bit 0
 			muxc	udata,#01	        ' and assemble rxdata
 			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 1
 			muxc	udata,#02
 			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 2
 			muxc	udata,#04
 			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 3
 			muxc	udata,#08
 			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 4
 			muxc	udata,#$10
			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 5
 			muxc	udata,#$20
 			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 6
 			muxc	udata,#$40
 			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 7
 			muxc	udata,#$80

 			waitcnt	ucnt,uticks
 			test	urxpin,ina wc	        ' sample bit 8 into if enabled (9TH BIT)
                        tjz     umode,#ufe

ustopins		waitcnt	ucnt,uticks	        ' check stop bit
 			muxc	udata,#$100             ' delayed op due to max speed, stop bit sample less important
 			test	urxpin,ina wc	        ' sample stop bit into C
ufe     if_nc           jmp     #hsrx1                 ' ignore on framing error but don't block transmit on line break
                        '
 			mov	ur0,urxbuf	        ' calc write pointer
 			add	ur0,urxwr	        ' UR0 points to buffer location to store
 			add	urxwr,#1	        ' update write index
 			wrbyte	udata,ur0	        ' save data in buffer - could take 287.5ns worst case
                        cmp     urxwr,urxsz wc           ' wraparound?
        if_nc           mov     urxwr,#0
'                        cmp     udata,udata wz          ' set Z flag to before jumping into middle of receive loop
		        wrword	urxwr,uhubrxwr	        ' update hub index for code reading the buffer
 			jmp	#hsrxtx


utxchk                  shr     udata,#15 wz,nr         ' Command code if bit 15 is set

              if_z      jmp     #utransmit
                        wrword  unull,utxbuf            ' reset txbuf ready for next character
                        and     udata,#$1FF             ' mask
                        cmp     udata,#$FF wz           ' STOP?
              if_z      jmp     #hsstop
hsstop                  mov     dira,#0                 ' release all pins
                        cogid   udata
                        cogstop udata
                        jmp	#hsrxtx
'}

' TRANSMIT CODE
utransmit
                        or      dira,utepin             ' assert TE if enabled
                        or      outa,utepin
                        wrword  unull,utxbuf            ' reset txbuf ready for next character
                        or      outa,utxpin             ' assert txpin
                        or      dira,utxpin
'                        mov     ur0,#10
                        test    umode,#1 wz             ' 9-bit mode?
              if_nz     or      udata,ustops
              if_z      or      udata,#$100             ' add a stop bit
                        shl     udata,#1                ' insert a start bit
                        mov     ucnt,uticks
 			add	ucnt,cnt                ' uses special start bit timing
utxlp
                        shr     udata,#1 wc
                        muxc    outa,utxpin
 			waitcnt	ucnt,uticks
                        tjnz    udata,#utxlp            ' continue to send until there are no stop bits left (all zeros)
                        tjz     utepin,#hsrxtx wz         ' check to see if we need to turnaround rx/tx
                        andn    outa,utepin             ' switch back to receive
                        andn    dira,utxpin             ' release shared tx line (based on tepin)
'                        andn    dira,utepin             ' release shared tx line (based on tepin if tepin = txpin )
'                        cmp     udata,udata wz          ' set Z flag to before jumping into middle of receive loop
                        jmp     #hsrxtx               ' return to receive but prioritize receive check first
{
ptxb                    muxc    outa,trpin              ' output bit
                        shr     txdat,#1 wz,wc          ' lsb first
                        waitcnt rxcnt,pticks            ' bit timing
        if_nz_or_c      jmp     #ptxb                   ' next bit (stop bit: z & c)
                        andn    dira,trpin              ' float data line back to receive
                        andn    outa,tepin              ' Turn line back to receive
}
uinc                    long    $200
unull                   long    0
ustops                  long    $200
'uio                     long    $0004_0000

' parameters
urxpin			res 1
utxpin                  res 1
utepin                  res 1
umode                   res 1
uticks		        res 1
urxbuf			res 1
urxsz                   res 1
utxbuf                  res 1

uhubrxwr		res 1

ustticks		res 1

ucnt			res 1
udata			res 1               	'assembled character
urxwr			res 1	                'cog receive buffer write index - copied to hub ram
ur0			res 1
upar                    res 1
uartend










DAT { *** F32 Floating Point *** }

CON
  SignFlag      = $1
  ZeroFlag      = $2
  NaNFlag       = $8

DAT
                 org
              byte ".ROM"                       ' ROM signature
              word @F32end-@F32                 ' size
              byte "F32       "                 ' name
              '     1234567890


'----------------------------
' Assembly language routines
'----------------------------

'----------------------------
' Main control loop
'----------------------------
                        org     0                       ' (try to keep 2 or fewer instructions between rd/wrlong)
F32                     rdlong  ret_ptr, par wz         ' wait for command to be non-zero, and store it in the call location
              if_z      jmp     #f32

                        rdlong  :execCmd, ret_ptr       ' get the pointer to the return value ("@result")
                        add     ret_ptr, #4

                        rdlong  fNumA, ret_ptr          ' fnumA is the long after "result"
                        add     ret_ptr, #4

                        rdlong  fNumB, ret_ptr          ' fnumB is the long after fnumA
                        sub     ret_ptr, #8

:execCmd                nop                             ' execute command, which was replaced by getCommand

:finishCmd              wrlong  fnumA, ret_ptr          ' store the result (2 longs before fnumB)
                        wrlong  outb, par               ' clear command status (outb is initialized to 0)
                        jmp     #f32                ' wait for next command


'----------------------------
' addition and subtraction
' fnumA = fnumA +- fnumB
'----------------------------
_FSub                   xor     fnumB, Bit31            ' negate B
_FAdd                   call    #_Unpack2               ' unpack two variables
          if_c_or_z     jmp     _FAdd_ret              ' check for NaN or B = 0

                        test    flagA, #SignFlag wz     ' negate A mantissa if negative
          if_nz         neg     manA, manA
                        test    flagB, #SignFlag wz     ' negate B mantissa if negative
          if_nz         neg     manB, manB

                        mov     ft1, expA                ' align mantissas
                        sub     ft1, expB
                        abs     ft1, ft1          wc
                        max     ft1, #31
              if_nc     sar     manB, ft1
              if_c      sar     manA, ft1
              if_c      mov     expA, expB

                        add     manA, manB              ' add the two mantissas
                        abs     manA, manA      wc      ' store the absolte value,
                        muxc    flagA, #SignFlag        ' and flag if it was negative

                        call    #_Pack                  ' pack result and exit
_FSub_ret
_FAdd_ret               ret


'----------------------------
' multiplication
' fnumA *= fnumB
'----------------------------
_FMul                   call    #_Unpack2               ' unpack two variables
              if_c      jmp     _FMul_ret              ' check for NaN

                        xor     flagA, flagB            ' get sign of result
                        add     expA, expB              ' add exponents

                        '{ new method: 4 * (4 * 24 + 10) = 424 counts for this block,
                        ' worst case.  But, it is within the window of the calling Spin
                        ' repeat loop, so un-noticable.  And the best case scenario is
                        ' better.
                        neg     ft1, manA                ' isolate the low bit of manA
                        and     ft1, manA
                        neg     ft2, manB                ' isolate the low bit of manB
                        and     ft2, manB
                        cmp     ft1, ft2 wc               ' who has the greater low bit?  After reversal, this will go to 0 faster.
              if_c      mov     ft1, manA wz             ' if t1 is 0, we'll just skip through everything              '
              if_nc     mov     ft1, manB wz             ' ditto, only t1 is manB
              if_nc     mov     manB, manA              ' and in this case we wanted manA to be the multiplier mask

                        mov     manA, #0                ' manA is my new accumulator
                        rev     manB, #32-30            ' start by right aligning the reverse of the B mantissa

:multiply     if_nz     shr     manB, #1 wc,wz          ' get multiplier bit, and take note if we hit 0 (skip if t1 was already 0!)
              if_c      add     manA, ft1                ' if the bit was set, add in the multiplicand
                        shr     ft1, #1                  ' adjust my increment value's bit alignment
              if_nz     jmp     #:multiply              ' go back for more
                        '}

                        { standard method: 404 counts for this block
                        mov     ft1, #0                  ' t1 is my accumulator
                        mov     ft2, #24                 ' loop counter for multiply (only do the bits needed...23 + implied 1)
                        shr     manB, #6                ' start by right aligning the B mantissa

:multiply               shr     ft1, #1                  ' shift the previous accumulation down by 1
                        shr     manB, #1 wc             ' get multiplier bit
              if_c      add     ft1, manA                ' if the bit was set, add in the multiplicand
                        djnz    ft2, #:multiply          ' go back for more
                        mov     manA, ft1                ' yes, that's my final answer.
                        '}

                        call    #_Pack
_FMul_ret               ret


'----------------------------
' division
' fnumA /= fnumB
'----------------------------
_FDiv                   call    #_Unpack2               ' unpack two variables
          if_c_or_z     mov     fnumA, NaN              ' check for NaN or divide by 0
          if_c_or_z     jmp     _FDiv_ret

                        xor     flagA, flagB            ' get sign of result
                        sub     expA, expB              ' subtract exponents

                        ' slightly faster division, using 26 passes instead of 30
                        mov     ft1, #0                  ' clear quotient
                        mov     ft2, #26                 ' loop counter for divide (need 24, plus 2 for rounding)

:divide                 ' divide the mantissas
                        cmpsub  manA, manB      wc
                        rcl     ft1, #1
                        shl     manA, #1
                        djnz    ft2, #:divide
                        shl     ft1, #4                  ' align the result (we did 26 instead of 30 iterations)

                        mov     manA, ft1                ' get result and exit
                        call    #_Pack

_FDiv_ret               ret

'------------------------------------------------------------------------------
' fnumA = float(fnumA)
'------------------------------------------------------------------------------
_FFloat                 abs     manA, fnumA     wc,wz   ' get |integer value|
              if_z      jmp     _FFloat_ret            ' if zero, exit
                        muxc    flagA, #SignFlag        ' depending on the integer's sign
                        mov     expA, #29               ' set my exponent
                        call    #_Pack                  ' pack and exit
_FFloat_ret             ret

'------------------------------------------------------------------------------
' rounding and truncation
' fnumB controls the output format:
'       %00 = integer, truncate
'       %01 = integer, round
'       %10 = float, truncate
'       %11 = float, round
'------------------------------------------------------------------------------
_FTruncRound            mov     ft1, fnumA               ' grab a copy of the input
                        call    #_Unpack                ' unpack floating point value

                        ' Are we going for float or integer?
                        cmpsub  fnumB, #%10     wc      ' clear bit 1 and set the C flag if it was a 1
                        rcl     ft2, #1
                        and     ft2, #1          wz      ' Z now signified integer output

                        shl     manA, #2                ' left justify mantissa
                        sub     expA, #30               ' our target exponent is 30
                        abs     expA, expA      wc      ' adjust for exponent sign, and track if it was negative

              if_z_and_nc mov   manA, NaN               ' integer output, and it's too large for us to handle
              if_z_and_nc jmp   #:check_sign

              if_nz_and_nc mov  fnumA, ft1                ' float output, and we're already all integer
              if_nz_and_nc jmp  _FTruncRound_ret

                        ' well, I need to kill off some bits, so let's do it
                        cmp     expA, #32       wc      ' DO set the C flag here...I want to know if expA =< 31, aka < 32
                        max     expA, #31               ' DON'T set the C flag here...max sets C if D<S
                        shr     manA, expA
              if_c      add     manA, fnumB             ' round up 1/2 lsb if desired, and if it isn't supposed to be 0! (if expA was > 31)
                        shr     manA, #1

              if_z      jmp     #:check_sign            ' integer output?

                        mov     expA, #29
                        call    #_Pack
                        jmp     _FTruncRound_ret

:check_sign             test    flagA, #signFlag wz     ' check sign and exit
                        negnz   fnumA, manA

_FTruncRound_ret        ret


'------------------------------------------------------------------------------
' truncation to unsigned integer
' fnumA = unsigned int(fnumA), clamped to 0
'------------------------------------------------------------------------------
_UintTrunc              call    #_Unpack
                        mov     fnumA, #0
                        test    flagA, #SignFlag wc
              if_c_or_z jmp     _UintTrunc_ret         ' if the input number was negative or zero, we're done
                        shl     manA, #2                ' left justify mantissa
                        sub     expA, #31               ' our target exponent is 31
                        abs     expA, expA      wc,wz
              if_a      neg     fnumA, #1               ' if we needed to shift left, we're already maxed out
              if_be     cmp     expA, #32       wc      ' otherwise, if we need to shift right by more than 31, the answer is 0
              if_c      shr     manA, expA              ' OK, shift it down
              if_c      mov     fnumA, manA
_UintTrunc_ret          ret


'------------------------------------------------------------------------------
' square root
' fnumA = sqrt(fnumA)
'------------------------------------------------------------------------------
_FSqr                   call    #_Unpack                 ' unpack floating point value
          if_c_or_z     jmp     _FSqr_ret               ' check for NaN or zero
                        test    flagA, #signFlag wz      ' check for negative
          if_nz         mov     fnumA, NaN               ' yes, then return NaN
          if_nz         jmp     _FSqr_ret

                        sar     expA, #1 wc             ' if odd exponent, shift mantissa
          if_c          shl     manA, #1
                        add     expA, #1
                        mov     ft2, #29

                        mov     fnumA, #0               ' set initial result to zero
:sqrt                   ' what is the delta root^2 if we add in this bit?
                        mov     t3, fnumA
                        shl     t3, #2
                        add     t3, #1
                        shl     t3, ft2
                        ' is the remainder >= delta?
                        cmpsub  manA, t3        wc
                        rcl     fnumA, #1
                        shl     manA, #1
                        djnz    ft2, #:sqrt

                        mov     manA, fnumA             ' store new mantissa value and exit
                        call    #_Pack
_FSqr_ret               ret


'------------------------------------------------------------------------------
' compare fnumA , fnumB
' fnumA =
'       1 if fnumA > fnumB
'       -1 if fnumA < fnumB
'       0 if fnumA = fnumB
'------------------------------------------------------------------------------
_FCmp                   mov     ft1, fnumA               ' if both values...
                        and     ft1, fnumB               '  are negative...
                        shl     ft1, #1 wc               ' (bit 31 high)...
                        negc    ft1, #1                  ' then the comparison will be reversed
                        cmps    fnumA, fnumB wc,wz      ' do the signed comparison, save result in flags C Z
              if_z      mov     ft1, #0
                        or      fnumA, fnumB            ' +0 == -0, so compare for both being 0...
                        andn    fnumA, Bit31 wz         ' ignoring bit 31, will be 0 if both fA and fB were zero
              if_nz     negc    fnumA, ft1               ' if it's not zero
_FCmp_ret               ret


'------------------------------------------------------------------------------
' new table lookup code
' Inputs
' t1 = 31-bit number: 1-bit 0, then 11-bits real, then 20-bits fraction (allows the sine table to use the top bit)
' t2 = table base address
' Outputs
' t1 = 30-bit interpolated number
'------------------------------------------------------------------------------
_Table_Interp           ' store the fractional part
                        mov     t4, ft1                  ' will store reversed so a SAR will shift the value and get a bit
                        rev     t4, #12                 ' ignore the top 12 bits, and reverse the rest
                        ' align the input number to get the table offset, multiplied by 2
                        shr     ft1, #19
                        test    ft2, SineTable    wc      'C = 1 if we're doing a SINE table lookup.  added to fix LOG and SIN
                        add     ft2, ft1
                        ' read the 2 intermediate values, and scale them for interpolation
                        rdword  ft1, ft2
                        shl     ft1, #14

                        add     ft2, #2

                        test    ft2, TableMask   wz      'table address has overflowed.  added to fix LOG
        if_z_and_nc     mov     ft2, Bit16               'fix table value unless we're doing the SINE table.  added to fix LOG
        if_nz_or_c      rdword  ft2, ft2                  'else, look up the correct value.  conditional added to fix LOG
                        shl     ft2, #14
                        ' interpolate
                        sub     ft2, ft1                  ' change from 2 points to delta
                        movs    ft2, t4                  ' make the low 9 bits the multiplier (reversed)
                        mov     t3, #9                  ' do 9 steps
:interp                 sar     ft2, #1          wc      ' divide the delta by 2, and get the MSB multiplier bit
              if_c      add     ft1, ft2                  ' if the multiplier bit was 1, add in the shifter delta
                        djnz    t3, #:interp            ' keep going, 9 times around
                        ' done, and the answer is in t1, bit 29 aligned
_Table_Interp_ret       ret


'------------------------------------------------------------------------------
' sine and cosine
' fnumA = sin(fnumA) for sine
' fnumA = sin(fnumA+pi/2) for cosine
' note: resume tan allows reuse of the angle scaling when calling
' both sine and cosine of the same angle.
'------------------------------------------------------------------------------
OneOver2Pi              long    1.0 / (2.0 * pi)        ' I need this constant to get the fractional angle

_Cos                    mov     t4, bit29               ' adjust sine to cosine at the last possible minute by adding 90 degrees
                        andn    fnumA, bit31            ' nuke the sign bit
                        jmp     #_SinCos_cont

_Sin                    mov     t4, #0                  ' just sine, and keep my sign bit

_SinCos_cont            mov     fnumB, OneOver2Pi
                        call    #_FMul                  ' rescale angle from [0..2pi] to [0..1]

                        ' now, work with the raw value
                        call    #_Unpack

                        ' get the whole and fractional bits
                        add     expA, #2                ' bias the exponent by 3 so the resulting data will be 31-bit aligned
                        abs     expA, expA      wc      ' was the exponent positive or negative?
                        max     expA, #31               ' limit to 31, otherwise we do weird wrapping things
              if_c      shr     manA, expA              ' -exp: shift right to bring down to 1.0
              if_nc     shl     manA, expA              ' +exp: shift left to throw away the high bits

                        mov     t6, manA                ' store the address in case Tan needs it

                        add     manA, t4                ' adjust for cosine?

_resume_Tan             test    manA, bit29     wz
                        negnz   ft1, manA
                        shl     ft1, #2

                        mov     ft2, SineTable
                        call    #_Table_Interp

                        ' rebuild the number
                        test    manA, bit30     wz      ' check if we're in quadrant 3 or 4
                        abs     manA, ft1                ' move my number into the mantissa
                        shr     manA, #16               ' but the table went to $FFFF, so scale up a bit to
                        addabs  manA, ft1                ' get to &10000
              if_nz     xor     flagA, #SignFlag        ' invert my sign bit, if the mantissa would have been negative (quad 3 or 4)
                        neg     expA, #1                ' exponent is -1
                        call    #_Pack

_resume_Tan_ret
_Cos_ret
_Sin_ret                ret


'------------------------------------------------------------------------------
' tangent
' fnumA = tan(fnumA) = sin(fnumA) / cos(fnumA)
'------------------------------------------------------------------------------
_Tan                    call    #_Sin
                        mov     t7, fnumA
                        ' skip the angle normalizing, much faster
                        mov     manA, t6                ' was manA for Sine
                        add     manA, bit29             ' add in 90 degrees
                        call    #_resume_Tan            ' go back and recompute the float
                        mov     fnumB, fnumA            ' move Cosine into fnumB
                        mov     fnumA, t7               ' move Sine into fnumA
                        call    #_FDiv                  ' divide
_Tan_ret                ret


'------------------------------------------------------------------------------
' log2
' fnumA = log2(fnumA)
' may be divided by fnumB to change bases
'------------------------------------------------------------------------------
_Log2                   call    #_Unpack                ' unpack variable
          if_nz_and_nc  test    flagA, #SignFlag wc     ' if NaN or <= 0, return NaN
          if_z_or_c     jmp     #:exitNaN

                        mov     ft1, manA
                        shl     ft1, #3
                        shr     ft1, #1
                        mov     ft2, LogTable
                        call    #_Table_Interp
                        ' store the interpolated table lookup
                        mov     manA, ft1
                        shr     manA, #5                  ' clear the top 7 bits (already 2 free
                        ' process the exponent
                        abs     expA, expA      wc
                        muxc    flagA, #SignFlag
                        ' recombine exponent into the mantissa
                        shl     expA, #25
                        negc    manA, manA
                        add     manA, expA
                        mov     expA, #4
                        ' make it a floating point number
                        call    #_Pack
                        ' convert the base
                        cmp     fnumB, #0    wz         ' check that my divisor isn't 0 (which flags that we're doing log2)
              if_nz     call    #_FDiv                  ' convert the base (unless fnumB was 0)
                        jmp     _Log2_ret

:exitNaN                mov     fnumA, NaN              ' return NaN
_Log2_ret               ret

'------------------------------------------------------------------------------
' exp2
' fnumA = 2 ** fnumA
' may be multiplied by fnumB to change bases
'------------------------------------------------------------------------------
                        ' 1st off, convert the base
_Exp2                   cmp     fnumB, #0       wz
              if_nz     call    #_FMul

                        call    #_Unpack
                        shl     manA, #2                ' left justify mantissa
                        mov     ft1, expA                ' copy the local exponent

                        '        OK, get the whole number
                        sub     ft1, #30                 ' our target exponent is 31
                        abs     expA, ft1      wc        ' adjust for exponent sign, and track if it was negative
              if_c      jmp     #:cont_Exp2

                        ' handle this case depending on the sign
                        test    flagA, #signFlag wz
              if_z      mov     fnumA, NaN              ' nope, was positive, bail with NaN (happens to be the largest positive integer)
              if_nz     mov     fnumA, #0
                        jmp     _Exp2_ret

:cont_Exp2              mov     ft2, manA
                        max     expA, #31
                        shr     ft2, expA
                        shr     ft2, #1
                        mov     expA, ft2

                        ' get the fractional part
                        add     ft1, #31
                        abs     ft2, ft1          wc
              if_c      shr     manA, ft2
              if_nc     shl     manA, ft2

                        ' do the table lookup
                        mov     ft1, manA
                        shr     ft1, #1
                        mov     ft2, ALogTable
                        call    #_Table_Interp

                        ' store a copy of the sign
                        mov     t6, flagA

                        ' combine
                        mov     manA, ft1
                        or      manA, bit30
                        sub     expA, #1
                        mov     flagA, #0

                        call    #_Pack

                        test    t6, #signFlag wz        ' check sign and store this back in the exponent
              if_z      jmp     _Exp2_ret
                        mov     fnumB, fnumA            ' yes, then invert
                        mov     fnumA, One
                        call    #_FDiv

_Exp2_ret               ret


'------------------------------------------------------------------------------
' power
' fnumA = fnumA raised to power fnumB
'------------------------------------------------------------------------------
_Pow                    mov     t7, fnumA wc            ' save sign of result
          if_nc         jmp     #:pow3                  ' check if negative base

                        mov     fnumA, fnumB            ' check exponent
                        call    #_Unpack
                        mov     fnumA, t7               ' restore base
          if_z          jmp     #:pow2                  ' check for exponent = 0

                        test    expA, Bit31 wz          ' if exponent < 0, return NaN
          if_nz         jmp     #:pow1

                        max     expA, #23               ' check if exponent = integer
                        shl     manA, expA
                        and     manA, Mask29 wz, nr
          if_z          jmp     #:pow2                  ' yes, then check if odd

:pow1                   mov     fnumA, NaN              ' return NaN
                        jmp     _Pow_ret

:pow2                   test    manA, Bit29 wz          ' if odd, then negate result
          if_z          andn    t7, Bit31

:pow3                   andn    fnumA, Bit31            ' get |fnumA|
                        mov     t6, fnumB               ' save power
                        call    #_Log2                  ' get log of base
                        mov     fnumB, t6               ' multiply by power
                        call    #_FMul
                        call    #_Exp2                  ' get result

                        test    t7, Bit31 wz            ' check for negative
          if_nz         xor     fnumA, Bit31
_Pow_ret                ret


'------------------------------------------------------------------------------
' fraction
' fnumA = fractional part of fnumA
'------------------------------------------------------------------------------
_Frac                   call    #_Unpack                ' get fraction
                        test    expA, Bit31 wz          ' check for exp < 0 or NaN
          if_c_or_nz    jmp     #:exit
                        max     expA, #23               ' remove the integer
                        shl     manA, expA
                        and     manA, Mask29
                        mov     expA, #0                ' return fraction

:exit                   call    #_Pack
                        andn    fnumA, Bit31
_Frac_ret               ret


'------------------------------------------------------------------------------
' input:   fnumA        32-bit floating point value
'          fnumB        32-bit floating point value
' output:  flagA        fnumA flag bits (Nan, Infinity, Zero, Sign)
'          expA         fnumA exponent (no bias)
'          manA         fnumA mantissa (aligned to bit 29)
'          flagB        fnumB flag bits (Nan, Infinity, Zero, Sign)
'          expB         fnumB exponent (no bias)
'          manB         fnumB mantissa (aligned to bit 29)
'          C flag       set if fnumA or fnumB is NaN
'          Z flag       set if fnumB is zero
' changes: fnumA, flagA, expA, manA, fnumB, flagB, expB, manB, t1
'------------------------------------------------------------------------------
_Unpack2                mov     ft1, fnumA               ' save A
                        mov     fnumA, fnumB            ' unpack B to A
                        call    #_Unpack
          if_c          jmp     _Unpack2_ret           ' check for NaN

                        mov     fnumB, fnumA            ' save B variables
                        mov     flagB, flagA
                        mov     expB, expA
                        mov     manB, manA

                        mov     fnumA, ft1               ' unpack A
                        call    #_Unpack
                        cmp     manB, #0 wz             ' set Z flag
_Unpack2_ret            ret


'------------------------------------------------------------------------------
' input:   fnumA        32-bit floating point value
' output:  flagA        fnumA flag bits (Nan, Infinity, Zero, Sign)
'          expA         fnumA exponent (no bias)
'          manA         fnumA mantissa (aligned to bit 29)
'          C flag       set if fnumA is NaN
'          Z flag       set if fnumA is zero
' changes: fnumA, flagA, expA, manA
'------------------------------------------------------------------------------
_Unpack                 mov     flagA, fnumA            ' get sign
                        shr     flagA, #31
                        mov     manA, fnumA             ' get mantissa
                        and     manA, Mask23
                        mov     expA, fnumA             ' get exponent
                        shl     expA, #1
                        shr     expA, #24 wz
          if_z          jmp     #:zeroSubnormal         ' check for zero or subnormal
                        cmp     expA, #255 wz           ' check if finite
          if_nz         jmp     #:finite
                        mov     fnumA, NaN              ' no, then return NaN
                        mov     flagA, #NaNFlag
                        jmp     #:exit2

:zeroSubnormal          or      manA, expA wz,nr        ' check for zero
          if_nz         jmp     #:subnorm
                        or      flagA, #ZeroFlag        ' yes, then set zero flag
                        neg     expA, #150              ' set exponent and exit
                        jmp     #:exit2

:subnorm                shl     manA, #7                ' fix justification for subnormals
:subnorm2               test    manA, Bit29 wz
          if_nz         jmp     #:exit1
                        shl     manA, #1
                        sub     expA, #1
                        jmp     #:subnorm2

:finite                 shl     manA, #6                ' justify mantissa to bit 29
                        or      manA, Bit29             ' add leading one bit

:exit1                  sub     expA, #127              ' remove bias from exponent
:exit2                  test    flagA, #NaNFlag wc      ' set C flag
                        cmp     manA, #0 wz             ' set Z flag
_Unpack_ret             ret


'------------------------------------------------------------------------------
' input:   flagA        fnumA flag bits (Nan, Infinity, Zero, Sign)
'          expA         fnumA exponent (no bias)
'          manA         fnumA mantissa (aligned to bit 29)
' output:  fnumA        32-bit floating point value
' changes: fnumA, flagA, expA, manA
'------------------------------------------------------------------------------
_Pack                   cmp     manA, #0 wz             ' check for zero
          if_z          mov     expA, #0
          if_z          jmp     #:exit1

                        sub     expA, #380              ' take us out of the danger range for djnz
:normalize              shl     manA, #1 wc             ' normalize the mantissa
          if_nc         djnz    expA, #:normalize       ' adjust exponent and jump

                        add     manA, #$100 wc          ' round up by 1/2 lsb

                        addx    expA, #(380 + 127 + 2)  ' add bias to exponent, account for rounding (in flag C, above)
                        mins    expA, Minus23
                        maxs    expA, #255

                        abs     expA, expA wc,wz        ' check for subnormals, and get the abs in case it is
          if_a          jmp     #:exit1

:subnormal              or      manA, #1                ' adjust mantissa
                        ror     manA, #1

                        shr     manA, expA
                        mov     expA, #0                ' biased exponent = 0

:exit1                  mov     fnumA, manA             ' bits 22:0 mantissa
                        shr     fnumA, #9
                        movi    fnumA, expA             ' bits 23:30 exponent
                        shl     flagA, #31
                        or      fnumA, flagA            ' bit 31 sign
_Pack_ret               ret


'------------------------------------------------------------------------------
' modulo
' fnumA = fnumA mod fnumB
'------------------------------------------------------------------------------
_FMod                   mov     t4, fnumA               ' save fnumA
                        mov     t5, fnumB               ' save fnumB
                        call    #_FDiv                  ' a - float(fix(a/b)) * b
                        mov     fnumB, #0
                        call    #_FTruncRound
                        call    #_FFloat
                        mov     fnumB, t5
                        call    #_FMul
                        or      fnumA, Bit31
                        mov     fnumB, t4
                        andn    fnumB, Bit31
                        call    #_FAdd
                        test    t4, Bit31 wz            ' if a < 0, set sign
          if_nz         or      fnumA, Bit31
_FMod_ret               ret


'------------------------------------------------------------------------------
' arctan2
' fnumA = atan2( fnumA, fnumB )
' note: y = fnumA, x = fnumB: same as C++, opposite of Excel!
'------------------------------------------------------------------------------
_ATan2                  call    #_Unpack2               ' OK, start with the basics
                        mov     fnumA, #0               ' clear my accumulator
                        ' which is the larger exponent?
                        sub     expA, expB
                        abs     expA, expA      wc

                        ' decrease my resolution...I could get some overflow without this!
                        ' Thanks, Duane Degn!!
                        shr     manA, #1
                        shr     manB, #1

                        ' make the exponents equal
              if_c      shr     manA, expA
              if_nc     shr     manB, expA

                        ' correct signs based on the Quadrant
                        test    flagA, #SignFlag wc
                        test    flagB, #SignFlag wz
              if_z_eq_c neg     manA, manA
              if_nz     sumc    fnumA, CORDIC_Pi

                        ' do the CORDIC thing
                        mov     ft1, #0
                        mov     ft2, #25                 ' 20 gets you the same error range as the original, 29 is best, 25 is a nice compromise
                        movs    :load_C_table, #CORDIC_Angles

:CORDIC                 ' do the actual CORDIC thing
                        mov     t3, manA        wc      ' mark whether our Y component is negative or not
                        sar     t3, ft1
                        mov     t4, manB
                        sar     t4, ft1
                        sumc    manB, t3                ' C determines the direction of the rotation
                        sumnc   manA, t4        wz      ' (be ready to short-circuit as soon as the Y component is 0)
:load_C_table           sumc    fnumA, 0-0
                        ' update all my counters (including the code ones)
                        add     :load_C_table, #1
                        add     ft1, #1
                        ' go back for more?
                        djnz    ft2, #:CORDIC

                        ' convert to a float
                        mov     expA, #1
                        abs     manA, fnumA     wc
                        muxc    flagA, #SignFlag
                        call    #_Pack

_ATan2_ret              ret

CORDIC_Pi               long    $3243f6a8       ' Pi in 30 bits (otherwise we can overflow)
' The CORDIC angle table...binary 30-bit representation of atan(2^-i)
CORDIC_Angles           long $c90fdaa, $76b19c1, $3eb6ebf, $1fd5ba9, $ffaadd
                        long $7ff556, $3ffeaa, $1fffd5, $ffffa, $7ffff
                        long $3ffff, $20000, $10000, $8000, $4000
                        long $2000, $1000, $800, $400, $200
                        long $100, $80, $40, $20, $10
                        'long $8, $4, $2, $1


'------------------------------------------------------------------------------
' arcsine or arccosine
' fnumA = asin or acos(fnumA)
' asin( x ) = atan2( x, sqrt( 1 - x*x ) )
' acos( x ) = atan2( sqrt( 1 - x*x ), x )
'------------------------------------------------------------------------------
_ASinCos                ' grab a copy of both operands
                        mov     t5, fnumA
                        mov     t6, fnumB
                        ' square fnumA
                        mov     fnumB, fnumA
                        call    #_FMul
                        mov     fnumB, fnumA
                        mov     fnumA, One
                        call    #_FSub
                        '       quick error check
                        test    fnumA, bit31    wc
              if_c      mov     fnumA, NaN
              if_c      jmp     _ASinCos_ret
                        ' carry on
                        call    #_FSqr
                        ' check if this is sine or cosine (determines which goes into fnumA and fnumB)
                        mov     t6, t6          wz
              if_z      mov     fnumB, t5
              if_nz     mov     fnumB, fnumA
              if_nz     mov     fnumA, t5
                        call    #_ATan2
_ASinCos_ret            ret


'------------------------------------------------------------------------------
' _Floor fnumA = floor(fnumA)
' _Ceil fnumA = ceil(fnumA)
'------------------------------------------------------------------------------
_Ceil                   mov     t6, #1                  ' set adjustment value
                        jmp     #floor2

_Floor                  neg     t6, #1                  ' set adjustment value

floor2                  call    #_Unpack                ' unpack variable
          if_c          jmp     _Floor_ret             ' check for NaN
                        cmps     expA, #23 wc, wz       ' check for no fraction
          if_nc         jmp     _Floor_ret

                        mov     t4, fnumA               ' get integer value
                        mov     fnumB, #0
                        call    #_FTruncRound
                        mov     t5, fnumA
                        xor     fnumA, t6
                        test    fnumA, Bit31 wz
          if_nz         jmp     #:exit

                        mov     fnumA, t4               ' get fraction
                        call    #_Frac

                        or      fnumA, fnumA wz
          if_nz         add     t5, t6                  ' if non-zero, then adjust

:exit                   mov     fnumA, t5               ' convert integer to float
                        call    #_FFloat                '}
_Ceil_ret
_Floor_ret              ret


'-------------------- constant values -----------------------------------------

One                     long    1.0
NaN                     long    $7FFF_FFFF
Minus23                 long    -23
Mask23                  long    $007F_FFFF
Mask29                  long    $1FFF_FFFF
TableMask               long    $0FFE           'added to fix LOG
Bit16                   long    $0001_0000       'added to fix LOG
Bit29                   long    $2000_0000
Bit30                   long    $4000_0000
Bit31                   long    $8000_0000
LogTable                long    $C000
ALogTable               long    $D000
SineTable               long    $E000

'-------------------- initialized variables -----------------------------------

'-------------------- local variables -----------------------------------------

ret_ptr                 res     1
ft1                      res     1
ft2                      res     1
t3                      res     1
t4                      res     1
t5                      res     1
t6                      res     1
t7                      res     1

fnumA                   res     1               ' floating point A value
flagA                   res     1
expA                    res     1
manA                    res     1

fnumB                   res     1               ' floating point B value
flagB                   res     1
expB                    res     1
manB                    res     1

F32end
{
' command dispatch table: must be compiled along with PASM code in
' Cog RAM to know the addresses, but does not neet to fit in it.
cmdCallTable
cmdFAdd                 call    #_FAdd
cmdFSub                 call    #_FSub
cmdFMul                 call    #_FMul
cmdFDiv                 call    #_FDiv
cmdFFloat               call    #_FFloat
cmdFTruncRound          call    #_FTruncRound
cmdUintTrunc            call    #_UintTrunc
cmdFSqr                 call    #_FSqr
cmdFCmp                 call    #_FCmp
cmdFSin                 call    #_Sin
cmdFCos                 call    #_Cos
cmdFTan                 call    #_Tan
cmdFLog2                call    #_Log2
cmdFExp2                call    #_Exp2
cmdFPow                 call    #_Pow
cmdFFrac                call    #_Frac
cmdFMod                 call    #_FMod
cmdASinCos              call    #_ASinCos
cmdATan2                call    #_ATan2
cmdCeil                 call    #_Ceil
cmdFloor                call    #_Floor
}

'################################################################################################
romend
'######################################### END OF ROMS ##########################################














DAT

        byte 0[varram-(@romend+s)]


DAT { *** SERIAL RECEIVE *** }

'**************************************** SERIAL RECEIVE ******************************************

{ This is a dedicated serial receive routine that runs in it's own cog

Includes PING-PONG networking


' serial configuration
baudrate      long    baud                      ' The baudrate is now stored as a variable
              byte    rxd,txd,0,0               ' defa3 pins for console
' $0030..$003F   TR TE ID GP  PPBAUD
ppcfgs
              long    clkfreq/2000000           ' default 2Mbps
              byte    0,0,0,0                   ' TR TE ID GP
rxticks                 long    sysfreq/baud
stticks                 long    ((sysfreq/baud)/2)-12

}

                        long 0[2]                       ' read and write        ' this hub space is used for rxwr & rxrd at runtime
rxbuffers                                               ' hub ram gets reused as the receive buffer
                        org

ConsoleRx
                        rdlong  rxticks,#@baudrate+s     ' read baud rate ticks
                        rdbyte  X1,#@conpins+s
                        shl     rxpin,X1                ' assume rxpin is already set to 1
                        rdlong  pticks,#@ppbaud+s               ' PPBAUD
                        mov     pstticks,pticks
                        shr     pstticks,#1
                        sub     pstticks,#12
                        rdbyte  myadr,#@idcfg+s wz      ' read ping-pong device address but check if disabled too (Z)
        if_z            mov     trpin,#0
        if_z            mov     tepin,#0
        if_nz           rdbyte  X1,#@trcfg+s          ' default mask = 1 (if par>31 then mask=0 )
                        shl     trpin,X1
        if_nz           rdbyte  X1,#@tecfg+s                 ' default mask = 1 (if par>31 then mask=0 )
                        shl     tepin,X1
                        rdbyte  mygrp,#@gpcfg+s

                        mov     rxwr,#0                 ' init write index
                        wrword  rxwr,rxwrP              ' clear rxrd in hub
                        wrword  rxwr,rxrdP              ' make rxwr = rxrd
                        mov     rxpins,rxpin
                        or      rxpins,trpin
                        mov     stticks,rxticks
                        shr     stticks,#1
                        sub     stticks,#4
                        mov     tpins,tepin             ' combination of tr and te pins
                        or      tpins,trpin
'
receive                 mov     rxdat,#0
                        mov     rxcnt,stticks           ' Adjusted bit timing for start bit
                        waitpne rxpins,rxpins            ' wait for a low = start bit
                        test    rxpin,ina wz            ' test for console rx?
                if_nz   jmp     #pingpong               ' otherwise check PPNET
                        add     rxcnt,cnt               ' uses special start bit timing
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina       wz      ' sample middle of start bit
rxcond2         if_nz   jmp     #receive                ' restart if false start otherwise bit time from center

'
' START bit validated
' Read in data bits lsb first
' No point in looping as we have plenty of code to play with
' and inlining (don't call) and unrolling (don't loop) can lead to higher receive speeds
'
                        waitcnt rxcnt,rxticks           ' wait until middle of first data bit
                        test    rxpin,ina wc            ' sample bit 0
                        muxc    rxdat,#01              ' and assemble rxdata
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina wc            ' sample bit 1
                        muxc    rxdat,#02
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina wc            ' sample bit 2
                        muxc    rxdat,#04
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina wc            ' sample bit 3
                        muxc    rxdat,#08
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina wc            ' sample bit 4
                        muxc    rxdat,#$10
 ' data bit 5
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina wc            ' sample bit 5
                        muxc    rxdat,#$20
                        mov     X1,rxbuf                ' squeeze in some overheads, calc write pointer
                        add     X1,rxwr                 ' X points to buffer location to store
' data bit 6
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina wc            ' sample bit 6
                        muxc    rxdat,#$40
                        add     rxwr,#1                 ' update write index
                        and     rxwr,#rxsize-1
' last data bit 7
                        waitcnt rxcnt,rxticks
                        test    rxpin,ina wc            ' sample bit 7
                        muxc    rxdat,#$80
                        wrbyte  rxdat,X1               ' save data in buffer - could take 287.5ns worst case
' stop bit
stopins                 waitcnt rxcnt,rxticks           ' check stop bit early (need to detect errors and breaks)
                        test    rxpin,ina wc            ' sample stop bit
                if_c    wrword  rxwr,rxwrP              ' update hub index for code reading the buffer if all good
                if_c    mov     breakcnt,#100           ' reset break count
                if_c    jmp     #receive
'
' Framing error - check if it's a null character as it may be part of a break condition
' 160722 update - any continous frame error character will eventually reset the Prop
' any normal character resets the count.
' Earlier versions would not reset it unless it received a normal framing char (improbable)
'
frmerror
                        sub     rxwr,#1
                        or      outa,rxpin
                        or      dira,rxpin              'unintentional? make sure the input is not floating
                        mov     rxcnt,#16
                        djnz    rxcnt,$
                        andn    dira,rxpin              'restore input and delay
                        mov     rxcnt,#16
                        djnz    rxcnt,$
                        test    rxpin,ina wz            'if it's still low then it is being intentionally driven
                if_nz   jmp     #receive                'ignore floating input
                        djnz    breakcnt,#receive
aboot
                        mov     rxcnt,#$80
                        clkset  rxcnt   ' reboot


{
4.1 Adds 9-bit mode for binary data plus control codes

GLOBAL
GROUP..
ADD

LOAD    CNT,ADDRH,ADDRL,MODE ->





All data is compiled byte by byte into a parameter long
Any command may set the parameter counter - on decrementing to zero will execute command
Data always is saved to hub memory - or shunted to disused area such as rom
Write index is only updated on user data


}



DAT { *** PPNET *** }

pingpong
 			mov	rxcnt,pstticks	        ' Adjusted bit timing for start bit
 			add	rxcnt,cnt           	' uses special start bit timing
 			waitcnt	rxcnt,pticks
 			test	trpin,ina       wz      ' sample middle of start bit
		if_nz	jmp	#receive                ' restart if false start otherwise bit time from center
 			waitcnt	rxcnt,pticks	        ' wait until middle of first data bit
 			test	trpin,ina wc	        ' sample bit 0
 			muxc	rxdat,#01	        ' and assemble prxdat
 			waitcnt	rxcnt,pticks
 			test	trpin,ina wc	        ' sample bit 1
 			muxc	rxdat,#02
 			waitcnt	rxcnt,pticks
 			test	trpin,ina wc            ' sample bit 2
 			muxc	rxdat,#04
 			waitcnt	rxcnt,pticks
 			test	trpin,ina wc	        ' sample bit 3
 			muxc	rxdat,#08
 			waitcnt	rxcnt,pticks
 			test	trpin,ina wc	        ' sample bit 4
 			muxc	rxdat,#$10
' data bit 5
			waitcnt	rxcnt,pticks
 			test	trpin,ina wc	        ' sample bit 5
 			muxc	rxdat,#$20
' data bit 6
 			waitcnt	rxcnt,pticks
 			test	trpin,ina wc	        ' sample bit 6
 			muxc	rxdat,#$40
' last data bit 7
 			waitcnt	rxcnt,pticks
 			test	trpin,ina wc	        ' sample bit 7
 			muxc	rxdat,#$80
' 9th bit address/data
 			waitcnt	rxcnt,pticks
 			test	trpin,ina wc	        ' sample 9th bit address into C

' stop bit
			waitcnt	rxcnt,pticks	        ' check stop bit (need to detect errors and breaks)
 			test	trpin,ina wz	        ' sample stop bit
		if_z	jmp	#pfrmerr	        ' framing error - check for break - disregard timing now

'
' MULTIDROP ADDRESS CHECK
'
              if_c      jmp     #multidrop              ' multidrop if 9th bit = 1
                        tjz     rxon,#receive           ' discard receive data if unit is not selected
' SELECTED + DATA or HEX
                        cmp     hexcnt,#0 wz            ' process hex if selected
                if_nz   jmp     #memop
                        tjnz    ppcnt,#dopars

' SELECTED + DATA ( DEFAULT!!!)
 			mov	X1,rxbuf	        ' calc write pointer
 			add	X1,rxwr	                ' X points to buffer location to store

' UPDATE BUFFER                                         ' rx is selected - so buffer this data
                        and     rxdat,#$FF wz           ' don't buffer if it's a null

 		if_nz   wrbyte	rxdat,X1	        ' * save data in buffer * (could take 287.5ns worst case)
 		if_nz	add	rxwr,#1	                ' update write index
                        and     rxwr,#rxsize-1
	        if_nz   wrword	rxwr,rxwrP  	        ' update hub index for code reading the buffer if all good
                        tjz     txon,#receive           ' echo if tx is enabled (direct one-on-one)
                        call    #pptxd                  ' ping-pong a character back
 			jmp	#receive

' MEMORY BLOCK READ/WRITE
memop                   tjnz    pppars,#hexrd           ' read or write mode?
' MEMORY WRITE
hexwr                   wrbyte  rxdat,hexadr            ' else save at hex address
hexinc                  add     hexadr,#1
                        sub     hexcnt,#1
                        jmp     #receive
' MEMORY READ
hexrd                   rdbyte  txdat,hexadr
                        or      outa,tpins              ' enable transmitter
                        or      dira,tpins              ' enable TE
                        call    #pptxh
                        jmp     #hexinc

'
' process address/control character $00..$FF
'
multidrop
 		        mov	txon,#0                 ' disable the transmitter
                        wrlong  txclr,emitregP
                        cmp     rxdat,#ppcmds wc
              if_nc     jmp     #chkppcmd
'                        cmp     rxdat,#_link wz         ' allow units to be linked as a temporary group - no echo allowed
 		        mov	rxon,#0                 ' if not linking then disable this receiver for the moment
 			cmp	rxdat,myadr wz          ' enable if this unit selected
                if_z    jmp     #selected               ' ok then, just check for group or global
			cmp	rxdat,#_gbl wz          ' Global?
mdrp 		if_z	mov	rxon,rxdat              ' enable - but rxon is set to global address - no tx
                if_z    jmp     #receive
                        cmp     rxdat,mygrp wz             ' same group?
                if_z    jmp     #mdrp                   ' treat as global
 			jmp	#receive
'
selected
		  	mov	rxon,myadr	        ' indicate that it is only this unit responding (rxon = myadr)
		   	mov	txon,myadr	        ' and transmitter
                        mov     txdat,myadr wz          ' echo my address - set NZ
                        call    #pptxs                  ' ack select
                        wrbyte  txon,emitflgP           ' signal app EMIT to synch if pingpong transmit is enabled
                        jmp     #receive                ' skip these other checks if selected

dopars                  shl     pppars,#8               ' build parameters
                        or      pppars,rxdat
                        djnz    ppcnt,#receive          ' continue waiting for more parameters?
                        cmp     ppcmd,#ppinduct wz      ' done - check and execute command
              if_z      jmp     #mdrp
                        cmp     ppcmd,#ppmem wz
              if_z      jmp     #domem
                        cmp     ppcmd,#ppinit wz
              if_z      coginit hexadr                  ' coginit using 4 parameters as 32-bit operand
                        jmp     #receive


' PARS: CNT,ADDRH,ADDRL,MODE
domem                   mov     hexcnt,pppars
                        shr     hexcnt,#24 wz              ' count
              if_z      mov     hexcnt,#$100            ' 0 = 256
                        mov     hexadr,pppars
                        shl     hexadr,#8
                        shr     hexadr,#16              ' address
                        and     pppars,#$FF wz          ' mode (in ppars)
                        jmp     #receive                ' accept data into memory
{
' send memory data
txhex                   rdbyte  txdat,hexadr
                        or      outa,tpins              ' enable transmitter
                        or      dira,tpins              ' enable TE
                        call    #pptxh
                        add     hexadr,#1
                        djnz    hexcnt,#txhex
                        jmp     #receive
}
'
' CHECK COMMAND - pingpong network control codes
'
chkppcmd                mov     ppcmd,rxdat           ' backup command code
                        tjz     rxon,#receive           ' ignore all other commands if not selected
                        cmp     rxdat,#ppinduct wz
              if_z      mov     ppcnt,#1                ' ADD looks for 1 parameter
                        cmp     rxdat,#pprst wz
              if_z      jmp     #aboot                  ' reset device
                        cmp     rxdat,#ppmem wz
              if_z      mov     ppcnt,#4
                        cmp     rxdat,#pphalt wz
              if_z      jmp     #dopphalt
                        cmp     rxdat,#ppinit wz
              if_z      mov     ppcnt,#4
                        cmp     rxdat,#ppspin wz
              if_z      coginit interpreter
                        jmp     #receive

dopphalt
                        mov     hexadr,#8
:L1                     sub     hexadr,#1
                        cmp     hexadr,#1 wz            ' skip communications cog #1
              if_nz     cogstop hexadr
                        tjnz    hexadr,#:L1
                        jmp     #receive


' respond to selection
pptxs
                        or      outa,tpins              ' enable transmitter
                        or      dira,tpins              ' enable TE
                        mov     rxcnt,pgap
                        add     rxcnt,cnt
                        ' insert extra delay before transmitting
                        waitcnt rxcnt,pticks
                        jmp     #pptx

' respond with data
pptxd                   rdword  txdat,emitregP wz        ' single word
                        or      outa,tpins              ' enable transmitter
                        or      dira,tpins              ' enable TE
              if_nz     wrword  txclr,emitregP           ' only clear if it's non-zero (in case hl is accessing it)
pptxh                   mov     rxcnt,pticks
                        add     rxcnt,cnt
pptx                    add     txdat,stops wc          ' add a stop bit (carry = start bit = 0)
ptxb                    muxc    outa,trpin              ' output bit (init C = 0 = start)
                        shr     txdat,#1 wz,wc          ' lsb first
pptxx                   waitcnt rxcnt,pticks            ' bit timing
        if_nz_or_c      jmp     #ptxb                   ' next bit (stop bit: z & c)
                        andn    dira,trpin              ' float data line back to receive
                        andn    outa,tepin              ' Turn line back to receive
pptxh_ret
pptxs_ret
pptxd_ret                ret

' Framing error - check if it's a null character as it may be part of a break condition
'
pfrmerr
 			cmp	rxdat,#0 wz	        ' if it's a null it could be part of a break
		if_nz	sub	rxwr,#1
 		if_nz	mov	breakcnt,#100	        ' reset the break count (compromise here to keep main loop tight)
		if_nz	jmp     #receive	        ' ignore normal framing error
 			djnz	breakcnt,#receive
 			mov	rxcnt,#$80
 			clkset	rxcnt	                ' reboot


_rxpars
' CONSOLE
rxpin                   long    1
rxticks                 long    sysfreq/baud
stticks                 long    ((sysfreq/baud)/2)-12
' NETWORK
myadr                   long    0
trpin                   long    1
tepin                   long    1

pticks                  long    (sysfreq / 2000000 )
pstticks                long    ((sysfreq/2000000)/2)-12
txon                    long    0
rxon                    long    0
' 10
emitregP                 long    emitreg
emitflgP                 long    emitreg+3
' 12
pgap                    long    (sysfreq/1000000)*2     ' gap between receive and transmit - *microseconds

rxbuf                   long    @rxbuffers+s            ' pointer to rxbuf in hub memory
rxwrP                   long    @rxbuffers+s-2          ' word address of rxwr in hub (after init)
rxrdP                   long    @rxbuffers+s-4          ' ptr to rxrdin hub
breakcnt                long    100
txclr                   long    0                       ' a null value to write to emitreg
stops                   long    $0200
ppcnt                   long    0
hexcnt                  long    0
interpreter             long    $0007C010

ppcmd                   res     1
rxdat                   res     1
pppars                  res     1
hexadr                  res     1
rxpins                  res     1
txdat                   res     1
rxcnt                   res     1
lastch                  res     1
x1                      res     1
'rxchk                   res     1
rxwr                    res     1                       'cog receive buffer write index - copied to hub ram
tpins                   res     1                       ' combined TR and TE pins
mygrp                   res     1

end                     res     0


CON

rxsize          = 512'256                   ' Serial rx buffer - reuses serial receive cog code image   can extend into BUFFERS area


' MULTI-DROP

_myadr          = 222           ' $DE default node address
                                ' $E0..$EE can be used for groups address
_gbl            = $EF           ' address all nodes - no response
                                '
'_link           = $F1          ' links units as a temporary semi-global group


ppcmds          = $F0           ' ping-pong command codes
ppinduct        = $F3           ' ADD another device to temporary group

ppmem           = $F8           ' load hex file into hub memory
'ppread          = $F9
pphalt          = $FA           ' HALT all other cogs
ppinit          = $FB           ' coginit a cog
ppspin          = $FC           ' coginit 0 with Spin to reboot image
'ppcfg           = $FD           ' request read and set config (normally global)
pprst           = $FE           ' reset all devices
ppetx           = $FF           ' dummy to indicate end of transmission

DAT { test cog loader }
{
A cog is preloaded with a load and execute module that waits for parameters and
then loads just what is needed then executes it.
This can be a lot faster than a full coginit.
PAR points to source address(2) and source count(2)

OR - PAR points to a long encoded with address and count
addrh,addrl,cnth,cntl
}
              org 0
loader
              mov       dira,#0                 ' reset all I/O
ldrlp         rdword    ldcnt,par wz            ' read load cnt from hub
              and       ldcnt,#$1FF             ' definitly not more than 512 longs
        if_z  jmp       #ldrlp                  ' perform a load if it is non-zero
              rdlong    ldadr,par               ' read hub load source address
              shr       ldadr,#16
              movd      ldlp,#ldrun            ' set destination

ldlp          rdlong    ldrun,ldadr
              add       ldlp,ldinc              ' inc dest in cog
              add       ldadr,#4                ' point to next long in hub
              djnz      ldcnt,ldlp              ' continue then execute code when done
              jmp       #ldrun
ldinc         long      $200                   ' destintation field increment
ldadr         res       1
ldcnt         res       1

              org 16
ldrun























DAT { *** TACHYON KERNEL *** }

{
***************************************
************* COG IMAGE & BUFFERS *************
***************************************
}

{{
Word tokens directly address code in the first 512 longs of the cog.

opcode map
$0000..$01FF Directly call PASM cog code at this address
$0200..$7CFE Call wordcode subroutine (push IP)
$7D00..$7DFF Local register - 256 bytes
$7E00..$7EFF Conditional relative +/- word jump
$7F00..$7FFF Relative +/- word jump
$8000..$FFFF Embedded 15-bit unsigned literal


}}

                        org     0

RESET                   jmp     #InitIP

' 170307 V4.2 Moved all "COGREGs" to fixed locations - removed COGREG reference and index from 1 onwards
' COGREG - Registers used by PASM modules to hold parameters such as I/O masks and bit counts etc
'COGREGS
REG1            long 0
REG2            long 0
REG3            long 0
REG4            long 0
'AREG
REG5            long 0          ' CLOCK mask



' REG6
txticks         long (sysfreq / baud )  ' set transmit baud rate
txmask          long |<txd              ' change mask to reassign transmit
' REG8 = TASK REGISTER POINTER
regptr          long registers          ' used by REG
unext           long doNEXT             ' could redirect code if used

' REG10
' SPIPINS - pin masks for SPI operations
spisck          long 0                  ' I/O mask for SPI clock
spiout          long 0                  ' I/O mask for SPI data out (MOSI)
spiinp          long 0                  ' I/O mask for SPI data in (MISO)
spice           long 0                  ' I/O mask for SPI CE (not really required unless we use CE instr)

spicnt          long 0                  ' bit count for variable size Kernel SPI
' REG15
clockpins       long 0                  ' I/O mask for CLOCK instruction
' REG16
clkdly          long 0
' REG17
lpsp            long    loopstk



InitIP                  mov     IP,PAR          ' Load the IP with the address of the first instruction
'''                        jmp     #doNEXT         ' NOTE - can remove jump to save a long since high level does !SP

' ?DUP ( n1 -- n1 n1 | 0 ) DUP n1 if non-zero - 333ns or 833ns
QDUP                    tjz     tos,unext
' DUP ( n1 - n1 n1 ) Duplicate the top item on the stack - 666ns
DUP                     mov     X,tos                   ' Read directly from the top of the data stack
PUSHX                   mov     ACC,#0
stkpsh                  mov     datastk,tos+3           ' save fixed tos - stack grows in cog memory
                        add     stkpsh,dstinc           ' increment dst field
                        add     stkpop,#1
PUSHCOG                 mov     tos+3,tos+2             ' push the cog stack registers (4)
                        mov     tos+2,tos+1
                        mov     tos+1,tos
                        mov     tos,X                   ' replace tos with X (DEFAULT)
                        add     udepth,#1                '
'
{ *** RUNTIME BYTECODE INTERPRETER *** }
'       *       *       *       *
' Fetch the next wordcode instruction in hub RAM pointed to by the instruction pointer IP
' This is the very heart of the runtime interpreter
'
doNEXT                  rdword  X,IP            ' read word code instruction
                        add     IP,#2 wc        ' advance IP to next wordcode (clears the carry too!)
                        shr     X,#9 nr,wz      ' cog or hub?
                 if_z   jmp     X               ' execute the code by directly indexing the first 512 longs in cog
                        cmp     regop,X wc      ' addresses above this vallue should be decoded
                 if_c   jmp     #decode         ' decode further
                        ' must be a call/jump
                        test    X,#1 wz         ' skip pushing the IP if bit 0 is set
                 if_nz  andn    X,#1            ' and fixup
                 if_z   call    #SAVEIP         ' otherwise this is an address of a high-level word code
                        mov     IP,X            ' so after saving the IP, load it with new address
                        jmp     #doNEXT

decode                    ' literal?
                        shr     X,#15 nr,wz     ' embedded 15-bit literal? (b15=1)
                 if_nz  and     X,mask15        ' mask out b15
                 if_nz  jmp     #PUSHX          ' push this literal without having to do a call/return
                        ' conditional jump?
                        cmp     jumpop,X wc     ' test for jump + disp
                 if_nc  jmp     #doREG

' Conditional - Jumps are encoded with an 8-bit signed word displacement
doJUMP                  tjnz    tos,#DROP       ' continue without jumping - discard flag
{
                        shl    X,#24           ' alternative method (requires full signed jump)
                        sar    X,#23
                        add    IP,X
'}
'{
                        test    X,#$80 wz       ' reverse jump? nz
                        and     X,#$7F          ' mask displacement
                        shl     X,#1            ' index as words
                        sumnz    IP,X           ' +/- jump
'}
                        jmp     #DROP           ' discard condition flag

                        ' any opcodes from here on are jumps with encoded +/-128 displacement
jumpop          long    $7F00-1
{
'conditional branch code
_UNTIL          = $7F80
_IF             = $7F00
}

doREG '( -- addr )
                        and     X,#$FF
                        add     X,regptr
                        jmp     #PUSHX

                        ' address 256 bytes of task registers per cogid
regop           long    rg-1





' Bill Henning's LMM loop
' LMM is an opcode which is placed before a long boundary which contains LMM PASM code,
' use EXIT to return to Tachyon's loop
' or change unext to point to LMM so LMM can jmp to Tachyon opcodes and yet still return to LMM
LMM                     rdlong  instr,IP
                        add     IP,#4
instr                   nop
                        jmp     #LMM
{
' Find the end of the string which could end in a null or any characeter >$7F
' this is also used to find the end of a larger text buffer
' STREND ( ptr -- ptr2 )
STREND
fchlp                   rdbyte  R0,tos                  ' read a byte
                        sub     R0,#1                   ' end is either a null or anything >$7F
                        cmp     R0,#$7E wc
              if_c      add     tos,#1
              if_c      jmp     #fchlp
                        jmp     unext
}

' 0EXIT ( flg -- ) Exit if flg is false (or zero)  Used in place of IF......THEN EXIT as false would just end up exiting
ZEXIT                   call    #POPX
                        tjnz    X,unext
'                       ''      ''
' EXIT a bytecode definition by popping the top of the return stack into the IP
EXIT                    call    #RPOPX                  ' Pop from return stack into X
JUMPX                   mov     IP,X                    ' update IP
_NOP                    jmp     unext                   ' continue

              { *** STACK OPERATORS *** }

' used in: U@ U! STRINGs
' CMOVE 512 bytes 172.666us @96
' pRCMOVE bytes from source to destination primitive - <CMOVE conditions the parameters before calling
' (RCMOVE) ( src dst cnt -- ) Copy bytes from src to dst for cnt bytes starting from the ends (in reverse)
pRCMOVE                 test    $,#1  wc                ' set carry for decrementing (always cleared by doNEXT)
' (CMOVE) ( src dst cnt -- ) Copy cnt bytes from src to dst address
CMOVE                   rdbyte  R0,tos+2                 ' read source byte
                        sumc    tos+2,#1                 ' inc or dec depending upon carry
                        wrbyte  R0,tos+1                 ' write destination byte
                        sumc    tos+1,#1                 ' inc or dec depending upon carry!!
                        djnz    tos,#CMOVE
' DROP3 ( n1 n2 n3 -- )  Pop the top 3 items off the datastack and discard them (used mostly by cog kernel) - 1.8us
DROP3                   call    #POPX
' DROP2 ( n1 n2 -- )  Pop the top 2 items off the datastack and discard them - 1.4us
DROP2                   call    #POPX
' 800ns execution time including bytecode read and execute
' DROP ( n1 -- )  Pop the top item off the datastack and discard it
DROP                    call    #POPX
                        jmp     unext

{ high level NIPEX is used as it is more compact as a NIP ; combo
NIP                     mov     tos+1,tos
                        jmp     #DROP
}


' OVERABS - only used as a faster way of OVER ABS in signed divide
'OVERABS                 abs     X,tos+1 wc              ' force OVER to not replace this value if it was negative
' OVER ( n1 n2 -- n1 n2 n1 ) - 1us
OVER                    mov     X,tos+1                 'read second data item and push
                        jmp     #PUSHX
' 3RD ( n1 n2 n3 -- n1 n2 n3 n1 ) Copy the 3rd item onto the stack
THIRD                   mov     X,tos+2                 ' read third data item
                        jmp     #PUSHX
' 4TH ( n1 n2 n3 n4 -- n1 n2 n3 n4 n1 ) Copy the 4th item onto the stack - 1.2us
FOURTH                  mov     X,tos+3
                        jmp     #PUSHX

' BOUNDS ( n1 n2 -- n2+n1 n1 ) == OVER + SWAP - 600ns
'BOUNDS                  add     tos,tos+1
' SWAP ( n1 n2 -- n2 n1 ) Swap the top two items
SWAP                    mov     X,tos+1
SWAPX                   mov     tos+1,tos
PUTX                    mov     tos,X
                        jmp     unext
' ROT ( a b c -- b c a )
ROT                     mov     X,tos+2
                        mov     tos+2,tos+1
                        jmp     #SWAPX

{
OVERPLUS                add     tos,tos+1
                        jmp     unext
}
PLUS4                   add     tos,#2
PLUS2                   add     tos,#2
                        jmp     unext



              { *** ARITHMETIC *** }
' - ( n1 n2 -- n3 ) Subtract n2 from n1
MINUS                   neg     tos,tos ' (note: save one long by negating and adding)
' + ( n1 n2 -- n3 ) Add top two stack items together and replace with result
PLUS                    add     tos+1,tos
                        jmp     #DROP

' 1- ( n1 -- n1-1 )
DEC                     test    $,#1 wc         ' set carry flag to invert sign in sumc
' 1+ ( n1 -- n1+1 )
INC                     sumc    tos,#1          ' inc or dec depending upon carry (default cleared by doNEXT)
                        jmp     unext


 ' ?NEGATE ( n1 flg -- n2 ) negate n1 if flg is true
QNEGATE                 tjz     tos,#DROP
                        call    #POPX
' NEGATE ( n1 -- n2 )  equivalent to  n2 = 0-n1
NEGATE                  neg     tos,tos
                        jmp     unext

{HELP UM* ( u1 u2 -- u1*u2L u1*u2H )
DESC: unsigned 32bit * 32bit multiply -- 64bit result
TIME: 1..11.8us
}
UMMUL                   mov     R0,tos+1
                        min     R0,tos                  ' max(tos, tos+1)
                        mov     R2,tos+1
                        max     R2,tos                  ' min(tos, tos+1)

                        mov     R1,#0
                        mov     tos,#0                  ' zero result
                        mov     tos+1,#0
UMMULLP                 shr     R2,#1 wz,wc             ' test next bit of u1
                if_nc   jmp     #UMMUL1                 ' skip if no bit here
                        add     tos+1,R0 wc             ' add in shifted u2
                        addx    tos,R1                  ' carry into upper long
UMMUL1                  add     R0,R0 wc                ' shift u2 left
                        addx    R1,R1                   ' carry into 64-bits
                if_nz   jmp     #UMMULLP                ' exhausted u1?
                        jmp     unext


' main division sub - called both by U/ and U/MOD
' double div, single divisor
' By specifing bits and left justifying the routine can be adapted and run faster
' CLKFREQ 1234 LAP U/MOD LAP .LAP  27.400us ok --> 18.800us

' UM/MOD64 ( Dbl.dividend divisor -- remainder Dbl.quotient)
UMDIVMOD64              mov     ACC,#32
UMDIVMOD32              add     ACC,#32
                        mov     R0, tos                 ' R0 = divisor
                        mov     R1, tos+2               ' R1R2 = dividend
                        mov     R2, tos+1
                        mov     tos+2, #0               ' remainder

udmlp                   shl     R1, #1 wc               ' dividend msb
                        rcl     R2, #1 wc
                        rcl     tos+2, #1               ' hi bit from dividend
                        cmpsub  tos+2, R0   wc,wr       ' cmp divisor ( R0 - tos & c set if tos => R0 )
                        rcl     tos+1, #1 wc            ' tos+1 = quotient l
                        rcl     tos, #1                 ' tos = quotient h
                        djnz    ACC, #udmlp
                        jmp     unext



              { *** BOOLEAN *** }
{
' 400ns execution time including bytecode read and execute
' INVERT ( n1 -- n2 ) bitwise invert n1 and replace with result n2
INVERT                  add     tos,#1
                        jmp     #NEGATE
Replace with INC,NEGATE
}
{
_BITS                   test    $,#1 wc ' set carry
                        rcl     ACC,tos
                        and     tos+1,ACC
                        jmp     #DROP
}
_AND                    and     tos+1,tos
                        jmp     #DROP
_ANDN                   andn    tos+1,tos
                        jmp     #DROP
_OR                     or      tos+1,tos
                        jmp     #DROP
_XOR                    xor     tos+1,tos
                        jmp     #DROP
' 1.2us execution time including bytecode read and execute
' SHR ( n1 cnt -- n2 ) Shift n1 right by count (5 lsbs )
_SHR                    shr     tos+1,tos
                        jmp     #DROP
_SHL                    shl     tos+1,tos
                        jmp     #DROP
{
_ROL                    rol     tos+1,tos
                        jmp     #DROP
_ROR                    ror     tos+1,tos
                        jmp     #DROP
}
_SHR8                   shr     tos,#7
' 400ns execution time including bytecode read and execute
' 2/ ( n1 -- n1 ) shift n1 right one bit (equiv to divide by 2)
_SHR1                   shr     tos,#1
' ABS ( n -- abs ) note: saves one long by cheating that SHR will always end up with b31 clear
_ABS                    abs     tos,tos
                        jmp     unext

_SHL8                   shl     tos,#6
_SHL2                   shl     tos,#1
' 2* ( n1 -- n2 ) shift n1 left one bit (equiv to multiply by 2)
_SHL1                   shl     tos,#1
                        jmp     unext


' REV ( n1 bits -- n2 ) Reverse LSBs of n1 and zero-extend ( or reverse all and shr by bits )
_REV                    rev     tos+1,tos
                        jmp     #DROP

' 400ns execution time including bytecode read and execute
' MASK ( bitpos -- bitmask  \ only the lower 5 bits of bitpos are taken, regardless of the higher bits )
MASK                    call    #AMASK
                        jmp     unext


' >N ( n -- nibble ) mask n to a nibble
toNIB                   and     tos,#$0F
' >B ( n -- nibble ) mask n to a byte
toBYTE                  and     tos,#$FF
                        jmp     unext

' SPLIT9 ( n -- lsb9 h ) specialized operation for filesystem addresses
SPLIT9                  mov     X,tos
                        and     tos,#$1FF
                        shr     X,#9
                        jmp     #PUSHX



              { *** COMPARISON *** }

' Basic instructions from which other comparison instructions are built from

' = ( n1 n2 -- flg ) true if n1 is equal to n2
EQ                      sub     tos+1,tos               ' n1 == 0 if equal
                        call    #POPX   ' drop n2
'                       -------------
' 0= ( n1 -- flg ) true if n1 equals 0 - same as a boolean NOT where TRUE becomes FALSE
_NOT
ZEQ                     cmp     tos,#1 wc               ' kuroneko method, nice and neat
SETZ                    subx    tos, tos                ' a carry becomes -1, else 0
                        jmp     unext

' > ( n1 n2 -- flg ) true if n1 > n2
GT                      cmps    tos,tos+1  wc           ' n1 > n2: carry set
                        subx    tos+1,tos+1
                        jmp     #DROP
' U<
ULT                     cmp     tos+1,tos wc
                        subx    tos+1,tos+1             ' final result is 0 or -1
                        jmp     #DROP

' Hardly used - could be high level 31 >>
' 0<
{
ZLT                     sar     tos,#31
                        jmp     unext
}

              { *** MEMORY *** }

' C@++  ( caddr -- caddr+1 byte ) fetch byte character and increment address
CFETCHINC               rdbyte  X,tos
                        add     tos,#1
                        jmp     #PUSHX

' IC@ ( n -- byte )
ICFETCH                 mov     tos,_from
' C@  ( caddr -- byte ) Fetch a byte from hub memory
CFETCH                  rdbyte  tos,tos
                        jmp     unext

' W@  ( waddr -- word ) Fetch a word from hub memory
WFETCH                  rdword  tos,tos
                        jmp     unext

' @  ( addr -- long ) Fetch a long from hub memory
FETCH                   rdlong  tos,tos
                        jmp     unext


'IC! ( byte -- byte )
ICSTORE                 wrbyte  tos,_from
                        jmp     unext


' C+!  ( n caddr -- ) add n to byte at hub addr
CPLUSST                 rdbyte  X,tos                   ' read in word from adress
                        add     tos+1,X                 ' add to contents of address - cascade
' C!  ( n caddr -- ) store n to byte at addr
CSTORE                  wrbyte  tos+1,tos               ' write the byte using address on the tos
                        jmp     #DROP2

' W+!  ( n waddr -- ) add n to word at hub addr
WPLUSST                 rdword  X,tos                   ' read in word from address
                        add    tos+1,X
' W!  ( n waddr -- ) store n to word at addr
WSTORE                  wrword  tos+1,tos
                        jmp     #DROP2

' +!  ( n addr -- ) add n to long at hub addr
PLUSST                  rdlong  X,tos                   ' read in long from address
                        add    tos+1,X
' !  ( n addr -- ) store n to long at addr
STORE                   wrlong  tos+1,tos
                        jmp     #DROP2

{
'>A
PUSHA                   add     astk,#4
                        wrlong  tos,astk
                        jmp     #DROP
' A@
READA                   test    $,#1  wc                ' only want to read, not pop, so disable pop
'A>
POPA                    rdlong  X,astk
              if_nc     sub     astk,#4
                        jmp     #PUSHX

astk                    long    $00E0-4                   ' some spare hub RAM

}

              { *** LITERALS *** }

' unsigned 15-bit literals are coded as a wordcode with b15 set
' otherwise all other literals are 16-bit or 32-bit inline (and slower)
' exception is -1 which is in code (compact&fast).

PUSH32                  rdword  ACC,IP
                        add     IP,#2
                        shl     ACC,#16
PUSH16                  rdword  X,IP
                        or      X,ACC
                        add     IP,#2
                        jmp     #PUSHX

mask15                  long    $7FFF

_TRUE
MINUS1                  mov     X,allones
                        jmp     #PUSHX

allones                 long    -1


' NOTE: VARIABLES and CONSTANTS are compiled as literals directly from the header record






              { *** I/O ACCESS *** }

{ not used - removed to extensions using COG@ COG!
' P@ ( -- n1 ) Read the input port A (assume it is always A for Prop 1)
PFETCH                  mov     X,INA
                        jmp     #PUSHX
' P! ( n1 -- ) Store n1 to the output port A
PSTORE                  mov     OUTA,tos
                        jmp     #DROP

}

              { *** FAST PIN OPERATIONS *** }

' H ( iomask -- iomask ) Set mask bits on the output - leave stack intact
H                       or      OUTA,tos
HL                      or      DIRA,tos
                        jmp     unext           ' do not pop stack
P                       or      OUTA,tos        ' pulse high
L                       andn    OUTA,tos        ' low
                        or      DIRA,tos
                        jmp     unext

F                       andn    DIRA,tos
                        jmp     unext
TOGGLE                  xor     OUTA,tos
                        jmp     unext

AMASK                   'shr     tos,#5 wz,nr    ' test if valid 0..31 = z
                        mov     X,tos
                        mov     tos,#1
        'if_nz           mov     tos,#0
                        shl     tos,X
AMASK_ret               ret

{
' PIN! ( flg pin -- )
PINST                   call    #POPX
                        mov     R0,tos
                        mov     tos,X
                        tjnz    R0,#HIGH
}

' LOW ( pin -- ) Output a low on pin and set as an output
LOW                     call    #AMASK
' OUTCLR ( iomask -- ) Clear multiple bits on the output
OUTCLR                  andn    OUTA,tos
                        jmp     #OUTPUTS

' HIGH ( pin -- ) Output a high on pin and set as an output
HIGH                    call    #AMASK
' OUTSET ( iomask -- ) Set multiple bits on the output
OUTSET                  or      OUTA,tos
 ' OUTPUTS ( iomask -- ) Set selected port pins to outputs
OUTPUTS                 or      DIRA,tos
                        jmp     #DROP
' FLOAT ( pin -- )
FLOATPIN                call    #AMASK
' INPUTS ( iomask -- ) Set selected port pins to inputs
INPUTS                  andn    DIRA,tos
                        jmp     #DROP

' PIN@ ( pin -- dat )
RDPIN                   call    #AMASK
' IN ( mask -- dat )
IN                      mov     x,tos
                        mov     tos,ina
                        and     tos,x wz
             if_nz      or      tos,allones             ' convert non-zero to true flag
                        jmp     unext

{
' INA COG@ phaseA SHR 3 AND
' PINS@ ( pin mask -- dat )
                        mov     X,ina
                        shr     X,tos+1
                        and     X,tos
                        mov     tos+1,X
                        jmp     #DROP
}

' WAITPEQ               Wait until input is high - REG4 = mask, REG2 = CNT
_WAITPEQ
                        waitpeq REG4,REG4
                        mov     REG2,cnt                ' capture count in REG2
                        jmp     unext


' WAITPNE       Wait until input is low - REG4 = mask, REG1 = CNT
_WAITPNE
                        waitpne REG4,REG4               ' use REG4 as the mask
                        mov     REG1,cnt                ' capture count in REG2
                        jmp     unext




              { *** SERIAL I/O OPERATORS *** }
{
To maximize the speed of I/O operations especially serial I/O such as ASYNCH, I2C and SPI etc there are special
operators that avoid pushing and popping the stack and instead perform the I/O bit by bit and leave the
latest shifted version of the data on the stack.
}

' SHIFT from INPUT - Assembles with last bit received as msb - needs SHR to right justify if asynch data
' SHRINP ( iomask dat -- iomask dat/2 )
SHRINP                  'andn   DIRA,tos+1
                        test    tos+1,INA wc
                        rcr     tos,#1
                        jmp     unext


{ SHIFT to OUT -
This is optimized for when you are sending out multiple bits as in asynchronous serial data or I2C
Shift data one bit right into output via iomask - leave mask & shifted data on stack (looping)
400ns execution time including bytecode read and execute  or 200ns/bit with REPS }
' SHROUT ( iomask dat -- iomask dat/2 )
SHROUT                  shr     tos,#1 wc               ' Shift right and get lsb
                        muxc    OUTA,tos+1              ' reflect state to output
                        jmp     unext



' I2C support
' CLKOUT ( iomask dat -- iomask dat2 ) REG6=iomask ) Shift msb bit out,  clock high, clock low
CLKOUT                  andn    OUTA,tos+1              ' ensure output will be active low
                        andn    OUTA,clockpins
                        shl     tos,#1 wc
                        muxnc   DIRA,tos+1             ' make it an output if it is a low else float
' CLOCK ( REG6=iomask ) Toggle multiple bits on the output)
CLOCK                   xor     OUTA,clockpins
                        tjz    clkdly,unext
                        mov     X,clkdly
                        djnz    X,$
                        jmp     unext

' CLKOUT ( iomask dat -- iomask dat2 ) REG6=iomask ) Shift msb bit out,  clock high, clock low
CLKIN                   andn    DIRA,tos+1
                        test    tos+1,INA wc
                        rcl     tos,#1
                        jmp     #CLOCK


{ *** SPI *** }
' SPI INSTRUCTIONS
{HELP SPIWR ( data -- data2 )
Simple fast, bare-bones SPI - transmits 8 bits MSB first
- data must be left justified - data is not discarded but rotated by number of shift operations used
- spicnt is normally zero after the last shift so some ops just add to zero to save a long or two.
Usage: $1234 SPIWR16 'transmit 16 bits
SPIWR ( data -- data<<8 ) send the MSByte
SPIWRB ( data -- data<<8 ) send the LSByte
SPIWR16 ( data -- data<<16 ) send the LSWord
SPIWRX permits variable number of bits if spicnt is set directly with @SPICNT COG! and those bits are shifted to MSBit before
}
SPIWR16                 rol     tos,#24                 '
                        mov     spicnt,#8               ' force a 16-bit transfer
SPIWRB                  rol     tos,#24                 ' left justify and write byte to SPI (2.8us)
SPIWR                   add     spicnt,#8               ' code execution time of 2.25us + overhead
SPIWRX                  andn    outa,spice              ' always activate the chip enable (saves time in HL)
                        rol     tos,#1 wc               ' assume msb first (140208 update now rotates)
SPIwrlp                 muxc    OUTA,spiout             ' send next bit of data out
                        xor     OUTA,spisck             ' toggle clock
                        rol     tos,#1 wc               ' (no room) 160608 inserts rol here to spread clock width at same rate
                        xor     OUTA,spisck             ' toggle clock
                        djnz    spicnt,#SPIwrlp
                        ror     tos,#1                  ' reset it
                        jmp     unext

' Receive data and shift into existing stack parameter
' If MOSI needs to be in a certain state then this should be set beforehand
' Clock will simply pulse from it's starting state - normally low
' Useage:  0 SPIRD SPIRD SPIRD SPIRD                    ' read 32-bits as one long
' SPIRD ( data -- data<<8 )                             ' 2.8us
SPIRD                   mov     spicnt,#8               ' always read back 8-bits
SPIRDX                  andn    outa,spice              ' always activate the chip enable (saves time in HL)
SPIrdlp                 xor     OUTA,spisck             ' toggle clock
                        test    spiinp,INA wc           ' read data from device
                        rcl     tos,#1
                        xor     OUTA,spisck             ' toggle clock
                        djnz    spicnt,#SPIrdlp
                        jmp     unext

' SPICE
_SPICE                  or      outa,spice              ' release chip enable
                        jmp    unext
{
' SPIRDBLK ( dst cnt 0 -- )
SPIRDBLK                mov     spicnt,#32
                        calL    #SPIRDX
}

              { *** COUNTED LOOPS *** }
{
Each counted loop has four registers per level
_from   loop index
_for    loop count
_by     loop step
_next   loop branch
}

_from                   long    0               ' loop index
_by                     long    1               ' loop step
_for                    long    1               ' loop count
_next                   long    0               ' loop branch
_from2                  long    0
_by2                    long    1
_fromj                  long    0                ' keep copy of second loop index in register for easy access as J

'lpdepth                 long    0

' I ( -- index ) The current loop index is at a fixed address just under the loop limit at top of an ascending loop stack
I                       mov     X,_from
                        jmp     #PUSHX
' FROM ( index -- )
FROMS                   mov     _from2,tos
                        jmp     #DROP
' BY ( steps -- )
BY                      mov     _by2,tos
                        jmp     #DROP

' ADO ( from cnt -- )
ADO                     mov     _from2,tos+1
                        mov     tos+1,tos
                        call    #POPX
' FOR ( cnt -- )
FOR                     min     tos,#1                  ' force a count of 0 to only execute once (otherwise 4 billion!)
                        mov     _fromj,_from            ' maintain a register for J
                        wrlong  _next,lpsp              ' stack previous NEXT branch
                        add     lpsp,#4
                        mov     _next,IP                ' this is the address to loop to
                        wrlong  _for,lpsp               ' stack previous FOR
                        add     lpsp,#4
                        mov     _for,tos                ' Set FOR count
                        wrlong  _by,lpsp                ' stack previous BY
                        add     lpsp,#4
                        mov     _by,_by2                ' set BY
                        wrlong  _from,lpsp              ' set previous FROM
                        add     lpsp,#4
                        mov     _from,_from2            ' set FROM
                        mov     _by2,#1                 ' next default BY = 1 = loop index increment
                        mov     _from2,#0               ' next default FROM = 0 = loop index
                        jmp     #DROP

' +NEXT
PLNEXT
                        call    #POPX
                        mov     _by,X
' NEXT
forNEXT
LOOP                    add     _from,_by               ' increment index by loop increment
                        djnz    _for,#BRANCH            ' loop for cnt times (regardless of increment)
EXITNEXT                sub     lpsp,#4
                        rdlong  _from,lpsp
                        sub     lpsp,#4
                        rdlong  _by,lpsp
                        sub     lpsp,#4
                        rdlong  _for,lpsp
                        sub     lpsp,#4
                        rdlong  _next,lpsp
                        sub     lpsp,#4                 ' special read and restore to maintain J index
                        rdlong  _fromj,lpsp
                        add     lpsp,#4
                        jmp     unext
'
BRANCH                  mov     IP,_next
                        jmp     unext





' ACALL ( adr -- ) Call arbitrary address (from the stack) - executes user vectors
ACALL                   call    #SAVEIP                 ' save current IP onto return stack
AJMP                    mov     IP,tos                  ' jump to address on top of the data stack
                        jmp     #DROP


              { *** CONSOLE SERIAL OUTPUT *** }

' Transmit the character that is in the tos register. The output direction is preset (to save cog space)
' (EMIT) ( data -- )
pEMIT
                        and     tos,#$0FF       ' data controls loop so trim to 8-bits
                        add     tos,#$100 wc    ' add a stop bit (carry = start bit)
pEMITX                  or      dira,txmask     ' make sure it's an output
                        mov     R0,cnt
                        add     R0,txticks
txbit                   muxc    outa,txmask     ' output bit
                        shr     tos,#1 wz,wc    ' lsb first
                        waitcnt R0,txticks      ' bit timing
        if_nz_or_c      jmp     #txbit          ' next bit (stop bit: z & c)
'''                     andn    dira,txmask     ' leave it to be pulled up so another cog can also use it
                        jmp     #DROP

              { *** PASM MODULE LOADER *** }

{
>16 longs are reserved for a selectable module as a helper for specialized functions such as SPI etc.
LOADMOD loads the longs into this area to be executed with RUNMOD
}
' LOADMOD ( src dst cnt -- ) Load a PASM module of loadsz into the cog
LOADMOD
                        movd    lcdst,tos+1     ' Init dst pointer - just loading a small module alongside Tachyon
ldmlp                   add     lcdst,dstinc    ' post-increment long destination (pipelined after rdlong)
lcdst                   rdlong  0_0,tos+2       ' read a long from hub ram into cog's destination
                        add     tos+2,#4        ' increment hub memory long address
                        djnz    tos,#ldmlp
                        jmp     #DROP3
{
' DELTA ( delta -- )    Calculate and set the cnt delta and waitcnt
DELTA                   call    #POPX
                        mov     deltaR,X        ' use otherwise unused video reg for delta
                        mov     cnt,X           ' (kernel isn't doing any video)
                        add     cnt,cnt
}
' WAITCNT ( -- )
WAITCNTS                waitcnt cnt,deltaR      ' continue from last count (must be called before target is reached)
                        jmp     unext


{
' temporary timing instructions
' Capture the current cnt value and calulate cycles since last LAP - result in lapcnt
' LAP ( --  ) delta in lapcnt (created independant regs rather than REG4,4)
LAP                     neg     lapcnt,target           '  -old
                        mov     target,cnt              ' new
                        add     lapcnt,target           ' new-old
                        jmp     unext

}

'{
' LEN$ ( str -- len )
STRLEN
                        mov     X,tos
stlp                    rdbyte  R0,tos wz               ' check byte for null or anything >$7F
       if_nz            cmp     R0,#$7F wc
       if_c_and_nz      add     tos,#1
       if_c_and_nz      jmp     #stlp
                        sub     tos,X
                        jmp     unext
'}


              { *** COG ACCESS *** }


' COG@ ( addr -- long ) Fetch a long from cog memory
COGFETCH                movs    _readsrc,tos
                        nop
_readsrc                mov     tos,0_0
                        jmp     unext

' COG! ( long addr -- ) Store a long to cog memory
COGSTORE                movd    _writedst,tos
                        nop
_writedst               mov     0_0,tos+1
                        jmp     #DROP2





              { *** INTERNAL STACKS *** }

{
As well as the data and return stack, a loop and branch stack is also employed
The return stack should normally only used for return addresses
A separate loop stack means that loop indicies can still be accessed in a called function
The branch stack speeds up loops by having the current loop address available without having to read an offset and calculate
The data stack is accessed as 4 fixed registers with an non-addressed overflow stack in hub RAM.
}


'                        '
'              { *** DATA STACK HANDLER *** }
'                        '
POPX
                        mov     X,tos                   ' copy old tos into X
                        tjz     udepth,#POPX_ret        ' do not allow ext stack to pop past bottom
                        sub     udepth,#1 wz
                        mov     tos,tos+1
                        mov     tos+1,tos+2
                        mov     tos+2,tos+3
                        sub     stkpop,#1
                        sub     stkpsh,dstinc
stkpop                  mov     tos+3,datastk
POPX_ret                ret





{ *** RETURN STACK HANDLER *** }
{
Return stack builds up in cog memory
Return stack items do not need to be directly addressed
This indexed method does not use movd and movs methods but directly inc/decs the
source and destination fields of the instruction.(retstk) so it must stay synchronized - Use !RP if needed
}

' !RP
InitRP                  movs    _rprd_,#retstk
                        movd    _rpwr_,#retstk
                        jmp     unext

{HELP >R ( n -- ) Push n onto the return stack }
PUSHR                   mov     R0,tos
                        call    #_PUSHR
                        jmp     #DROP

{HELP R> ( -- n ) Pop n from the return stack }
RPOP                    call    #RPOPX                  ' Pop return stack into R and X
                        jmp     #PUSHX                  ' Push X onto the data stack as tos

SAVEIP                  mov     R0,IP
_PUSHR
_rpwr_                  mov     retstk,R0       ' save it on the stack (dest modified)
                        add     _rprd_,#1      ' update source for popping
                        add     _PUSHR,dstinc   ' update dest for pushing (points to next free)
SAVEIP_ret                      '
_PUSHR_ret              ret


RPOPX                   sub     _rprd_,#1      ' decrement rpop's source field
                        sub     _rpwr_,dstinc
_rprd_                  mov     X,retstk
RPOPX_ret               ret


dstinc        long $200       ' instruction's destination field increment value



{ *** COG VARIABLES *** }




lapcnt          res 1
target          res 1


IP              res 1                  ' Instruction pointer
ACC             res 1                  ' Accumulator for inline byte-aligned literals
X               res 1                  ' primary internal working registers
R0              res 1
R1              res 1
R2              res 1
udepth          res 1                  ' depth long index - points to top of overflow in hub ram

' *** STACKS ***
tos             res 4               ' fixed stack registers - top 4 items
datastk         res datsz           ' the top four items are fixed, the rest work as a regular up stack3
retstk          res retsz



'RUNMOD
_RUNMOD_        ' this is a dummy symbol but the org must be equal to _RUNMOD (or less)
                res     loadsz


                fit 496

' define some constants used by this cog
' The RUNMOD parameters are defined here so that the method can be changed easily


                org REG1
sck             res 1
mosi            res 1
miso            res 1
scs             res 1
'scnt            res 1

                org REG1
                res 3
pixshift        res 1
pixeladr        res 1

endofkernel     res 0   ' just a branch to identify the end of the kernel in the listing (BST)
                res 0
                res 0
                res 0
                res 0



CON

deltaR  = $1FF

loadparPtr = $140 'loadpars+registers

{ Boot-time Spin startup - launches Tachyon into all the remaining cogs and starts serial receive into cog 1 }

PUB Start
'   rxticks := txticks := clkfreq / baudrate             ' Force VM transmit routine to correct baud
   coginit(1,@ConsoleRx, 0)                             ' Load serial receiver into cog 1
 '  bytefill(@tasks,0,64)                               ' ensure idle tasks do not run "garbage"
  repeat 6                                              ' cogs 2..7 loaded with Tachyon and IDLE loop
        cognew(@RESET, @IDLE_reset)
  coginit(3,@loader, loadparPtr)
  coginit(0,@RESET, @TERMINAL_reset)                    ' finally replace this cog 0 loaded with Tachyon main terminal loop




